

' OPENGL / WINDOWS API


' 01:58 17/10/2010
' Charles Pegge


  #basic
  #include "minwin.inc"
  #include "StringUtil.inc"

  /*

  Window size wWidth wHeight
  Active view:
    0 = none
    1 = upper left
    2 = upper right
    3 = lower left
    4 = lower right

  */
   


  #define WINGDIAPI
  #define APIENTRY
  #define const
  typedef word wchar_t
  typedef sys ptrdiff_t
  includepath +"glo2/"
  library "opengl32.dll"
  include once "gl/gl.h"
  'include once "gl/glext.h"
  library "glu32.dll"
  include once "gl/glu.h"
  include once "gl/thinbasic_wgl.inc"
  library ""
  


  '=============
  'SCENE GLOBALS
  '=============

  dim a


  dim gmf(256) AS GLYPHMETRICSFLOAT

  dim as quad
    '
    'TIMING
    '
    grtic1,grtic2,grtic3,grfreq
    
  dim as double fps,grlap,agr,aspect
  
  '
  'STATE VARIABLES
  '
  dim as sys refresh,bselect,keyt,keyc,keyd,ReqShutDown,
  bLeft,bMid,bRight,bWheel,ldblclk,
  wWidth,wHeight,viewmode=3,togsp,projmode,listr,objectr
  '
  'GL CONTEXT
  '
  dim as sys hDC,hRC,
  shadows,shadowable,
  antialias, multisampling,
  nPixelFormat,ReqNewMode,arbMultisampleFormat,
  arbMultisampleSupported,
  '
  drawing_list,
  '
  'TIMING
  '
  timerval, doredraw,
  '
  'POSITIONAL
  '
  iposX, iposY, sposX,sposY,mposX,mposY,eposX,eposY,
  '
  'Rotation around each axis
  '
  rot_x, rot_y, rot_z,
  active_view



  single tra_x, tra_y, tra_z 'OBJECT VIEW TRANSLATION
  single sca_a=1 'OBJECT VIEW SCALE
  single orthosize=3.0


  dim keys(256) as long 'keys up/down states

  'dim mapref(16) as long

  'dim cameraProjectionMatrix(16) as single
  dim as double modelview(16), projection(16)

  QueryPerformanceFrequency & grfreq

  dim as sys isNewView=1,acte




  '---------------------
  sub StandardMaterial()
  '=====================
  local as single,
  
  surface_diffuse(4)  => (1.0, 0.8, 0.0, 1.0),
  surface_specular(4) => (0.0, 0.0, .5, 0.5),
  surface_shininess=0.1
  '
  'Set model color (used for orthogonal views, lighting disabled)
  '---------------
  '
  glColor4fv surface_diffuse

  'Set model material (used for perspective view, lighting enabled)
  '------------------
'
  glMaterialfv GL_FRONT, GL_DIFFUSE,   surface_diffuse
  glMaterialfv GL_FRONT, GL_SPECULAR,  surface_specular
  glMaterialf  GL_FRONT, GL_SHININESS, surface_shininess
  end sub



'=======================================================

DrawingObjects 'MACRO code for creating drawing objects

'=======================================================




'-------------
sub Lighting()
'=============
  '
  static as single, 
  light_position(4) => (LightPosition, 1.0),
  light_diffuse (4) => (LightDiffuse, 1.0),
  light_specular(4) => (LightSpecular, 1.0),
  light_ambient (4) => (LightAmbient, 1.0)
  glPolygonMode GL_FRONT_AND_BACK, GL_FILL

  'Configure and enable light source 1
  '
  glLightfv GL_LIGHT1, GL_POSITION, light_position
  glLightfv GL_LIGHT1, GL_AMBIENT,  light_ambient
  glLightfv GL_LIGHT1, GL_DIFFUSE,  light_diffuse
  glLightfv GL_LIGHT1, GL_SPECULAR, light_specular
  '
  glEnable GL_LIGHT1
  '
end sub


  include "OpenglUtil.inc"



' DrawBorder() - Draw a 2D border (used for orthogonal views)
'
'---------------------------------------------------
sub DrawBorder( byval gscale as single, st as long )
'===================================================
  dim as single x,y
  glPushMatrix

  'Setup modelview matrix (flat XY view)
  '
  glLoadIdentity
  gluLookAt,  
  0.0, 0.0, 1.0, 
  0.0, 0.0, 0.0,
  0.0, 1.0, 0.0
  'We don't want to update the Z-buffer
  '
  glDepthMask GL_FALSE

  'Set color
  '---------
  glDisable GL_LIGHTING
  glColor3f 0.7, 0.7, 0.4
  glBegin GL_LINES

  dim h as long
  h=st*0.5
  x = gscale * h
  y = gscale * h
    
  'Horizontal lines
  '----------------
  
  glVertex3f -x, -y, 0.0
  glVertex3f  x, -y, 0.0
  glVertex3f -x,  y, 0.0
  glVertex3f  x,  y, 0.0

  'Vertical lines
  
  glVertex3f -x, -y, 0.0
  glVertex3f -x,  y, 0.0
  glVertex3f  x, -y, 0.0
  glVertex3f  x,  y, 0.0

  glEnd

  'Enable Z-buffer writing again
  '
  glDepthMask GL_TRUE

  glPopMatrix
  
end sub



' DrawGrid() - Draw a 2D grid (used for orthogonal views)

'--------------------------------------------------------------
sub DrawGrid( BYVAL gscale AS SINGLE, BYVAL gsteps AS INTEGER )
'==============================================================

  dim as long i
  dim as single x,y

  glPushMatrix

  'Set background color
  '
  glClearColor 0.15, 0.15, 0.3, 0.0
  glClear GL_COLOR_BUFFER_BIT

  'Setup modelview matrix (flat XY view)
  '
  glLoadIdentity
  gluLookAt,
  0.0, 0.0, 1.0, 
  0.0, 0.0, 0.0,
  0.0, 1.0, 0.0
  '
  'We don't want to update the Z-buffer
  '
  glDepthMask GL_FALSE

  'Set grid color
    
  glDisable GL_LIGHTING
  glColor3f 0.0, 0.5, 0.5

  glBegin GL_LINES

  dim g,h as long

  g=gsteps
  h=g*0.5
    
  '' Horizontal lines
  
  x = gscale * h
  y = (-gscale) * h
  '
  for i = 0 to g
    glVertex3f -x, y, 0.0
    glVertex3f x, y, 0.0
    y+=gscale
  next

  '' Vertical lines
  
  x = -gscale * h
  y = gscale * h
  '
  for i = 0 to g
    glVertex3f x, -y, 0.0
    glVertex3f x, y, 0.0
    x+=gscale
  next

  glEnd

  'Enable Z-buffer writing again
  '
  glDepthMask GL_TRUE

  glPopMatrix
  
end sub



'--------------------------------------------------------------------------------------------
sub Draw3dView(l as sys, b as sys, w as sys, h as sys, x as double, y as double, z as double)
'============================================================================================

  'For perspective view, use solid rendering
  '

  glEnable GL_NORMALIZE
  glEnable GL_SCISSOR_TEST
  glEnable GL_DEPTH_TEST
  glDepthFunc GL_LEQUAL
  '
  'Enable face culling (faster rendering)
  '
  glEnable GL_CULL_FACE
  glCullFace GL_BACK
  glFrontFace GL_CW


  ;Setup perspective projection matrix
  ;
  projmode=0
  Setprojection projmode
  glEnable GL_LIGHTING
  Lighting()

  '
  glViewport  l, b, w, h
  glScissor   l, b, w, h
  'Upper right view (PERSPECTIVE VIEW
  '
  ViewFromHere x,y,z 'Eye-position
  '
  glDisable GL_LIGHTING
  glDisable GL_CULL_FACE
  glDisable GL_DEPTH_TEST
  glDisable GL_SCISSOR_TEST
  '
end sub


'--------------------------------------------------------------------------------------------
sub Draw2dView(l as sys, b as sys, w as sys, h as sys, x as double, y as double, z as double)
'============================================================================================
  '
  glEnable GL_SCISSOR_TEST
  glPolygonMode GL_FRONT_AND_BACK, GL_LINE

  'Enable line anti-aliasing
  '-------------------------
  '
  glEnable GL_LINE_SMOOTH
  glEnable GL_BLEND
  glBlendFunc GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA
  '
  'Setup orthogonal projection matrix
  '----------------------------------
  '
  projmode=1
  orthosize=3.0
  SetProjection projmode
  '
  glViewport l,b,w,h
  glScissor  l,b,w,h
  ViewFromHere 0, 0, 10 'Eye-position (in front of)
  glDisable GL_LINE_SMOOTH
  glDisable GL_BLEND
  glDisable GL_SCISSOR_TEST
  '
end sub


'-----------------
sub DrawAllViews()
'=================
  
  '
  '======================
  '** ORTHOGONAL VIEWS **
  '======================
  

  'For orthogonal views, use wireframe rendering
  '---------------------------------------------

  glEnable GL_SCISSOR_TEST

  'Enable line anti-aliasing
  '
  glEnable GL_LINE_SMOOTH
  glEnable GL_BLEND
  glBlendFunc GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA

  'Setup orthogonal projection matrix
  '
  '
  sys w=wwidth*0.5 , h=wheight*0.5
  '
  orthosize=3.0
  projmode=1
 
  'Upper left view (TOP VIEW)
  '--------------------------
  '
  SetProjection projmode
  glViewport 0,h,w,h
  glScissor  0,h,w,h
  glPolygonMode GL_FRONT_AND_BACK, GL_LINE
  DrawGrid 0.4,12
  if active_view=1 then DrawBorder 0.45,12
  ViewFromHere 0, 10, 0.1 'Eye-position (above)

  'Lower left view (FRONT VIEW)
  '----------------------------
  '
  SetProjection projmode
  glViewport 0,0,w,h
  glScissor  0,0,w,h
  glPolygonMode GL_FRONT_AND_BACK, GL_LINE
  DrawGrid 0.4, 12
  if active_view=3 then DrawBorder 0.45,12
  ViewFromHere 0, 0, 10 'Eye-position (in front of)

  'Lower right view (SIDE VIEW)
  '----------------------------
  '
  SetProjection projmode
  glViewport w,0,w,h
  glScissor  w,0,w,h
  glPolygonMode GL_FRONT_AND_BACK, GL_LINE
  DrawGrid 0.4, 12
  if active_view=4 then DrawBorder 0.45,12
  ViewFromHere 10, 0, 0 'Eye-position (to the right)
  

  ;Disable line anti-aliasing
  ;
  glDisable GL_LINE_SMOOTH
  glDisable GL_BLEND
  glDisable GL_SCISSOR_TEST


  ;======================
  ;** PERSPECTIVE VIEW **
  ;======================
  '
  'top right Corner
  '
  Draw3dView w,h,w,h, 0.0, 0.0, 6.0
  '
end sub


'---------------------------------------
sub next_frame()  ' construct each frame
'=======================================
                                              '
  static sys signal = 0
  static single s1,s2,s3
  '
  ' timing
  '-------

  QueryPerformanceCounter &grtic2
  grlap=1e3*(grtic2-grtic1)/grfreq
  'grlap=1e3*(grtic3-grtic1)/grfreq 'frame processing time
  grtic1=grtic2
  agr=0.9*agr+.005*grlap 'rolling average grlap/

  ' 
  ;
  'Calculate aspect of window
  '--------------------------
  ;
  if wheight > 0
    aspect = wwidth / wheight
  else
    aspect = 1.0
  end if
  '
  'Intialise next frame and select the view
  '----------------------------------------
  '
  glClearColor 0.1, 0, 0.5, 0
  glClear GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT
  '
  '--------
  'backdrop
  '========
  '

  s1=50
  s2=-100
  s3=0.5
  s4=s3*.2
  glbegin GL_QUADS
  glcolor4f   s4,   0,  s3, 1
  glvertex3f -s1, -s1,  s2
  glcolor4f    0,  s4,  s3, 1
  glvertex3f -s1,  s1,  s2
  glcolor4f   s4,   0,  s3, 1
  glvertex3f  s1,  s1,  s2
  glcolor4f    0,   0,  s3, 1
  glvertex3f  s1, -s1,  s2
  glend
  '

  objectr=1 : listr=0
  select case viewmode
  case 2 : Draw2dView 0,0,wwidth,wheight, 0.0, 0.0, 6.0
  case 3 : Draw3dView 0,0,wwidth,wheight, 0.0, 0.0, 6.0
  case 4 : DrawAllViews()
  case 5 : objectr=0 : listr=1 : Draw3dView 0,0,wwidth,wheight, 0.0, 0.0, 6.0 
  case 6 : objectr=1 : listr=1 : Draw3dView 0,0,wwidth,wheight, 0.0, 0.0, 6.0
  end select
  '
  '
  QueryPerformanceCounter &grtic3
  glFinish   ' wait until all operations complete
  SwapBuffers HDC
  '
xdo_frame:

end sub                                    '


'-------------------------
sub scheduled_activities()
'=========================
    '
    def sta 2
    def stm .02
    def sts 1.01
    '
    sys a
    '
    'KEYBOARD ACTION
    '===============
    '
    if keyd then
    '
    'keyboard action for all viewmodes
    '---------------------------------

    select keyd
    case 27  : ReqShutDown=1
    case 112 :                   'F1
    case 113 :                   'F2
    case 114 :                   'F3
    case 115 : viewmode=2        'F4 '1 port orthogonal wireframe
    case 116 : viewmode=3        'F5 '1 port perspective
    case 117 : viewmode=4        'F6 '4 port viewing
    case 118 : viewmode=5        'F7 'editing
    case 119 : viewmode=6        'F8 'mixed text and perspective
    end select
    '
    'for non editing modes
    '---------------------
    '
    if viewmode<>5 then
    select keyd
    case 38  : rot_x -=sta       'ARROW UP
    case 40  : rot_x +=sta       'ARROW DOWN
    case 37  : rot_y -=sta       'ARROW LEFT
    case 39  : rot_y +=sta       'ARROW RIGHT
    case 36  : tra_x -=stm/sca_a 'HOME
    case 35  : tra_x +=stm/sca_a 'END
    case 34  : tra_y -=stm/sca_a 'PG DOWN
    case 33  : tra_y +=stm/sca_a 'PG UP
    case 189 : SCa_a /=sts       '-
    case 187 : sca_a *=sts       '+
    case 120 : rot_x=0 : rot_y=0 : rot_z=0 : tra_x=0 : tra_y=0 : tra_z=0 : sca_a=1 'F0 reset
    end select
    end if

    end if 'keyd keydown
    '
    '
    'MOUSE ACTION
    '============
    '
    '
    if bleft=1 'LEFT BUTTON DOWN
      '
      'quantify mouse movement between timer intervals
      '
      mMovX=mPosX-iposX
      mMovY=mPosY-iposY
      iposX=mPosX
      iposY=mPosY
      '
      'Depending on which view was selected, rotate around different axes
      '
      if viewmode=4 then
        '
        'Detect which of the four views was clicked
        '
        active_view = 1
        if ( sposx >= wwidth\2 )
          active_view+=1
        end if
        if ( sposy <= wheight\2 )
          active_view = active_view + 2
        end if
      else
        active_view=15
      end if
      '
      'for non edit modes
      '------------------
      '
      if viewmode<>5 then
        '
        if keyd=77 'press M to move
          '
          tra_x +=0.2*mMovx*stm/sca_a
          tra_y +=0.2*mMovy*stm/sca_a
          '
        else 'otherwise rotate
        '
          select active_view
          case 1    : rot_x -= mMovY : rot_z += mMovX
          case 3    : rot_x -= mMovY : rot_y += mMovX
          case 4    : rot_y += mMovX : rot_z -= mMovY
          case else : rot_x -= mMovY : rot_y += mMovX
          end select
          '
        end if

      end if 'non edit
      '
    end if
    '
    if viewmode<>5 then 'not edit
      '
      'CHECK FOR OBJECT ANIMATION
      '==========================
      '
      if togsp<>0 then
        rot_y+=2
        if rot_y>=360 then rot_y-=360
      end if
      '
    end if 'non edit
    '
    '
    'DECIDE WHETHER TO PRODUCE NEW FRAME
    '
    sys act=bleft or keyd or togsp or isNewView or acte
    if act then
      next_frame()
    end if
    isNewView=0
    '
end sub



'---------------------------------------------------------------------------------
function WndProc (long hWnd, long wMsg, long wParam, long lparam) as long callback
'=================================================================================
  '
  '==========
  select wMsg
  '==========
  '
  '
  case WM_ACTIVATE    : if HIwrd(wParam)=0 then acte=0
  case WM_SETFOCUS    : acte=0
  case WM_KILLFOCUS   : acte=0
  '
  case WM_DESTROY     : goto termination
  case WM_TIMER       : scheduled_activities() : if ReqShutDown then goto termination
  case WM_ERASEBKGND  : function=1
  case WM_SIZE        : wWidth=lowrd lParam : wHeight=hiwrd lParam : isNewView=1 : scheduled_activities()
  '
  case WM_CHAR        : keyc=wParam ': print hex wparam
  case WM_KEYUP       : wParam and=255 : keys(wParam)=0 : keyd=0
  case WM_LBUTTONUP   : bLeft = 0 : ePosX=mPosX : ePosY=mPosy : active_view = 0 : exclu=0
  case WM_MBUTTONUP   : bMid = 0 : ePosX=mPosX : ePosY=mPosy
  case WM_RBUTTONUP   : bRight=0 : ePosX=mPosX : ePosY=mPosy
  case WM_MBUTTONDOWN : bMid=1 : sPosX=mPosX:sPosY=mPosy : bSelect or=2
  case WM_RBUTTONDOWN : bRight=  : sPosX=mPosX : sPosY=mPosY : bSelect or=2
  case WM_MOUSEWHEEL  : bWheel=HIwrd(wParam) : bselect=1

  case WM_KEYDOWN
  '============== 

    wParam and=255 : keys(wParam) = 1 : keyd=wParam : keyt=wParam
    if keyd=32 then
      if viewmode<>5 then togsp=1-togsp 'toggle state for SPACE key
    end if

  case WM_MOUSEMOVE
  '================

    bselect=bselect OR 1
    mPosX = LOwrd(lParam)
    mPosY = wheight-HIwrd(lParam) '0 is bottom left
    '
    a=abs(mposx-sposx)+abs(mposy-sposy)
    if a>3 then ldblclk=0 'to cancel double click
    '
    IsNewView=1



  case WM_LBUTTONDOWN
  '==================

    ldblclk+=1
    bLeft  = 1 : sPosX=mPosX : sPosY=mPosy : iposX=mposX : iposY=mposY
    bSelect or= 2
    doredraw = TRUE
    '
  case else
  '========

    function=DefWindowProc hWnd,wMsg,wParam,lParam

  '
  end select
  exit function 
  '
  '===========
  termination:
  '===========
  '
  KillTimer hWnd,1
  'CLOSE
  PostQuitMessage 0
  '
end function ' WndProc





'----------------------------------------------------------------------------
Function WinMain ( long inst, long prevInst, long cmdline, long show) as long
'============================================================================

  ; window handle
  
  dim a,b,c,hWnd,style as long
  dim wc as WndClass
  dim wm as MSG


  def WindowPosition CW_USEDEFAULT,CW_USEDEFAULT

  with wc.                 '
    style=CS_HREDRAW or CS_VREDRAW
    lpfnWndProc=&WndProc
    cbClsExtra=0
    cbWndExtra=0    
    hInstance=inst
    hIcon=LoadIcon 0, IDI_APPLICATION
    hCursor=LoadCursor 0,IDC_ARROW
    hbrBackground=GetStockObject WHITE_BRUSH '
    lpszMenuName=0
    lpszClassName=`Opengl`
  end with
  
  if not RegisterClass &wc
    MessageBox 0,`Registration failed`,`Problem`,MB_ICONERROR
    exit function
  end if                  '

  style=0 WS_OVERLAPPEDWINDOW 'WS_POPUP or WS_THICKFRAME  'WS_OVERLAPPEDWINDOW,

  hWnd=CreateWindowEx 0,wc.lpszClassName,WindowTitle,
  style,WindowPosition, CanvasSize,0,0,inst,0
      
  if not hWnd
    MessageBox 0,`Unable to create window`,`problem`,MB_ICONERROR
    exit function
  end if  
  
  hDC=GetDC(hWnd)
  PixelFormat(hDC,0)
  hRC = wglCreateContext(hDC)
  wglMakeCurrent hDC, hRC
  ReqNewMode=0 ' done
  BuildFont(hWnd,hDC,hRC)
  finit 'reinitialise fpu after npixelformat
  '
  '
  'Record the Drawings
  '-------------------
  '
  drawing_list = glGenLists drawings
  dec drawing_list 'adjust base
  '
  drawObjects 'MACRO TO BUILD DRAWING LISTS & gl COMPILE
  '
  '
  ShowWindow hWnd,show
  UpdateWindow hWnd
  '
  timerval=10 ' 20=nominally 1/50 sec
  SetTimer hWnd,1,timerval,NULL
  QueryPerformanceCounter &grtic1 'initial for lap measurement

  '
  '
  'MESSAGE LOOP
  '============
  '
  while GetMessage &wm,0,0,0
    TranslateMessage &wm
    DispatchMessage &wm
  wend
  '
  glDeleteLists drawing_list,drawings
  glDeleteLists 1000, 255 ' font
  '
  wglMakeCurrent hDC, NULL
  wglDeleteContext hRC
  ReleaseDC hWnd,hDC

  function=wm.wparam

  end function ' end of WinMain



  '=================
  main: 'entry point
  '=================

  dim cmdline,inst as long
  cmdline=GetCommandLine
  inst=GetModuleHandle 0
  WinMain (inst,0,cmdline,SW_NORMAL)
  '
  '
  '===================
  endprog: 'exit point
  '===================

  txt.free 'listing buffer
  freelibrary kernel32
  freelibrary user32
  freelibrary gdi32
  
