



'-------
'GLOBALS
'=======




long viewport[4]
sys ppx,ppy
sys focus,exclu

'======
'picker
'======


def SelectBufSize 4096

long pick=1, nearest=1
long selectbuf[SelectBufSize]
long SelLine, SelWord, SelObject, hits



'----------------
'LOAD SAMPLE TEXT
'================

TextArray txt 'Listing buffer
'
sys et=txt.load "openglview.inc"
'txt.save "s.txt"
'sys i,j
'if txt.locate "wndproc",i,j then print txt.line(i) cr cr  i  "  " j



  



'------------------------------
sub orthopersp(long p)
'==============================
  '
  single n=orthosize
  '
  if p then
    glOrtho  -n*aspect, n*aspect, -n, n, 1.0, 100.0 'left right bottom top near far
  else
    gluPerspective 45.0, aspect, 1, 100.0 'viewAngle,aspect,near,far
  end if
end sub
'
'--------------------
sub SetProjection(long p)
'====================
  glMatrixMode GL_PROJECTION
  glLoadIdentity
  orthopersp(p)
  glMatrixMode GL_MODELVIEW
  glLoadIdentity
end sub


'---------------
sub RenderView()
'===============

  glPushMatrix

  glscalef sca_a, sca_a, sca_a
  
  glTranslatef tra_x, tra_y, tra_z
 
  glRotatef rot_x, 1.0, 0.0, 0.0
  glRotatef rot_y, 0.0, 1.0, 0.0
  glRotatef rot_z, 0.0, 0.0, 1.0

    DeployObjects 'MACRO

  glPopMatrix

  '
end sub


'--------------------
sub PickPrep() as sys
'====================
  '
  glInitNames()
  glSelectBuffer (SelectBufSize, selectBuf)
  '
  glRenderMode(GL_SELECT)
  '
  glPushName(-1) 'an arbitrary value
  '
  glMatrixMode(GL_PROJECTION)
  glLoadIdentity()
  gluPickMatrix( mposx, mposy, 2.0, 2.0, & viewport) 'pixel selection zone
  orthopersp projmode
  glMatrixMode(GL_MODELVIEW)
  glpushmatrix
end sub



'---------------------------
function PickResult() as sys
'===========================
  '
  glPopName()
  hits=glRenderMode(GL_RENDER)
  '
  '--------------------
  'nearest named object
  '--------------------
  '
  sys v=0x7fffffff, w=-1, i=1, c=hits*4
  '
  while i<c
   '
   if nearest then
     if SelectBuf(i+1)<=v then
       v=SelectBuf(i+1)
       w=SelectBuf(i+3) 'resolve by depth order
     end if
   else
     if SelectBuf(i+3)>w then
       w=SelectBuf(i+3) 'resolve by name order
     end if
   end if
   '
   i+=SelectBuf(i)+3
   '
  wend
  '
  if w>=0 then SelObject=w
  '
  SetProjection projmode
  glPopMatrix
  '
  return w
  '
end function


'
'================
Class EditControl
'================

  'TEXT LOCATION (FILE .. CHARACTER)

  sys    CurLinePos 'current text line position in file 1..end
  sys    CurWordPos 'current selected word position in text line
  sys    CurCharPos 'current character position in text line (caret to the left of this char)
  string CurWord    'current selected word (highlighted wherever it appears on screen)

  'OBJECT

  sys    ido   'object identity number
  sys    ndis  'display refresh flag (new display)
  sys    oms   'flag for moving and scaling
  sys    lino  'flage to display line numbers
  sys    ofs   'line offset for first line on display
  sys    q     'how many lines to display

  'VIEWPORT (PIXEL) METRICS  

  sys    ewh   'edit window height
  sys    eww   'edit window width
  sys    ewx1  'coord
  sys    ewx2  'coord
  sys    ewy1  'coord
  sys    ewy2  'coord


  'SPATIAL METRICS

  single d     'size of character (font)
  single spd   'micro-scrolling speed factor
  single scrll 'scroller line displacement (vertical)
  single xscrl 'scroller line displacement (horizontal)
  single xd    'displacement of the control from the eyeview centre
  single yd    'displacement of the object from the eyeview centre
  single sclx  'x scale of the object
  single scly  'y scale of the object
  single oxd   'prior value of xd before a move (mouse drag)
  single oyd   'prior value of yd before a move (mouse drag)
  single osclx 'prior value of sclx before rescaling (mouse drag/pull)
  single oscly 'prior value of scly before rescaling (mouse drag/pull)
  sys onl      'prior value of q line count before rescaling (mouse drag/pull)



  '----------------------------------------------------------------------------------
  function RenderText(s as string, byval x as single, y as single, byval d as single)
  '==================================================================================
  '
  if not len s then exit sub
  glPushAttrib GL_LIST_BIT
  glPushMatrix
  glLoadIdentity
  glListBase 1000
  glTranslatef x, y, -1
  glscalef d, d*.75, 0.01
  glpushMatrix
  glCallLists LEN(s), GL_UNSIGNED_BYTE, byval *s
  glPopMatrix
  glPopMatrix
  glPopAttrib
  end function


  '----------------------------------------------------------------------------------------------
  function PutBoxArea(byval x as single, byval y as single, byval w as single, byval h as single)
  '==============================================================================================
  '
  glPushMatrix
  glLoadIdentity
  gltranslatef x,y,-1.0
  glbegin GL_QUADS
  'clockwise
  glvertex3f 0, 0, 0
  glvertex3f 0, h, 0
  glvertex3f w, h, 0
  glvertex3f w, 0, 0
  glend
  glpopmatrix
  end function


  '----------------------------------------------------------
  function GetWordArea(s as string, x as single, y as single)
  '==========================================================
  /*
  TYPE POINTFLOAT
    x AS SINGLE
    y AS SINGLE
  END TYPE
  '
  TYPE GLYPHMETRICSFLOAT
    gmfBlackBoxX AS SINGLE
    gmfBlackBoxY AS SINGLE
    gmfptGlyphOrigin AS POINTFLOAT
    gmfCellIncX AS SINGLE
    gmfCellIncY AS SINGLE
  END TYPE
  */
  indexbase 0
  x=0 : y=gmf[77].gmfCellIncY
  sys a,b,e=len s
  for b=1 to e
    a=asc(s,b)
    x+=gmf[a].gmfCellIncX
    'x-=gmf[a].gmfptGlyphOrigin.x
    'x+=gmf[a].gmfBlackBoxX
  next
  end function



  '---------------------
  method RenderListing()
  '=====================
  '
  '
  '
  'transient variables
  '-------------------
  '
  static sys    a,c,e,f,i,j,n,p,gn,mpx,mpy,dpx,dpy
  static single xp,yp,scv,gf,gfy,v,b,alf,xtxt,ytxt,vpr,rto,lmx
  static single s1,s2,s3,s4
  static string tx,tx1,tx2
  '
  static sys    txd[64]   'word/char position on line
  static single txc[256]  'word metrics x,y,w,h
  static single txo[256]  'char metrics x,y,w,h
  static string txa[64]   'words on line
  '
  static double clip_plane1[4],clip_plane2[4],clip_plane3[4],clip_plane4[4]
  '
  '
  v=0    'line y offset
  gn=0   'name counter
  '
  '
  '
  'initial values
  '-------------
  '
  if q=0 then setup 1,0,0,1,30
  '
  'adjust params
  '-------------
  '
  if ndis=0 then
    if isnewview then ndis=2
    'if bleft then ndis=2
  end if
  '
  if ndis then
    '
    vpr=0.414        'viewport: y ratio +/- vpr ewh
    d=vpr*2*scly/q   'scale size to number of lines in the display buffer
    '
    rto=viewport[4]*.5/vpr
    b=1/aspect 'y/x ratio 'aspect is wwidth/wheight
    '
    ewx1=viewport[3]*(1-sclx*b)*.5+viewport[1]+xd*rto
    ewy1=viewport[4]*(1-scly)*.5+viewport[2]+yd*rto
    eww= viewport[3]*sclx*b
    ewh= viewport[4]*scly
    ewx2=ewx1+eww
    ewy2=ewy1+ewh
    '
    '
    '
    '
    if ofs<0 then ofs=0
    if ndis<2 then scrll=0
    ndis=0
  end if
  '
  mpx=mposx-ewx1 'mouse x position within control (left)
  mpy=mposy-ewy1 'mouse y position withing control (bottom)
  '
  if bleft then
    if (mpx>0)and(mpx<eww) then
      if (mpy>0)and(mpy<ewh) then
        if exclu=0 then focus=ido : exclu=ido 'claim focus
      end if
    end if
  end if
  '
  '--------------------
  'backgound and border
  '====================
  '
  if pick=0 then

    s1=-2 : s2=-1 : s3=0.6 : s4=s3*.2
    '
    glpushmatrix
    gltranslatef xd,yd,0
    glscalef sclx,scly,1

    clip_plane1=>1.0,  0.0,  0.0, vpr  'clip left
    clip_plane2=>-1.0, 0.0,  0.0, vpr  'clip right
    clip_plane3=>0.0,  1.0,  0.0, vpr  'clip below
    clip_plane4=>0.0,  -1.0, 0.0, vpr  'clip above
    glClipPlane(GL_CLIP_PLANE1,clip_plane1)
    glClipPlane(GL_CLIP_PLANE2,clip_plane2)     
    glClipPlane(GL_CLIP_PLANE3,clip_plane3)
    glClipPlane(GL_CLIP_PLANE4,clip_plane4)
    glEnable GL_CLIP_PLANE1
    glEnable GL_CLIP_PLANE2
    glEnable GL_CLIP_PLANE3
    glEnable GL_CLIP_PLANE4

    'background
    '----------
    '
    glbegin GL_QUADS
    glcolor4f   s4,  s4,  s3, .7
    glvertex3f -s1, -s1,  s2
    glcolor4f   s4,  s4,  s3, .7
    glvertex3f -s1,  s1,  s2
    glcolor4f   s4,  s4,  s3, .7
    glvertex3f  s1,  s1,  s2
    glcolor4f   s4,  s4,  s3, .7
    glvertex3f  s1, -s1,  s2
    glend
    '
    glcolor4f   s3,   s3,  s3, 1
    '
/*
    s1=-vpr
    s2=-vpr
    s3=s1+vpr*2
    s4=s2+vpr*2
    '
    glbegin GL_LINE_STRIP
    glvertex3f s1, s2, -1
    glvertex3f s3, s2, -1
    glvertex3f s3, s4, -1
    glvertex3f s1, s4, -1
    glvertex3f s1, s2, -1
    glend
*/
    '
    glpopmatrix
    '
  end if
  '
  '-------------
  'DISPLAY LINES
  '=============
  '
  fl=1 : b=0 : lmx=0
  '
  '-------------------
  for i=q to 1 step -1
  '===================
    b=v+scrll
    v+=d
    j=i+ofs 'data ref
    if j=0 then jmp fwd ndispl
    if (b>0)and(b<1) then
      tx= txt.line(j)
      'if focus=ido then
      'if len tx then
        '
        'display line
        '------------
        '
        xp=xd-vpr*sclx
        yp=yd+b-vpr*scly
        alf=.5-abs(b-vpr) : alf+=alf : alf= sqr alf 'Fading
        '
        b=xp+xscrl
        '
        if lino then
          '
          'line numbers
          '------------
          '
          glColor4f 0.2,0.4,0.6,alf 'line number text color
          '
          tx1=str(j)+"  "
          GetWordArea tx1, gf,gfy
          RenderText tx1,b,yp,d
          gf*=d
          b+=gf          
          '
        end if
        '
        xtxt=b
        '
        glColor4f 0.7,0.7,0.6,alf 'regular text color
        GetWordArea tx,gf,gfy
        gf*=d 'scale
        '
        if pick then
          '
          if pick=1 then
            '
            'use box in place of text
            '
            glLoadname j
            PutBoxArea b,yp,gf+d*8,d 'extra width to pick empty lines
            '
          elseif pick=2
            '
            'only interested in the identified line
            '
            if SelLine=j then
              '
              CurLinePos=j : CurCharPos=0
              c=1 : e=len tx
              do
                if c>e then exit do
                if gn<64 then gn+=1 : glLoadname gn
                txd[gn]=c 'record position on line
                tx1=getword tx, c
                GetWordarea tx1, gf, gfy
                gf*=d
                PutBoxArea b,yp,gf,d
                '
                'record words on line and locations for syntax handling
                '
                txa[gn]=tx1          'store word
                txc[gn*4]=>b,yp,gf,d 'store area box
                b+=gf
                '
              end do
              '
            end if
          else 'if pick=3
            if SelLine=j then
              tx1=txa[SelWord] : a=SelWord*4
              b=txc[SelWord*4] 'word offset
              c=1 : e=len tx1
              do
                if c>e then exit do
                if gn<64 then gn+=1 : glLoadname gn
                tx2=mid tx1,c,1
                GetWordarea tx2, gf, gfy
                gf*=d
                PutBoxArea b,yp,gf,d
                '
                'record character box area on line
                '
                txo[gn*4]=>b,yp,gf,d 'store area box
                b+=gf : c+=1
              end do
            end if
          end if
          '
        else 'pick=0
          '
          '
          'syntax highlighting
          '-------------------
          '
          'comment detection
          '
          c=instr(tx,"'")
          e=instr(tx,";")
          if e then
            if c then
              if c>e then c=e
            else
              c=e
            end if
          end if
          '
          '
          'highlight selected word
          '
          if len CurWord then
            tx2=CurWord
            e=len tx2
            do
              a=instr(tx,tx2)
              if not a then exit do
              if c then
                if a>c then exit do 'do not apply to Basic comments
                c-=e
              end if
              tx1=left(tx,a-1)
              tx=mid(tx,a+e) : a=1
              GetWordArea(tx1,gf,gfy)
              if len tx1 then RenderText tx1,b,yp,d
              b+=gf*d
              GetWordArea(tx2,gf,gfy)
              gf*=d
              if gf>0 then
                glColor4f 0.0,0.7,0.7,.5 'background text color
                PutBoxArea b,yp,gf,d
                glColor4f 0.9,0.9,0.1,alf*.5 'highlight
                RenderText tx2,b,yp,d
              end if
              b+=gf
              glColor4f 0.6,0.7,0.6,alf 'standard
            end do
          end if
          '
          '
          'for Basic comments
          '
          if c>0 then a=instr(tx,"'") else a=0
          '
          if a then
            tx1=left(tx,a-1)
            tx=mid(tx,a)
            GetWordArea(tx1,gf,gfy)
            if len tx1 then RenderText tx1,b,yp,d
            b+=gf*d
            glColor4f 0.9,0.4,0.1,alf         
          end if
          '
          'main textline
          '
          if len tx then
            GetWordArea(tx1,gf,gfy)
            RenderText tx,b,yp,d
            b+=gf*d
          end if
          '
          if lmx<b then lmx=b
          '
          if hits then
            if SelLine=j then
              if SelWord then
                '
                'box matching word area
                '
                tx1=txa[SelWord] : a=SelWord*4
                '
                glColor4f 0.9,0.9,0.1,0.2 'background text color
                PutBoxArea txc[a],txc[a+1],txc[a+2],txc[a+3]
                glColor4f 0.9,0.9,0.1,alf 'highlight text color
                'glColor4f 0,0,0,1 'highlight text color
                RenderText tx1,txc[a],txc[a+1],txc[a+3]
                '
                'highlight character
                '
                a=SelObject*4
                glColor4f 0.9,0.9,0.7,0.2 'highlight char color
                PutBoxArea txo[a],txo[a+1],txo[a+2],txo[a+3]                
                '
                'record text info if left click
                '
                if ldblclk then
                  c=txd[SelWord]
                  CurLinePos=j : CurWordPos=c : CurCharPos=c+SelObject-1
                  if ldblclk=2 then CurWord=ltrim tx1
                end if
              end if
            end if
          end if 'hits
          '
          if CurLinePos=0 then CurLinePos=1
          '
          'caret placement
          '---------------
          '
          if CurLinePos=j then
            ytxt=yp
            b=xtxt
            if CurCharPos=0 then CurCharPos=txt.length(j)+1
            tx= txt.line(CurLinePos)
            tx1=left tx,CurCharPos-1
            GetWordArea tx1,gf,gfy
            gf*=d
            b+=gf
            glColor4f 0.9,0.9,0.1,alf 'caret color
            PutBoxArea b,yp, d*.125, d 'caret as rectangle
          end if 'caret
        end if
      'end if
    end if
    '
    '
    ndispl:
    '
  '-----
  next
  '=====
  '
  '
  if pick=0 then
    glDisable GL_CLIP_PLANE1
    glDisable GL_CLIP_PLANE2
    glDisable GL_CLIP_PLANE3
    glDisable GL_CLIP_PLANE4
  end if
  '
  '
  '----------------------------
  'SCALING AND MOVING
  '============================
  '
  '
  if bleft then
    '
    acte=1
    '
    '
    if focus<>ido then jmp fwd nscale
    '
    '
    if mpy>0.9*ewh then
      if mpy<ewh then
        '
        'ANCHOR ORIGINAL VALUES
        '
        if oms=0 then
          '
          onl=q : oxd=xd : oyd=yd
          '
          'LINE COUNT
          '
          if mpx>0.8*eww then
            oms=3
          '
          'MOVING
          '
          elseif mpx>0.4*eww then
            if mpx<0.8*eww then
              oms=4
           end if
          end if
        end if
      end if
    elseif mpy<.1*eww then
      '
      if oms=0 then osclx=sclx : oscly=scly : onl=q : oyx=dx : oyd=yd
      '
      'SCALING
      '
      if mpx>0.8*eww then
        oms=1
      elseif mpx>0.4*eww then
        if mpx<0.8*eww then
          oms=2
        end if
      end if
    end if
    '
    'DYNAMIC SCALING AND MOVING WITH MOUSE
    '
    if oms then
      '
      dpx=mposx-sposx
      dpy=mposy-sposy
      '
      if oms=1 then
        sclx=osclx+dpx*.0025 'X SCALING
        scly=oscly-dpy*.0025 'Y SCALING
        ndis=2
        exit method
      elseif oms=2 then       
        yd=oyd+dpy/rto 'MOVE Y
        scly=oscly-dpy*.0025 'Y SCALING
        q=onl*scly/oscly     'line count
        ndis=2
        exit method
      elseif oms=3 then 'LINE COUNT
        q=onl-dpy*.25
        ndis=1
        exit method
      elseif oms=4 then
        xd=oxd+dpx/rto 'MOVE X
        yd=oyd+dpy/rto 'MOVE Y
        ndis=2
        exit method
      end if
    end if
    '
  else 'LEFT BUTTON IS UP
    oms=0
  end if
  '
  nscale:

  '
  '
  if pick then
    glLoadName 0 'fence
    exit method 'no other action when picking
  end if
  '
  if focus<>ido then exit method
  '
  '--------
  'keyboard
  '========
  '
  '
  if keyt then
  if viewmode=5 then
    '
    c=CurLinePos
    a=txt.length(c)+1
    '
    select keyt
    case 38  : CurLinePos-=1     'ARROW UP
    case 40  : CurLinePos+=1     'ARROW DOWN
    case 37  : CurCharPos-=1     'ARROW LEFT
    case 39  : CurCharPos+=1     'ARROW RIGHT
    case 36  : CurCharPos=1      'HOME
    case 35  : CurCharPos=a      'END
    case 34  : CurLinePos+=q-2   'PG DOWN
    case 33  : CurLinePos-=(q-2) 'PG UP
    case 114 'F3
      if len(Curword) then
        e=CurLinePos
        f=CurCharPos
        txt.locate CurWord, e, f
        if e then
          CurlinePos=e : CurCharPos=f+len CurWord
          ofs=e-10
          if ofs<1 then ofs=0
          ndis=1
          keyt=0 : acte=1
          exit method
        end if
      end if
    end select
    '
    'Characters to insert (or delete)
    '--------------------------------
    '
    if keyc then
      tx=txt.line(CurLinePos)
     '
      if keyc=8 then 'BACKSPACE DELETION
        '
        if CurCharPos=1 then
          if CurLinePos>1 then
            CurLinePos-=1
            a=txt.length(CurLinePos)+1
            CurCharPos=a
            txt.line(CurLinePos)=txt.line(CurLinePos)+txt.line(CurLinePos+1)
            txt.delete(CurLinePos+1)
          end if
        else 'if CurCharPos>1 then
          CurCharPos-=1
          txt.line(CurLinePos)=left(tx,CurCharPos-1)+mid(tx,CurCharPos+1)
        end if
        '
      elseif keyc=13 then 'ENTER
        '
        tx1=txt.line(CurLinePos)
        txt.line(CurLinePos)=left tx1,CurCharPos-1
        CurLinePos+=1
        txt.insert(CurLinePos)="" 'itr
        txt.line(CurLinePos)=mid tx1,CurCharPos
        CurCharPos=1
        '
      else 'CHAR INSERT
        '
        txt.line(CurLinePos)=left(tx,CurCharPos-1)+chr(keyc)+mid(tx,CurCharPos)
        CurCharPos+=1 : a+=1
        '
      end if
    end if
    '
    keyc=0 'clear char
    keyt=0 'clear keydown transient
    acte=1 'refresh screen
    '
    'limit checks
    '-----------
    '
    if CurCharPos<1 then
      if CurLinePos>1 then
        CurLinePos-=1
        CurCharPos=txt.length(CurLinePos)+1
      else
        CurCharPos=1
      end if
    elseif CurCharPos>a then
      if CurLinePos<et then
        CurCharPos=1
        CurLinePos+=1
      else
        CurCharPos=a
      end if
    end if
    '
    'if CurLinePos>et then CurLinePos=et 'could be 0
    if CurLinePos<1 then CurLinePos=1   'never less than 1
    '
    '
    'need screen buffer refresh for whole line scrolling?
    '----------------------------------------------------
    '
    e=0 : a=CurLinePos-c
    '
    if a<0 then
      if curlinepos<ofs+4 then e=-1
    elseif a then
      if curlinepos>ofs+30 then e=1
    end if
    '
    if e<0 then
      ofs+=a : ndis=1 'GO UP
      exit method
    elseif e>0 then 'GODOWN
      ofs+=a : ndis=1
      if ofs+a+q-5>et then ofs=et-q+5
      if ofs<0 then ofs=0
      exit method
    end if
    '
  end if 'Viewmode 5
  end if 'Keyboard

  '
  '-------------------------
  autoscroll: 'AUTOSCROLLING
  '=========================
  '
  '
  'AUTOSCROLL ZONE CONFINEMENT
  '---------------------------
  '
  if mpx<=0  then exit method
  if mpx>eww then exit method
  if mpy<=0  then exit method
  if mpy>ewh then exit method
  '
  if mpx>0.1*eww then jmp fwd nvscroll
  '
  'AUTOSCROLLING DOWN AND UP
  '-------------------------
  '
  if mpy<0.1*ewh then 'SCROLL DOWN
    if (ofs+q-5)<=et then
      acte=1
      scv=d*spd*(10*ewh-mpy*100)*agr/ewh
      scrll+=scv
      if scrll>=d then
        n=scrll/d 'quantise
        ndis=2
        for p=1 to n
          if (ofs+q-5)<=et then
            ofs+=1 : CurLinePos+=1
          end if
          if scrll>=d then scrll-=d
        next
      end if
    end if
  elseif mpy>0.9*ewh then 'SCROLL UP
    scv=d*spd*(mpy*100-ewh*90)*agr/ewh
    if ofs<=0 then
      scrll=0
    else
      acte=1
      scrll-=scv
      if scrll<0 then
        n=-scrll/d
        ndis=2
        for p=1 to n
          if ofs>0 then
            ofs-=1 : CurLinePos-=1
          end if
          if scrll<0 then scrll+=d
        next
      end if
    end if
  end if
  '
  '--------
  nvscroll:
  '--------
  '
  '----------------------------
  'AUTOSCROLLING RIGHT AND LEFT
  '============================
  '
  if mpY>0.2*ewh
    if mpY<0.8*ewh
      if mpx>eww*0.9 then xscrl-=spd*(mpx-eww*.9)/300 : acte=1 'scroll right
      if mpx<eww*0.1 then xscrl-=spd*(mpx-eww*.1)/300 : acte=1   'scroll left
      if xscrl>0 then xscrl=0 : acte=0                          ' left (margin) scrolling limit
      lmx=2*vpr*sclx
      'lmx+=(vpr*sclx+d-eww/rto)
      if lmx<0 then lmx=0
      if xscrl<-lmx then xscrl=-lmx : acte=0                    'right scrolling limit
    end if
  end if
  '
  '
end method


'------------
method listing()
'============
  '
  if pick then RenderListing() : exit sub
  '
  SetProjection(0)
  '
  glEnable GL_LINE_SMOOTH
  glDisable GL_LIGHTING
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) 'Enable Alpha Blending
  glEnable(GL_BLEND)                                'Enable Blending
  glAlphaFunc(GL_GREATER,0.1)                       'Set Alpha Testing
  glEnable(GL_ALPHA_TEST)                           'Enable Alpha Testing
  Lighting() 'also disables wireframe mode
  '
  RenderListing()
  '
  glDisable GL_ALPHA_TEST
  '
end method


'--------------
method picker()
'==============
  SelLine=0 : SelWord=0 : SelObject=0 
  if bleft then
    pick=1
    PickPrep() : Listing() : PickResult()
    if hits then
      if SelObject then
        SelLine=SelObject : SelObject=0 : pick=2
        PickPrep() : Listing() : PickResult()
        if SelObject then
          SelWord=SelObject : SelObject=0 : pick=3
          PickPrep : Listing() : PickResult()
        end if
      end if
    end if
  end if
  pick=0
end method


'-----------------------------------------------------------
method setup(sys id, single x, single y,  single sc, sys nl)
'===========================================================


  '
  'STANDARD SETTINGS
  '
  ido=1          'identity number
  sclx=1         'standard x scale
  scly=1         'standard x scale
  xd=0.0         'displacement from center
  yd=0.0         'displacement from center
  ofs=0          'text line offset
  q=30           'number of lines in display buffer
  spd=.0625      'scrolling speed factor
  lino=1         'line numbers
  '
  Curword="" : tx="" : tx1="" : tx2="" 'temp strings
  '
  ndis=1 'flag new display
  '
  'INPUTS
  '
  ido=id : xd=x : yd=y : sclx=sc : scly=sc : q=nl
  '
end method


'-----------
method enq()
'===========
  print recordof this
end method


'=====================
end class 'EditControl
'=====================

'#recordof editcontrol

EditControl ed1
EditControl ed2
ed1.setup 1,-0.1,-.2,0.4,30
ed2.setup 2,0.1,0.2,0.4,20
'ed1.enq


'------------------------------------------------------
sub ViewFromHere(x as double, y as double, z as double)
'======================================================
  sys b
  ppx=mposx
  ppy=mposy
  '
  'glMatrixMode GL_MODELVIEW
  glGetIntegerv(GL_VIEWPORT, viewport)
  glLoadIdentity
  gluLookAt,
  x,    y,   z,    'Eye Position
  0.0,  0.0, 0.0,  'Target View-point
  0.0,  1.0, 0.0   'Up-vector
  '
  if objectr then
    if pick then
      PickPrep
      RenderView()
      PickResult
    end if
    RenderView()
  end if
  '
  if listr then
    '
    b=pick
    pick=0 : hits=0 : acte=0
    '
    if hits=0 then
      ed1.picker
    end if
    '
    if hits=0 then
      ed2.picker
    end if
    '
    ed1.listing
    ed2.listing
    '
    pick=b : hits=0 'restore flag
    '
  end if
  '
end sub


'-------------------------------------------------
sub PixelFormat(byval hdc as long, choice as long)
'=================================================

  'setup pixel format


  dim pfd AS PIXELFORMATDESCRIPTOR
  '
  pfd.nSize           = SIZEOF PIXELFORMATDESCRIPTOR 'Size of UDT structure
  pfd.nVersion        = 1                            'Version. Always set to 1.
  pfd.dwFlags         = PFD_DRAW_TO_WINDOW OR _      'Support Window
                        PFD_SUPPORT_OPENGL OR _      'Support OpenGL
                        PFD_DOUBLEBUFFER             'Support Double Buffering
  pfd.iPixelType      = PFD_TYPE_RGBA                'Red, Green, Blue, & Alpha Mode
  pfd.cColorBits      = 32                           '32-Bit Color Mode
  pfd.cRedBits        = NULL                         'Ignore Color and Shift Bits...
  pfd.cRedShift       = NULL                         '...
  pfd.cGreenBits      = NULL                         '...
  pfd.cGreenShift     = NULL                         '...
  pfd.cBlueBits       = NULL                         '...
  pfd.cBlueShift      = NULL                         '...
  pfd.cAlphaBits      = NULL                         'No Alpha Buffer
  pfd.cAlphaShift     = NULL                         'Ignore Shift Bit.
  pfd.cAccumBits      = NULL                         'No Accumulation Buffer
  pfd.cAccumRedBits   = NULL                         'Ignore Accumulation Bits...
  pfd.cAccumGreenBits = NULL                         '...
  pfd.cAccumBlueBits  = NULL                         '...
  pfd.cAccumAlphaBits = NULL                         '... Good Cereal! ;)
  pfd.cDepthBits      = 16                           ' bits z-buffer depth 8 16 24
  pfd.cStencilBits    = 1                            'Stencil Buffer
  pfd.cAuxBuffers     = NULL                         'No Auxiliary Buffer
  pfd.iLayerType      = PFD_MAIN_PLANE               'Main Drawing Plane
  pfd.bReserved       = NULL                         'Reserved
  pfd.dwLayerMask     = NULL                         'Ignore Layer Masks...
  pfd.dwVisibleMask   = NULL                         '...
  pfd.dwDamageMask    = NULL                         '...
  '
  nPixelFormat = ChoosePixelFormat(hDC, &pfd) 'First without multisampling
  '
  '
  SetPixelFormat(hDC, nPixelFormat, &pfd)
  '
end sub


'------------------------------------------------------------------------
sub BuildFont (BYVAL hWnd AS LONG, BYVAL hDC AS LONG, BYVAL hRC AS LONG )
 '=======================================================================

    dim glFont       as LOGFONT
    dim glFontHandle as long
    '
    glFont.lfHeight         = 1                             'Height Of Font
    glFont.lfWeight         = FW_BOLD                       'Font Weight
    glFont.lfCharSet        = ANSI_CHARSET                  'Character Set Identifier
    glFont.lfOutPrecision   = OUT_TT_PRECIS                 'Output Precision
    glFont.lfClipPrecision  = CLIP_DEFAULT_PRECIS           'Clipping Precision
    glFont.lfQuality        = ANTIALIASED_QUALITY           'Output Quality
    glFont.lfPitchAndFamily = FF_DONTCARE OR DEFAULT_PITCH  'Family And Pitch
    copy0 &glFont.lfFaceName, "Lucida Console" ' "Consolas" ' "Courier New"    'Font Name
    '
    glFontHandle = CreateFontIndirect(& glFont)
    glFontHandle = SelectObject(hDC, glFontHandle)
    '
    wglUseFontOutlines (hDC, 0, 255, 1000, 0.0, 0.2, WGL_FONT_POLYGONS, & gmf)
    '
    DeleteObject(glFontHandle)
end sub

