
' Asmoshphere
' Charles E V Pegge
' 14:23 01/04/2008
' 22:47 15/04/2008 to SSE4
' 04:25 23/04/2008 fix hexadecimal literals. Local #variable overrides
' 03:44 30/04/2008 softcoding + hash lookup
' 12:59 19/09/2008 multi exit: exit 1 2 ..9 also jmp fwd
' 12:06 14/11/2008 correction to imul operands



'INTERPRET PROG CONTROL WORDS FOR JMP, CALL 

'--------------------------------------------------------------------------------------------
function jword(byref s as string ,byref st as sys, byref i as sys, byref lw as sys) as string
'============================================================================================
' eg:
'    jmp long repeat
'    jmp repeat
'    call label
    dim as sys a
    dim as string wd
    dim as double v
    i=st
    wd=word(s,i)
    '
    lw=1 'long by default
    '
    if wd="long" then lw=1:wd=word(s,i)
    if wd="short" then
      lw=0:wd=word(s,i)
      if wd="fwd" then
         lw=2
         wd=word(s,i)
      end if
    end if
    if wd="fwd" then
       lw=3
       wd=word(s,i)
    end if
    'if wd="#" then wd+=word(s,i)
    wordeval(s,swd,i) : v=dv
    if nan=0 then
        ' immediate
        if lw=1 then wd=hexl(dv): goto xitj
        if lw=0 then wd=hexb(v): goto xitj
    end if
    if wd="exit" then
        wd="x"
        a=ascn
        if (a>48)and(a<58) then lw=1:wd+=word(s,i): goto xitj ' multi exit
        if lw then wd+="l"
        goto xitj
    end if
    if wd="repeat" then 
        wd="r": if lw then wd+="l"
        goto xitj
    end if
    if lw=0 then wd="g "+wd: goto xitj
    if lw=1 then wd="gl "+wd: goto xitj
    if lw=2 then wd="gs "+wd: goto xitj
    if lw=3 then wd="gf "+wd: goto xitj
xitj:
    lw and=1 : function=" "+wd
    '
end function



'--------------------------------------------------------
function condi(byref wr as string, byref i as sys) as sys
'========================================================
  dim as sys m, v
  v=-1
  m=asc(wr,i)*256+asc(wr,i+1)
  select case m
    case &h7a00 : v=04 ' jz   je
    case &h6e7a : v=05 ' jnz  jne
    case &h6c00 : v=12 ' jl
    case &h6765 : v=13 ' jge
    case &h6c65 : v=14 ' jle
    case &h6700 : v=15 ' jg
    case &h6200 : v=02 ' jb    jc
    case &h6165 : v=03 ' jae   jnc
    case &h6265 : v=06 ' jbe
    case &h6100 : v=07 ' ja
    case &h6f00 : v=00 ' jo
    case &h6e6f : v=01 ' jno
    case &h7300 : v=08 ' js
    case &h6e73 : v=09 ' jns
    case &h7065 : v=10 ' jpe
    case &h706f : v=11 ' jpo
    case &h6300 : v=02 ' jc    jb
    case &h6e63 : v=03 ' jnc   jae
    case &h6500 : v=04 ' je     jz
    case &h6e65 : v=05 ' jne   jnz
  end select
  function=v
end function

'------------------------------------------------------
function rexcode(byref v as sys, byval w as sys) as sys
'======================================================
  dim as sys rex
  rex=&h40
  if v>=8 then v-=8 : rex or=1 
  if w=8 then rex or=8
  function=rex
end function


'----------------------------------------------
sub pfx66(byref pfx as string, byref lp as sys)
'==============================================
  if instr(pfx," 66")=0 then pfx=" 66"+pfx : lp+=1
end sub

'----------------------------------------------
function SegOverride(byref wd as string) as sys
'==============================================
  dim as sys k
  if wd="cs" then
    k=&h2e
  elseif wd="ss" then
    k=&h36
  elseif wd="ds" then
    k=&h3e
  elseif wd="es" then
    k=&h26
  elseif wd="fs" then
    k=&h64
  elseif wd="gs" then
    k=&h65
  end if
  function=k
end function


'---------------------------------------------
function Assemble(byref s as string) as string
'=============================================
'
' s    preprocessor source
' t    assembler output
' i    source index
' j    output index
' m    general match index
' n    general purpose
' v    general purpose
' w    general purpose
' a    ascii code
' b    general purpose
' c    encoding (in rg position)
' d    general purpose
' wd   word
' wr   word
' wt   word
' co   code
' nn   operand length (like wk)
' sb   shortform byte code
' l    general purpose length
' b0   main prefix code
' rex  rex prefix code or null
' b1   main instruction code
' b2   address mode code
' dn   3dnow postfix
' md   mod component
' rg   reg component
' rm   rm component
' di   direction component
' im   immediate encoding
' ic   immediate encoding (in rg postion)
' pn   operand encoding constraint flag
' sg   sign flag
' ws   word size encoding
' wk   register size as bytes (also specialised regs 129 130 131)
' wk1  first operand size (from wk)
' se   sign extension encoding/flag
' axdi eax direct shortform encoding
' axim eax immediate shortform encoding
' ima  supports immediate operand flag
' lw   length of operand bytes in relative jumps / calls
' flt  instruction  class: gpu/fpu/mmx/simd/other
' bs   fpu mem operand encoding
' pp   fpu stack operand encoding
' cp   fpu stack operand encoding
' ppf  fpu pop flag
' et   fpu extended number encoding (for 10 byte number formats)
' qt   fpu operand size flag 
' itf  fpu integer instruction
' ads  address offset string
' dss  data code string
' re   register identifier (mem)
' sc   sib scal 
' id   sib index
' ptf  pointer flag
' rtf  return instruction flag
' rmf  
' rsf  bitscan instruction flag
' dv   double precision number (wordval return)
' rgm  reg rm encoding
' gg   mmx granularity encoding
' pfx  prefic codes as string
' flot foating point literal flag
' ncm  no comment
' rip  RIP addressing (relative to instruction pointer)
' lnmk line marker
' w1   general purpose string

' ersl errors list
' flos float encoding string
' flot float flag

'SIGNALS:

' flt=0 genereal instruction
' flt=1 fpu instruction
' flt=2 mmx instruction
' flt=3 xmmx instruction
' flt=4 general instruction without di and ws additions
' pn=0  undefined
' pn=1  single operand
' pn=2  2 operands
' pn=3  2 operands - the first must be a register
' pn=4  2 operands - the first is an r/m, the second must be a register
' pn=5  2 operands -  the first must be a register
' pn=6  2 operands - the first must be a mem, not a register
' pn=7  1 operand  - must be a mem
' pn=8  undefined
' pn=9  undefined
' pn=10 3 operands - the third must be an 8 bit value eg some xmmx instructions
' pn=11 3 operands - the third must be an 8 bit value or the cl register eg: shld shrd
' pn=12 1 2 or 3 operands - specific to imul
' pn=13 1 or 2 operand bit shift shl ror etc
' pn=14 first reg is general purpose, second reg is xmmx, rg and rm octals are then swapped thus: md-rm-rg (PMOVMSKB)
' pn=15 r/m.xmm,imm8  (pextrb pextrw pextrd pextrq)

dim as sys i,j,k,m,n,v,w,a,b,c,d
dim as string wd,wr,wp,wt,co,pfx
dim as sys nn,sb,l,le
dim as sys b0,rex,b1,b2,dn,lp
dim as sys md,rg,rm,er,di,im,pn,sg,ws,wk,wk1,se
dim as sys axim,axdi
dim as sys ima,ic,lw
dim as sys flt,bs,pp,cp,ppf,et,qt,itf
dim as sys re,ds,sc,id,ptf,rtf,rmf,rsf,rgm,gg,flot,ncm,rip,fwd

dim as string ads,dss,lnmk,ersl,t,w1,flos


le=len(s) : a=le+1000
t=space(a)
mex=a*16

i=1
j=1
lct=1
ert=0
ers=""
b0=-1
b1=-1
b2=-1
dn=-1
lp=0

lbr=40:rbr=41:iq1=34:iq2=96:iq3=96:ct1=59:ct2=39 ' default symbols



'============
do 'MAIN LOOP
'============

    co=""
    b0=-1
    im=0
    di=0
    flt=0
    mct=0
    rsf=0
    pn=0
    flot=0
    rex=0
    rip=0
    fwd=0
    '
    'skip crlfs etc at beginning of line
    do
        if i>le then goto term
        a=asc(s,i)
        if a=10 then lct+=1
        if a=9 then a=32 ' tab
        if a=58 then a=13
        if a>32 then exit do
        i+=1
    loop
    bgl=i
    wr=word(s,i):a=ascw
    if a=0 then goto term


'VIEW MARKERS

    if a=35 then
      if wr="#view" then vwb=j
      if wr="#endv" then vwe=j+7
      continue do
    end if

    '--------
    'COMMENTS
    '========

    if isc(a) then ' ' ; comment
        'if ascn=35 then lnmk=wordahead(s,i)
        i=bgl: goto flush
    end if

    if wr="symbols" then
        co=" sy"+mid(s,i,8)
        symbols(s,i)
        goto addcode
    end if

    'if wr="align" then
    '    co=" !"+word(s,i): goto addcode
    'end if
    '


    if a=95 then
      '
      '------------------------
      'STACK POINTER ADJUSTMENT
      '========================
      '
      'uses sum of multiple adjustments
      'but will ignore zero sum
      '
      if wr="_sp" then
        v=0
        do
          v+=wval(uword(s,i))
          wr=wordahead(s,i)
          if wr="_sp" then i=nwd : continue do
          exit do
        loop
        if v then inserts(s,"add "+qesp+cm+str(v)+cr,i)
        continue do       
      end if
    end if

    '=============
    'PASS THROUGHS
    '=============

        wd=" "+wr+" "

        m=0: if a=&h64 then  m=instr(" db dw dd dq ",wd) ' commas are optional
        if m>0 then
            do
                do
                    a=asc(s,i)
                    if ise(a) then goto addcode
                    if a>32 then exit do
                    i+=1
                loop
                wordeval(s,i,i):v=dv
                if m=1  then co+=hexb(v)
                if m=4  then co+=hexw(v)
                if m=7  then co+=hexl(dv)
                if m=10 then co+=" hq"+hex(dv) 'itr limited size
                do ' next data
                    a=asc(s,i)
                    if a=44 then i+=1:exit do
                    if ise(a) then goto addcode
                    if a>37 then exit do
                    i+=1
                loop
            loop
        end if

        if wr="skip" then ' only occurs when vew=2 >> no oxygen
            capture(s,m,i,a): co=" ": goto addcode
        end if

        if wr="o2" then
            capturi(s,m,b,i) : co=" "+mid(s,m,b) : ncm=1
            goto addcode
        end if

        if a=lbr then ' (
            co=" "+wr: goto addcode
        end if

        if a=rbr then ' )
            co=" "+wr: goto addcode
        end if

        if a=46 then
           if i-swd=1 then if isq(ascn) then wr="."+word(s,i) ' .QUOTED LABEL
           lbw=wr
           co=wr: goto addcode
        end if

        if wr="exit" then
          a=ascn
          if (a>48)and(a<58) then co=" e9 x"+word(s,i): goto addcode
          co=" e9 xl": goto addcode
        end if

        if wr="repeat" then co=" e9 rl": goto addcode

        if wr="asm" then continue do ' ignore


        md=0:rg=0:rm=0:er=0:sg=0:ima=0:ic=0:sb=0
        d=len(wr)
        


'SPECIAL CASES

        m=instr(" ret in out outs outsb outsw outsd enter leave ",wd)
                '01  05 08  12   17    23    29    35    41    57
        if m>0 then
            if m=01 then
                rtf=1:k=0
                a=ascl(s,i)
                if a=&h66 then wd=word(s,i): if wd="far" then k=8:a=asc(s,i)
                if isx(a)=0 then
                    wd=word(s,i)
                    wordeval(s,swd,i): if ert then goto exita
                    v=dv: if v>0 then co=hexb(&hc2+k)+hexw(v): goto addcode
                end if
                co=hexb(&hc3+k): goto addcode
            end if
            if m=05 then
                ' IN al or eax, nn or dx 
                b1=&he4' IN Input From Port  fixed port e4w : port number ' variable port ecw
                a=ascl(s,i)
                wd=word(s,i)
                if wd="eax" then b1+=1
                wd=word(s,i) ' swallow comma
                wd=word(s,i)
                ' no macro
                if wd="dx" then b1+=8:co=hexb(b1): goto addcode
                wordeval(s,swd,i): if ert then goto exita
                v=dv: co=hexb(b1)+hexb(v): goto addcode
                goto addcode
            end if
            if m=08 then
                ' OUT  nn or dx, eax or al 
                b1=&he6 ' OUT to Port  fixed port e6w : port number ' variable port eew
                wd=word(s,i)
                if wd="dx" then
                    b1+=8
                    wd=word(s,i) ' comma
                    wd=word(s,i)
                    if wd="eax" then b1+=1
                    co=hexb(b1): goto addcode
                end if
                wordeval(s,swd,i): if ert then goto exita
                wd=word(s,i)
                wd=word(s,i)
                if wd="eax" then b1+=1
                v=dv:co=hexb(b1)+hexb(v): goto addcode
            end if
            if m=12 then co=" 6E": goto addcode  ' OUTS  string Output to DX Port
            if m=17 then co=" 6E": goto addcode  ' OUTS  string Output to DX Port
            if (m=23)or(m=29) then co=" 6F": goto addcode
            if m=35  then ' ENTER
                wordeval(s,i,i):v=dv
                wd=word(s,i) ' skip comma 
                wordeval(s,i,i)
                co=" C8"+hexw(v)+hexb(dv): goto addcode
            end if
            if m=41 then ' LEAVE
                co=" C9": goto addcode
            end if
        end if


    b=ascl(s,i)


'INSTRUCTIONS WITHOUT OPERANDS


            if m=77 then m=01
    ' cbw   - convert byte to word
    ' cdq   - Convert Doubleword to Qword
    ' clc   - Clear Carry Flag
    ' cld   - clear direction flag
    ' cli   - Clear Direction Flag
    ' clts  - Clear Task-Switched Flag in CR0
    ' cmc   - Complement Carry Flag
    ' cpuid - CPU Identification
    ' cwd   - Convert Word to Doubleword
    ' cwde  - Convert Word to Doubleword
    ' daa   - Decimal Adjust AL after Addition 
    ' das   - Decimal Adjust AL after Subtraction 
    ' into  - Interrupt 4 on Overflow 
    ' invd - Invalidate Cache 
    ' iret / retd  Interrupt Return
    ' nop   - no operation
    ' lahf   - Load Status Flags into AH Register

    ' popa / popad    Pop All General Registers
    ' popf / popfd    Pop Stack into FLAGS or EFLAGS Register
    ' pusha / pushad  Push All General Registers
    ' pushf / pushd   Push Flags Register onto the Stack
    ' rdmsr   Read from Model-Specific Register
    ' rdpmc   Read Performance Monitoring Counters
    ' rdtsc   Read Time-Stamp Counter 
    ' rsm     Resume from System Management Mode
    ' UD2  Undefined instruction 0000 FFFF : 0000 1011

    ' sahf   - Store AH into Flags 
    ' sec     Set Carry Flag
    ' std     Set Direction Flag 
    ' sti     Set Interrupt Flag
    ' wait    Wait
    ' wbinvd  Writeback and Invalidate Data Cache
    ' wrmsr   Write to Model-Specific Register
    ' xlat    Table Look-up Translation            '
    ' stc     Set carry flag          '

    ' LOCK  Assert LOCK# Signal Prefix 1111 0000
    ' LEAVE  High Level Procedure Exit 1100 1001
    ' HLT  Halt 1111 0100
    ' AAA  ASCII Adjust after Addition 0011 0111
    ' AAD  ASCII Adjust AX before Division 
    ' AAM  ASCII Adjust AX after Multiply 
    ' AAS  ASCII Adjust AL after Subtraction 
    ' SYSENTER
    ' SYSEXIT
    ' UD2 Undefined instruction


'RELATIVE IMMEDIATE JUMPS AND CALLS

        m=0: if (a=&h63)or(a=&h6a) then m=instr ( _
        " call jmp jz jnz jl jge jle jg jb jae jbe ja jo jno js jns jpe jpo jc jnc je jne ",wd)
        '01   06  10 13  17 20  24  28 31 34  38  42 45 48  52 55  59  63  67 70  74 77  
'todo jc jnc

        if m=0 then goto Group_F

        pn=1:ws=0:ima=0:k=0
        wd=word(s,i)

        if m=1 then
            'call
            b1=&hff:bs=&he8:c=2:lw=1
            if wd="far" then
                c=3:bs=&h9a:k=1:wd=word(s,i)
            end if
            goto jumpmode
        end if

        if m=6 then
            'jmp
            b1=&hff:bs=&he9:c=4:lw=0
            if wd="far" then
                c=5:bs=&hea:k=1:wd=word(s,i)
            end if
            goto jumpmode


            jumpmode:
            if wd="[" then i=swd: goto mos
            v=regid(wd,wk)
            if v<0 then v=sregid(wd,wk)
            if v>=0 then i=swd: goto mos
            wordeval(s,swd,i)
            if nan=0 then
                ' immediate
                co=hexb(bs)+hexl(dv)
                if k=1 then
                    ' far direct absolute
                    i+=1:wordeval(s,i,i) 'skip colon
                    co+=hexw(dv)
                end if
                goto addcode
            end if
            wd=jword(s,swd,i,lw) ' long short
            if lw=0 then co=" EB"+wd: goto addcode ' short relative jump
            co=hexb(bs)+wd: goto addcode ' long relative jump
        end if


        ' Conditional jumps
        v=regid(wd,nn)
        if (v>=0)or(wd="[") then ers="must be a label":ert=13: goto exita
        '
        v=condi(wr,2)

        if v>=0 then
            lw=0:wd=jword(s,swd,i,lw)
            if lw then co=" 0F"+hexb(&h80+v)+wd: goto addcode
            co=hexb(&h70+v)+wd: goto addcode
        end if

        axdi=-1

Group_F:

        if a<>&h66 then goto Group_M
        qt=4
        itf=0
        if wr="fild"  then itf=5 ' 64 bit possible
        if wr="fistp" then itf=7 ' 64 bit possible
        'FI INTEGER
        if instr(" fild fist fiadd fisub fimul fidiv fisubr fidivr fistp fimulp fidivp fidivrp ficom ficomp ",wd) then
            qt=2: wr="f"+mid(wr,3)
        end if
        ppf=0:pp=0 'POP
        if instr(" fstp faddp fsubp fsubrp fmulp fdivp fdivrp fcomip fucomip fcomp"," "+wr) then
            if right(wr,1)="p" then ppf=1: wr=left(wr,len(wr)-1)
        end if
        wd=" "+wr+" "
        m=instr(" fst fld fadd fsub fmul fdiv fsubr fdivr fcomi fucomi fcom fldt fstpt ",wd)
                '01  05  09   14   19   24   29    35    41    47     54
        if m>0 then 
            flt=1:pn=1:et=-1:d=0
            if m=01 then
                if (ppf>0)and(qt=4) then et=7  ' FST  Store Real
                b1=&hd9:bs=&hdd:c=2:d=-2:pp=&hdd:cp=3
                if ppf>0 then ppf=0:c+=1 ' fstp fistp
                goto fcode
            end if
            if m=05 then
                if qt=4 then et=5
                b1=&hd9:bs=&hd9:c=0:d=-3: goto fcode ' FLD  Load Real
            end if
            if m=09 then b1=&hd8:bs=&hd8:c=0:pp=&hde:cp=0: goto fcode ' FADD   Add
            if m=14 then b1=&hd8:bs=&hd8:c=4:pp=&hde:cp=5: goto fcode ' FSUBP  Subtract and Pop 
            if m=19 then b1=&hd8:bs=&hd8:c=1:pp=&hde:cp=1: goto fcode ' FMUL   Multiply 
            if m=24 then b1=&hd8:bs=&hd8:c=6:pp=&hde:cp=7: goto fcode ' FDIV   Divide 
            if m=29 then b1=&hd8:bs=&hd8:c=5:pp=&hde:cp=4: goto fcode ' FSUBR  Reverse Subtract 
            if m=35 then b1=&hd8:bs=&hd8:c=7:pp=&hde:cp=6: goto fcode ' FDIVR  Reverse Divide 
            if m=41 then b1=-1:  bs=&hdb:c=6:pp=&hdf:cp=6: goto fcode ' FCOMI  Compare Real and Set EFLAGS db:c-r=6 st?
            if m=47 then b1=-1:  bs=&hdb:c=5:pp=&hdf:cp=5: goto fcode ' FUCOMI  Compare Real unordered and Set EFLAGS db:c-r=6 st?
            if m=54 then b1=&hd8:bs=&hd8:c=2:pp=&hd8:cp=3: goto fcode ' FCOM   Compare Real
            if wr="fldt"  then qt=4 : v=-1 : b1=&hd9 : et=5 : wd="eword" : goto memoperand
            if wr="fstpt" then qt=4 : v=-1 : b1=&hd9 : et=7 : wd="eword" : goto memoperand
            'ers="Internal error: Misaligned "+wd:ert=19: goto exita
        end if

        m=instr(" fxch fbld fbstp ffree fldcw fldenv fstcw fstenv fstsw fucom fucomp frstor fsave fnsave fnstcw fnstenv fnstsw fisttp ",wd)
                '01   06   11    17    23    29     36    42     49    55    61     68     75    81     88     95      103    110    117
        if m>0 then
            flt=1:pn=1:et=-1:d=0
            if m=01 then b1=-1  :bs=&hd9:c=1: goto fcode             ' FXCH    Exchange st0 and st? d9:c 1 st? 
            if m=06 then b1=&hdf:bs=-1:et=0:c=4: goto fcode          ' FBLD    Load Binary Coded Decimal df:md-4-rm
            if m=11 then b1=&hdf:bs=-1:et=0:c=6: goto fcode          ' FBSTP   Store Binary Coded Decimal and Pop df:md-6-rm
            if m=17 then b1=-1  :bs=&hdd   :c=0: goto fcode          ' FFREE   Free st? Register dd:c 0 st? 
            if m=23 then b1=&hd9:bs=-1:qt=1:c=5: goto fcode          ' FLDCW   Load Control Word d9:md-5-rm
            if m=29 then b1=&hd9:bs=-1:qt=1:c=4: goto fcode          ' FLDENV  Load FPU Environment d9:md-4-rm
            if m=36 then b0=&h9b:b1=&hd9:bs=-1:qt=1:c=7: goto fcode  ' FSTCW   Store Control Word d9:md-7-rm
            if m=42 then b0=&h9b:b1=&hd9:bs=-1:qt=1:c=6: goto fcode  ' FSTENV  Store FPU Environment d9:md-6-rm
            if m=49 then b0=&h9b:b1=&hdd:bs=-1:qt=1:c=7: goto feax   ' FSTSW   Store Status Word into Memory dd:md-7-rm ' ax: df e0
            if m=55 then b1=-1  :bs=&hdd   :c=4: goto fcode          ' FUCOM   Unordered Compare Real dd:e 0 st?
            if m=61 then b1=-1  :bs=&hdd   :c=5: goto fcode          ' FUCOMP  Unordered Compare Real and Pop dd:e 1 st? 
            if m=68 then b1=&hdd:bs=-1:qt=1:c=4: goto fcode          ' FRSTOR  Restore FPU state into Memory dd:md-4-rm ' ax: df e0
            if m=75 then b0=&h9b:b1=&hdd:bs=-1:qt=1:c=6: goto fcode  ' FSAVE   Store FPU state into Memory dd:md-4-rm ' ax: df e0
            if m=81 then b1=&hdd:bs=-1:qt=1:c=6: goto fcode          ' FNSAVE   Store FPU state into Memory dd:md-4-rm ' ax: df e0
            if m=88 then b1=&hd9:bs=-1:qt=1:c=7: goto fcode          ' FNSTCW  Store Control Word d9:md-7-rm
            if m=95 then b1=&hd9:bs=-1:qt=1:c=6: goto fcode          ' FNSTENV  Store FPU Environment d9:md-6-rm
            if m=103 then b1=&hdd:bs=-1:qt=1:c=7: goto feax          ' FNSTSW   Store Status Word into Memory dd:md-1-rm 'df/db/dd
            if m=110 then qt=5:c=1: goto mos                         ' FISTTP   Store integer with truncation ??:md-7-rm ' ax: df e0 SSE3
            'ers="Internal error: Misaligned "+wd:ert=19: goto exita
feax:
            wd=word(s,i)
            v=regid(wd,wk)
            if v=0 then
                if b0>=0 then co=hexb(b0)
                co+=" DF E0": goto addcode
            end if
            i=swd: goto fcode
        end if

        if left(wr,5)="fcmov" then
            wp=" "+mid(wr,6)+" "
            m=instr(" b e be u nb ne nbe nu ",wp)' FCMOVcc  Conditional Move on EFLAG
                    '1 3 5  8 10 13 16  20
            if m>0 then
                b1=-1:d=0
                bs=&hda
                if m=01 then c=0: goto fcode  ' fcmovb   -  move if below (B) da:c-0-st?
                if m=03 then c=1: goto fcode  ' fcmove   -  move if equal (E) da:c-1-st?
                if m=05 then c=2: goto fcode  ' fcmovbe  -  move if below or equal (BE) da:c-2-st?
                if m=08 then c=3: goto fcode  ' fcmovu   -  move if unordered (U) da:c-3-st?
                bs=&hdb  ' fcmov                        
                if m=10 then c=0: goto fcode  ' fcmovnb  -  move if not below (NB) db:c-0-st?
                if m=13 then c=1: goto fcode  ' fcmovne  -  move if not equal (NE) db:c-1-st?
                if m=16 then c=2: goto fcode  ' fcmovnbe -  move if not below or equal (NBE) db:c-2-st?
                if m=20 then c=3: goto fcode  ' fcmovnu  -  move if not unordered (NU) db:c-3-st?
                'ers="Internal error: Misaligned "+wd:ert=19: goto exita
            end if
        end if

        if m=0 then goto Group_F1 ' fixed instructions



fcode:
        v=-1
        a=ascn
        if (a<>&h73)and(ise(a)=0) then
           if b1<0 then ers="Stack operands only st(0..7) ":ert=16: goto exita
           '
           'POPPING eg: fstp
           '
           if ppf>0 then
               'can with ficomp
               'if m<>1 then ers="Unable to pop here ":ert=16: goto exita
               b1=pp:c=cp
           end if
           wd=word(s,i) 'pickup word dword qword eword
           goto memoperand
        end if
        if bs<0 then ers="memory operands only [..] ":ert=16: goto exita
        b1=bs
        if ppf then 
            b1=pp: c=cp
        end if
        '
        a=ascn:if ise(a) then co=hexb(b1)+hexb(&hc0+c*8+1): goto addcode ' implicit operands
        '
        wd=word(s,i) : v=0
        '
        'ST..ST  ST0(0)..ST(7)
        '---------------------
        '
        if len(wd)=3 then v=asc(wd,3) : if (v>=48)and(v<=57) then wd=left(wd,2) : v-=48
        '
        if wd="st" then
            if ascn=40 then
              i+=1:ascn=asc(s,i)  ' ignore (
              if qt=2 then ers="FPU Integers use memory pointers, not stack regs":ert=16: goto exita
              '
              wd="0":if (ascn>47)and(ascn<58) then wd=word(s,i)
              if ascn=41 then i+=1 ' ignore )
              v=wval(wd)
            end if
            '
            if (v<0)or(v>7) then ers="Expecting range 0..7 ":ert=16: goto exita
            n=i
            w=-1
            wd=word(s,i) ' comma?
            a=ascw
            if a<>44 then i=n
            if a=44 then
                w=v : v=0      
                wd=word(s,i)
                if len(wd)=3 then v=asc(wd,3) : if (v>=48)and(v<=57) then wd=left(wd,2) : v-=48
                if ascn=40 then
                  i+=1 ' ignore (
                  v=wval(word(s,i))
                  if asc(s,i)=41 then i+=1 ' ignore )
                end if
                if wd<>"st" then ers="Expecting st(..)":ert=16: goto exita
                if (v<0)or(v>7) then ers="Expecting range 0..7 ":ert=16: goto exita
                if v>w then ' attempt storing from st(1).. to st(0)
                    if d=-2 then ers="source must be st(0) dest st(0..7)":ert=16: goto exita
                end if
            end if
            if (w>0)and(v>0) then ers="one operand must be st(0)":ert=16: goto exita
            if (w=0)and(ppf) then
                ' does not apply to fcomi etc
                ' ers=" popped operation must have dest st(1..7) not st(0)":ert=16: goto exita
            end if
            b2=&hc0+c*8+v
            if (w>v) then
                if d=-3 then ers="Destination must be st(0) ":ert=16: goto exita
                b1=b1 or 4
                'if c>1 then c=c xor 1 ' swap source,dest
                if c>1 then c=c or 1 ' swap source,dest
                b2=&hc0+c*8+w
            end if
            co=hexb(b1)+hexb(b2) 
            goto addcode
        end if
        ers="Expecting st(0..7) ":ert=16: goto exita

Group_F1: 'FPU - no operands

    ' FABS     Absolute Value d9:e1
    ' FCHS     Change Sign d9:e0
    ' FLDZ     Load +0.0 into st0 d9:ee
    ' FLD1     Load +1.0 into st0 d9:e8
    ' FLDPI    Load p into st0 d9:eb
    ' FSQRT    Square Root d9:fa
    ' FSIN     Sine d9:fe
    ' FCOS     Cosine of st0 d9:ff
    ' FSINCOS  Sine and Cosine d9:fb
    ' FPTAN    Partial Tangent d9:f2
    ' FPATAN   Partial Arctangent d9:f3

    ' FCLEX    Clear Exceptions db:e2
    ' FDECSTP  Decrement Stack-Top Pointer d9:f6
    ' FINCSTP  Increment Stack Pointer d9:f7
    ' FINIT    Initialize Floating-Point Unit db e3
    ' FNOP     No Operation d9:d0
    ' FPREM    Partial Remainder d9:f8
    ' FPREM1   Partial Remainder (IEEE) d9:f5
    ' FRNDINT  Round to Integer d9:fc
    ' FSCALE   Scale d9:fd
    ' FSTSW    Store Status Word (to ax)
    ' FTST  Test d9:e4
    ' FUCOMPP  Unordered Compare Real and Pop Twice da:e9
    ' FXAM     Examine d9:e5
    ' FXTRACT  Extract Exponent and Significand d9:f 4

    ' FCOMPP   Compare Real and Pop Twice de:c-3-1
    ' F2XM1    Compute 2ST(0)  1 d9:f0
    ' FLDL2E   Load log2(e) into st0 d9:ea
    ' FLDL2T   Load log2(10) into st0 d9:e9
    ' FLDLG2   Load log10(2) into st0 d9:ec
    ' FLDLN2   Load loge(2) into st0 d9:ed
    ' FYL2X    st1  log2(ST(0)) d9:f1
    ' FYL2XP1  st1  log2(ST(0) + 1.0) d9:f9
    ' FWAIT

Group_M:



'CPU INSTRUCTIONS WITH OPERANDS


'GENERAL ARITHMETIC AND LOGIC


m1:
        m=instr(" mov inc dec push pop add sub mul div cmp and or xor test xchg movsx movzx ",wd)
                '01  05  09  13  18  22  26  30  34  38  42   46 49  53   58   63    69    75
        if m>0 then
            ima=1
            if m=01 then
                pn=2: b1=&h88: axdi=&hb0: im=&hc6
                ic=0: ima=2: axim=&ha0
                goto mos 'mov
            end if
            if m=05 then pn=1: b1=&hfe:           c=0:ima=0 : goto mos  ' inc  ' sb=&h40 not 64 bit mode
            if m=09 then pn=1: b1=&hfe:           c=1:ima=0 : goto mos  ' dec  ' sb=&h48 not 64 bit mode
            if m=13 then pn=1: b1=&hff: sb=&h50: c=6:im=&h68: ic=0 : goto mos 'push
            if m=18 then pn=1: b1=&h8f: sb=&h58:  c=0:ima=0 : goto mos  ' pop
            if m=22 then pn=2: b1=&h00: im=&h80: ic=0: ima=1: goto mos  ' add
            if m=26 then pn=2: b1=&h28: im=&h80: ic=5: ima=1: goto mos  ' sub
            if m=38 then pn=2: b1=&h38: im=&h80: ic=7: ima=1: goto mos  ' cmp
            if m=30 then pn=1: b1=-1: axdi=&hf6:  c=4       : goto mos  ' mul
            if m=34 then pn=1: b1=-1: axdi=&hf6:  c=6:      : goto mos  ' div
            if m=42 then pn=2: b1=&h20: im=&h80: ic=4: ima=1: goto mos  ' and
            if m=46 then pn=2: b1=&h08: im=&h80: ic=1: ima=1: goto mos  ' or
            if m=49 then pn=2: b1=&h30: im=&h80: ic=6: ima=1: goto mos  ' xor
            if m=53 then pn=2: b1=&h84: im=&hf6: ic=0: ima=1: goto mos  ' test (no di)
            if m=58 then pn=2: b1=&h84:axdi=&h90:      ima=0: goto mos  ' XCHG  Exchange Register/Memory with mrm and AL/AX/EAX Register 90+reg
            if m=63 then pn=3: b0=&h0f:b1=&hbe:        ima=0: goto mos  ' MOVSX Move with Sign-Extend
            if m=69 then pn=3: b0=&h0f:b1=&hb6:        ima=0: goto mos  ' MOVZX Move with Zero-Extend
            'ers="Internal error: Misaligned "+wd:ert=19: goto exita
        end if

        m=instr(" neg not adc sbb imul idiv bound arpl bsf bsr ",wd)
                '01  05  09  13  17   22   27    33   38  42  46
        if m>0 then
            if m=01 then pn=1: b1=&hf6:          c=3: goto mos          ' neg
            if m=05 then pn=1: b1=&hf6:          c=2: goto mos          ' not
            if m=09 then pn=2: b1=&h10: im=&h80: ic=2: ima=1: goto mos  ' adc
            if m=13 then pn=2: b1=&h18: im=&h80: ic=3: ima=1: goto mos  ' sbc
            if m=17 then pn=12:b1=&haf:axdi=&hf6:c=5:im=&h69:ic=&h0:ima=1: goto mos   ' imul **** todo extra formats
            ' also extended modes 0f af mrm  mem imm to reg = 69 6b mrm dat
            if m=22 then pn=1: b1=-1  : axdi=&hf6: c=7: ima=0 : goto mos  ' idiv
            '-----------------------------------------------------------------
            if m=27 then pn=3: b1=&h62                      : goto mos  ' BOUND  Check Array Against Bounds
            if m=33 then pn=4: b1=&h63                      : goto mos  ' ARPL  Adjust RPL Field of Selector '+ws
            if m=38 then pn=3: b0=&h0f: b1=&hbc:rsf=4       : goto mos  ' BSF  Bit Scan Forward
            if m=42 then pn=3: b0=&h0f: b1=&hbd:rsf=4       : goto mos  ' BSR  Bit Scan Reverse
            'ers="Internal error: Misaligned "+wd:ert=19: goto exita
        end if



'BIT SHIFTING

        m=instr(" rcl rcr rol ror sal sar shl shr shld shrd ",wd)
                '01  05  09  13  17  21  25  29  33   38   43
        if m>0 then
            pn=13:b1=&hd0:im=&hc0::ima=8
            if m=25 then m=17
            do
            if m=01 then c=2:ic=2 :exit do ' RCL  Rotate thru Carry Left df by cl 8bit imm
            if m=05 then c=3:ic=3 :exit do ' RCR  Rotate thru Carry Right df by cl 8bit imm
            if m=09 then c=0:ic=0 :exit do ' ROL  Rotate Left  8bit imm
            if m=13 then c=1:ic=1 :exit do ' ROR  Rotate Right 8bit imm
            if m=17 then c=4:ic=4 :exit do ' SAL  Shift Left   8bit imm
            if m=21 then c=7:ic=7 :exit do ' SAR  Shift Right  8bit imm
            if m=29 then c=5:ic=5 :exit do ' SHR  Shift Right  8bit imm
            pn=11
            if m=33 then b0=&h0f:b1=&ha5:c=0:im=&ha4:ic=0 :exit do ' SHLD  Double Precision Shift Left
            if m=38 then b0=&h0f:b1=&had:c=0:im=&hac:ic=0 :exit do ' SHRD  Double Precision Shift Right
            'ers="Internal error: Misaligned "+wd:ert=19: goto exita
            loop
            goto mos
        end if




'ITERATIVES

        m=instr(" jcxz jecxz loopz loope loopnz loopne loop ",wd)
                '01   06    12    18    24     31     38   43
        if m>0 then
            pn=0:c=0:rmf=3
            do            
            if (m=01)or(m=06) then b1=&he3    :exit do ' JCXZ/JECXZ     Jump on CX/ECX Zero Address-size prefix differentiates JCXZ and JECXZ 1110 0011 : 8-bit displacement
            if (m=12)or(m=18) then b1=&he1    :exit do ' LOOPZ/LOOPE    Loop Count while Zero/Equal 1110 0001 : 8-bit displacement
            if (m=24)or(m=31) then b1=&he0    :exit do ' LOOPNZ/LOOPNE  Loop Count while not Zero/Equal 1110 0000 : 8-bit displacement
            if m=38           then b1=&he2    :exit do ' LOOP           Loop Count 1110 0010 : 8-bit displacement
            'ers="Internal error: Misaligned "+wd:ert=19: goto exita
            loop
            if ascl(s,i)=&h6c then
                if wd="long" then ers="Short jump only ":ert=15: goto exita
            end if
            if m<=6 then
                if ascl(s,i)<&h65 then ers="Expecting 'exit' repeat' or a label ":ert=17: goto exita
                wd=word(s,i)
                do
                if wd="exit" then wd="x":exit do
                if wd="repeat" then wd="r":exit do
                if len(wd) then wd="g "+wd: exit do
                exit do
                loop
                co=hexb(b1)+" "+wd: goto addcode
            end if
            co+=hexb(b1)+" r"
            goto addcode
        end if


        v=instr(" rep repe repne ",wd)
                '01  05   10    16
        wp=wr    
        if v>0 then wp=word(s,i) ' rep something
        l=len(wp):b=asc(wp,l)
        if (b=&h62)or(b=&h64)or(b=&h77) then l-=1:wp=left(wp,l)
        if asc(wp,l)<>&h73 then goto nost
        ws=0: if (b=&h64)or(b=&h77) then ws=1
        m=instr(" ins lods movs outs cmps stos scas "," "+wp+" ")
                '01  05   10   15   20   25   30   35
        if m>0 then
            do
            if (v=1)or(v=5) then b0=&hf3
            if v=10 then b0=&hf2
            if m=01 then b1=&h6c  :exit do ' REP INS   Input String     f3 : 6cw
            if m=05 then b1=&hac  :exit do ' REP LODS  Load String      f3 : acw
            if m=10 then b1=&ha4  :exit do ' REP MOVS  Move String      f3 : a4w
            if m=15 then b1=&h6e  :exit do ' REP OUTS  Output String    f3 : 6ew
            if m=20 then b1=&ha6  :exit do ' REP CMPS  Compare String   f3 : a6w
            if m=25 then b1=&haa  :exit do ' REP STOS  Store String     f3 : aaw
            if m=30 then b1=&hae  :exit do ' REP SCAS  Scan String      f3 : aew
            ers="expecting ins lods movs outs stos scas etc ":ert=15: goto exita
            loop
            b1+=ws
            if b0>=0 then co=hexb(b0)
            co+=hexb(b1)
            goto addcode
        end if
nost:

        if wr="int" then
            wd=word(s,i)
            v=wval(wd)
            if v=3 then co=" CC": goto addcode      ' INT 3
            co=" CD"+hexb(v): goto addcode ' INT imm8
        end if






'ima 1 8 or 16 bit data
'    8 8  bit data only


    ' BT   Bit Test 
    ' BTC  Bit Test and Complement
    ' BTR  Bit Test and Reset
    ' BTS  Bit Test and Set
    ' XADD  Exchange and Add 0f c0w mrm

    ' SGDT  Store Global Descriptor Table Register 0f:01:m0m
    ' SIDT  Store Interrupt Descriptor Table Register of:01:m1m
    ' SLDT  Store Local Descriptor Table Register mrm
    ' SMSW  Store Machine Status Word mxm
    ' STR   Store Task Register mxm
    ' VERR  Verify a Segment for Reading m4m
    ' VERW  Verify a Segment for Writing m5m
    ' CMPXCHG  Compare and Exchange
    ' CMPXCHG8B  Compare and Exchange 8 Bytes


    ' LDS   Load Pointer to DS
    ' LEA   Load Effective Address
    ' LES   Load Pointer to ES
    ' LAR   Load Access Rights Byte
    ' LFS   Load Pointer to FS
    ' LGDT  Load Global Descriptor Table Register
    ' LIDT  Load Global Descriptor Table Register
    ' LGS   Load Pointer to GS mrm
    ' LSL   Load Segment Limit
    ' LSS   Load Pointer to SS
    ' LTR   Load Task Register
    ' LLDT  Load Local Descriptor Table Register
    ' LMSW  Load Machine Status Word

' SET conditional

        m=instr(" cmovz cmovnz cmovl cmovge cmovle cmovg cmovb cmovae cmovbe cmova cmovo cmovno cmovs cmovns cmovpe cmovpo cmovc cmovnc cmove cmovne ",wd)
        if m>0 then
            ' cmovcc Byte Set on Condition '  register 0f:40+tttn : m0m
            ' 8 bit regs
            pn=2 : b0=&h0f : b1=&h40 : flt=4
            v=condi(wr,5)
            'if v<0 then ers="Internal error: Misaligned "+wd:ert=19: goto exita
            b1+=v
            goto mos
        end if

' SET conditional

        m=instr(" setz setnz setl setge setle setg setb setae setbe seta seto setno sets setns setpe setpo setc setnc sete setne ",wd)
        if m>0 then
            ' SETcc Byte Set on Condition '  register 0f:90+tttn : m0m
            ' 8 bit regs
            pn=1:b0=&h0f:b1=&h90
            v=condi(wr,4)
            c=0
            'if v<0 then ers="Internal error: Misaligned "+wd:ert=19: goto exita
            b1+=v
            goto mos
        end if



'Prefix Bytes
'  address size 0110 0111        '
'  LOCK 1111 0000                '
'  operand size 0110 0110        ' word
'  CS segment override 0010 1110 ' seg CS
'  DS segment override 0011 1110 ' seg ds
'  ES segment override 0010 0110 ' seg es
'  FS segment override 0110 0100 ' seg fs
'  GS segment override 0110 0101 ' seg gs
'  SS segment override           '



'=============
'MMX ENCODINGS
'=============




        if asc(wr)=&h70 then
            gg=0
            v=len(wr)
            wp=left(wr,v-1)
            m=instr(" padd padds paddus pcmpeq pcmpgt psll psra psrl psub psubs psubus punpckhb punpckhw punpckhd punpcklb punpcklw punpckld "," "+wp)
            if m>0 then
                a=asc(wr,v)
                k=-1
                if a=&h62 then k=0 ' b
                if a=&h77 then k=1 ' w
                if a=&h64 then k=2 ' d
                if a=&h71 then k=3 ' q ' psllq
                if k>=0 then
                    gg=k
                    wr=left(wr,v-1)
                    wd=" "+wr+" "
                end if
            end if
        end if 


        if d>3 then m=instr(" emms movd movq packssdw packsswb packuswb padd padds paddus pand pandn ",wd)
                            '01   06   11   16       25       34       43   48    54     61   66    72
        if m>0 then
            pn=3
            b0=&h0f
            im=-1
            ' d=0 1 2 3
            ' b2= md-mmx-rm
            ' di +&h10 to mem
            ' immediate opts
            do
            if m=01 then b1=&h77 :exit do ' EMMS      - Empty MMX state 
            if m=06 then b1=&h6e:pn=2:exit do ' MOVD      - Move doubleword:  mem to mx 0f:6e: mem from mx 0f:7e
            if m=11 then b1=&h6f:pn=2:exit do ' MOVQ      - Move quadword: mem to mx 0f:6f: mem from mx 0f:7f
            if m=16 then b1=&h6b :exit do ' PACKSSDW1 - Pack dword to word data (signed with saturation) memory to mx 0f:6b
            if m=25 then b1=&h63 :exit do ' PACKSSWB1 - Pack word to byte data (signed with saturation):   memory to mx 0f:63
            if m=34 then b1=&h67 :exit do ' PACKUSWB1 - Pack word to byte data (unsigned with saturation):   memory to mx 0f:67
            if m=43 then b1=&hfc :exit do ' PADD      - Add with wrap-around:   memory to mx 0f: fc+gg
            if m=48 then b1=&hec :exit do ' PADDS     - Add signed with saturation: memory to mx 0f: ec+gg
            if m=54 then b1=&hdc :exit do ' PADDUS    - Add unsigned with saturation: memory to mx 0f: dc+gg
            if m=61 then b1=&hdb :exit do ' PAND      - Bitwise And:   memory to mx 0f:db
            if m=66 then b1=&hdf :exit do ' PANDN     - Bitwise AndNot: mmxreg2 to mmxreg1 0f:bf:c-mx1-mx2:   memory to mx 0f:df
            'ers="Internal error: Misaligned MMX list1"+wd:ert=19: goto exita
            loop
            v=b1:b1+=gg:gg=0
            if v=&h77 then co=" 0F"+hexb(b1): goto addcode ' check for junk
            flt=2: goto mos
        end if


        m=instr(" pcmpeq pcmpgt pmaddwd pmulhw pmullw por psll psra psrl psub psubs psubus punpckhb punpckhw punpckhd punpcklb punpcklw punpckld pmulhuw pxor ",wd)
                '01     08     15      23     30     37  41   46   51   56   61    67     74       83      92        101     110       119      128     136  141
        if m>0 then
            pn=3
            b0=&h0f
            im=-1
            ' b2= md-mmx-rm
            do
            if m=01  then b1=&h74         :exit do ' PCMPEQ  - Packed compare for equality: mx with memory 0f:74+gg
            if m=08  then b1=&h64         :exit do ' PCMPGT  - Packed compare greater (signed):   mx with memory 0f:64+gg
            if m=15  then b1=&hf5         :exit do ' PMADDWD - Packed multiply add: memory to mx 0f:f5
            if m=23  then b1=&he5         :exit do ' PMULHW  - Packed multiplication: memory to mx 0f:e5
            if m=30  then b1=&hd5         :exit do ' PMULLW  - Packed multiplication: memory to mx 0f:d5
            if m=37  then b1=&heb         :exit do ' POR     - Bitwise Or:   memory to mx 0f:eb
            if m=136 then b1=&hef         :exit do ' PXOR    - Bitwise Or:   memory to mx 0f:ef
            if m=41  then b1=&hf0:im=&h70:ic=6:exit do ' PSLL2   - Packed shift left logical: mx by memory 0f:f0+gg:md-mx-rm:  mx by immediate 0f:70+gg: c-6-mx: imm8 data
            if m=46  then b1=&he0:im=&h70:ic=4:exit do ' PSRA2   - Packed shift right arithmetic: mx by memory 0f:e0+gg:md-mx-rm:  mx by immediate 0f:70+gg: c-4-mx: imm8 data
            if m=51  then b1=&hd0:im=&h70:ic=2:exit do ' PSRL2   - Packed shift right logical: mx by memory 0f:d0+gg:md-mx-rm :   mx by immediate 0f:70+gg: c-2-mx: imm8 data
            if m=56  then b1=&hf8         :exit do ' PSUB    - Subtract with wraparound: memory from mx 0f:f8+gg
            if m=61  then b1=&he8         :exit do ' PSUBS   - Subtract signed with saturation: memory from mx 0f:e8+gg:md-mx-rm
            if m=67  then b1=&hd8         :exit do ' PSUBUS  - Subtract unsigned with saturation: memory from mx 0f:d8+gg
            if (m=74)or(m=83)or(m=92) then b1=&h67 :exit do ' PUNPCKH - Unpack high data to next larger type: memory to mx 0f:68+gg
            if (m=101)or(m=110)or(m=119) then b1=&h5F :exit do ' PUNPCKH - Unpack high data to next larger type: memory to mx 0f:68+gg
            if m=128 then b1=&he4                     :exit do ' PMULHUW     - Packed Multiply High Unsigned : mm to mm 0f:e4:c-mm1-mm2 : mem to mm 0f:e4:md-mm-rm
            'ers="Internal error: Misaligned MMX list2"+wd:ert=19: goto exita
            loop
            if im>=0 then im+=gg:ima=8 ' + 8bit data
            flt=2:b1+=gg:gg=0: goto mos
        end if


'===============
' SIMD ENCODINGS
'===============

        c=0

'SSE2


    '    0f 58 ADDPS        - Packed Single-FP Add : xm to xm   0f:58:c-mx1-xm2 : mem to xm 0f:58:md-xm-rm
    ' f3 0f 58 ADDSS        - Scalar Single- FP Add xm to xm f3:0f:58:c xm1 xm2 :  mem to xm f3:0f:58:md-xm-rm
    '    0f 55 ANDNPS       - Bit-wise Logical And Not for Single-FP :  xm to xm 0f:55:c-mx1-xm2 : mem to xm 0f:55:md-xm-rm
    '    0f 54 ANDPS        - Bit-wise Logical And for Single-FP :  xm to xm 0f:54:c-mx1-xm2 :   mem to xm 0f:54:md-xm-rm
    '    0f c2 CMPPS        - Packed Single-FP Compare : xm to xmmreg, imm8 0f:c2:c-mx1-xm2: imm8 : mem to xmmreg, imm8 0f:c2:md-xm-rm: imm8
    ' f3 0f c2 CMPSS        - Scalar Single-FP Compare : xm to xmmreg, imm8 f3:0f:c2:c xm1 xm2: imm8 :   mem to xmmreg, imm8 f3:0f:c2:md-xm-rm: imm8
    '    0f 2f COMISS       - Scalar Ordered Single-FP compare and set EFLAGS :   xm to xm 0f:2f:c-mx1-xm2 : mem to xm 0f:2f:md-xm-rm
    '    0f 2a CVTPI2PS     - Packed signed INT32 to Packed Single-FP conversion :   mm to xm 0f:2a:c mx1 mmreg1 :  mem to xm 0f:2a:md-xm-rm
    '    0f 2d CVTPS2PI     - Packed Single-FP to Packed INT32 conversion :   xm to mm 0f:2d:c-mm1-xm1 : mem to mm 0f:2d:md-mm-rm
    ' f3 0f 2a CVTSI2SS     - Scalar signed INT32 to Single- FP conversion :   r32 to mx1 f3:0f:2a:c xm r32 :   mem to xm f3:0f:2a:md-xm-rm
    ' f3 0d 2d CVTSS2SI     - Scalar Single-FP to signed INT32 conversion :   xm to r32 f3:0f:2d:c r32 xmmreg : mem to r32 f3:0f:2d:md-r32-rm
    '    0f 2c CVTTPS2PI    - Packed Single-FP to Packed INT32 Conversion (truncate) : xm to mm 0f:2c:c-mm1-xm1 : mem to mm 0f:2c:md-mm-rm
    ' f3 0f 2c CVTTSS2SI    - Scalar Single-FP to signed INT32 conversion (truncate) : xm to r32 f3:0f:2c:c-r32-xm1 : mem to r32 f3:0f:2c:md-r32-rm
    '    0f 5e DIVPS        - Packed Single-FP Divide : xm to xm 0f:5e:c-mx1-xm2 : mem to xm 0f:5e:md-xm-rm
    ' f3 0f 5e DIVSS        - Scalar Single-FP :   Divide f3:0f:5e:c-xm1-xm2 : xm to xm : mem to xm f3:0f:5e:md-xm-rm
    '    0f ae 40 FXRSTOR   - Restore FP/MMX and Streaming SIMD Extensions state : 0f:ae:40+m512
    '    0f ae 00 FXSAVE    - Store FP/MMX and Streaming SIMD Extensions state : 0f:ae:00+m512 
    '    0f ae 80 LDMXCSR   - Load Streaming SIMD Extensions Technology Control/Status Register : m32 to MXCSR 0f:ae:80+m32

    '    0f 5f MAXPS        - Packed Single-FP Maximum :   xm to xm 0f:5f:c-mx1-xm2 : mem to xm 0f:5f:md-xm-rm
    ' f3 0f 5f MAXSS        - Scalar Single-FP Maximum : xm to xm f3:0f:5f:c-xm1-xm2 : mem to xm f3:0f:5f:md-xm-rm
    '    0f 5d MINPS        - Packed Single- FP Minimum : xm to xm 0f:5d:c-mx1-xm2 : mem to xm 0f:5d:md-xm-rm
    ' f3 0f 5d MINSS        - Scalar Single-FP Minimum : xm to xm f3:0f:5d:c-xm1-xm2 : mem to xm f3:0f:5d:md-xm-rm
    '    0f 28 MOVAPS       - Move Aligned Four Packed Single-FP : mx2 to mx1 0f:28:c mx2 xm1 : mem to mx1 0f:28:md-xm-rm : mx1 to mx2 0f:29:c-mx1-xm2 : mx1 to mem 0f:29:md-xm-rm
    '    0f 90 MOVHLPS      - Move High to Low Packed Single-FP : xm to xm 0f:90:c-mx1-xm2
    '    0f 16 MOVHPS       - Move High Packed Single-FP : mem to xm 0f:16:md-xm-rm : xm to mem 0f:17:md-xm-rm
    '    0f 16 MOVLHPS      - Move Low to High Packed Single-FP : xm to xm 0f:16:c-mx1-xm2
    '    0f 90 MOVLPS       - Move Low Packed Single-FP : mem to xm 0f:90:md-xm-rm : xm to mem 0f:91:md-xm-rm
    '    0f 50 MOVMSKPS     - Move Mask To Integer : xm to r32 0f:50:c r32 xmmreg
    ' f3 0f 80 MOVSS        - Move Scalar Single-FP : mx2 to mx1 f3:0f:80:c-xm2-xm1 : mem to mx1 f3:0f:80:md-xm-rm : mx1 to mx2 f3:0f:80:c-xm1-xm2 : mx1 to mem f3:0f:80:md-xm-rm
    '    0f 80 MOVUPS       - Move Unaligned Four Packed  single-FP : mx2 to mx1 0f:80:c mx2 xm1 :   mem to mx1 0f:80:md-xm-rm : mx1 to mx2 0f:81:c-mx1-xm2 : mx1 to mem 0f:81:md-xm-rm
    '    0f 59 MULPS        - Packed Single-FP Multiply : xm to xm 0f:59:c-mx1-xm2 : mem to xm 0f:59:md-xm-rm
    ' f3 0f 59 MULSS        - Scalar Single-FP Multiply : xm to xm f3:0f:59:c-xm1-xm2 : mem to xm f3:0f:59:md-xm-rm
    '    0f f7 MASKMOVQ     - Byte Mask Write :   mm to mm 0f:f7:c-mm1-mm2
    '    0f 2b MOVNTPS      - Move Aligned Four Packed Single-FP Non Temporal :   xm to mem 0f:2b:md-xm-rm
    '    0f e7 MOVNTQ       - Move 64 Bits Non Temporal :   mm to mem 0f:e7:md-mm-rm

    '    0f 56 ORPS:        - Bit-wise Logical OR for Single-FP Data : xm to xm 0f:56:c-mx1-xm2 : mem to xm 0f:56:md-xm-rm
    '    0f 53 RCPPS        - Packed Single-FP Reciprocal : xm to xm 0f:53:c-mx1-xm2 : mem to xm 0f:53:md-xm-rm
    ' f3 0f 53 RCPSS        - Scalar Single-FP Reciprocal : xm to xm f3:0f:53:c-xm1-xm2 : mem to xm f3:0f:53:md-xm-rm
    '    0f 52 RSQRTPS      - Packed Single-FP Square Root Reciprocal : xm to xm 0f:52:c-mx1-xm2 : mem to xm 0f:52 mode-xm-rm
    ' f3 0f 52 RSQRTSS      - Scalar Single-FP Square Root Reciprocal : xm to xm f3:0f:52:c-xm1-xm2 : mem to xm f3:0f:52:md-xm-rm
    '    0f c6 SHUFPS       - Shuffle Single-FP : xm to xmmreg, imm8 0f:c6:c-mx1-xm2:imm8 : mem to xmmreg, imm8 0f:c6:md-xm-rm:imm8
    '    0f 51 SQRTPS       - Packed Single-FP Square Root : xm to xm 0f:51:c-mx1-xm2 : mem to xm 0f:51:md-xm-rm
    ' f3 0f 51 SQRTSS       - Scalar Single-FP Square Root : xm to xm f3:0f:51:c-xm1-xm2 : mem to xm f3:0f:51:md-xm-rm
    '    0f ae STMXCSR      - Store Streaming SIMD Extensions Technology Control/Status Register : MXCSR to mem 0f:ae:c m32
    '    0f 5c SUBPS        - Packed Single-FP Subtract : xm to xm 0f:5c:c-mx1-xm2 : mem to xm 0f:5c:md-xm-rm
    ' f3 0f 5c SUBSS        - Scalar Single-FP Subtract : xm to xm f3:0f:5c:c-xm1-xm2 : mem to xm f3:0f:5c:md-xm-rm
    '    0f ae f8 SFENCE    - Store Fence 0f:ae:f8 
    '    0f 2e UCOMISS      - Unordered Scalar Single-FP compare and set EFLAGS : xm to xm 0f:2e:c-mx1-xm2 : mem to xm 0f:2e:md-xm-rm
    '    0f a1 UNPCKHPS     - Unpack : High Packed Sing  le-FP Data : xm to xm 0f:a1:c-mx1-xm2 : mem to xm 0f:a1:md-xm-rm
    '    0f a0 UNPCKLPS     - Unpack Low Packed Single-FP Data : xm to xm 0f:a0:c-mx1-xm2 : mem to xm 0f:a0:md-xm-rm
    '    0f 57 XORPS        - Bitwise Logical Xor for Single-FP Data : xm to xm 0f:57:c-mx1-xm2 : mem to xm 0f:57:md-xm-rm

    ' 0f e0 PAVGB           - Packed Average : mm to mm 0f:e0:c-mm1-mm2 : 0f:e3:c-mm1-mm2 : mem to mm 0f:e0:md-mm-rm : 0f:e3:md-mm-rm
    ' 0f e3 PAVGW           - Packed Average : mm to mm 0f:e0:c-mm1-mm2 : 0f:e3:c-mm1-mm2 : mem to mm 0f:e0:md-mm-rm : 0f:e3:md-mm-rm
    ' 0f c5 PEXTRW          - Extract Word :   mm to reg32, imm8 0f:c5:c mm r32: imm8
    ' 0f c4 PINSRW          - Insert Word : reg32 to mmreg, imm8 0f:c4:c r32 mmreg1: imm8 : m16 to mmreg, imm8 0f:c4:md-mm-rm: imm8
    ' 0f ee PMAXSW          - Packed Signed Integer Word Maximum : mm to mm 0f:ee:c-mm1-mm2 : mem to mm 0f:ee:md-mm-rm
    ' 0f de PMAXUB          - Packed Unsigned Integer Byte Maximum : mm to mm 0f:de:c-mm1-mm2 : mem to mm 0f:de:md-mm-rm
    ' 0f ea PMINSW          - Packed Signed Integer Word Minimum : mm to mm 0f:ea:c-mm1-mm2 :  mem to mm 0f:ea:md-mm-rm
    ' 0f da PMINUB          - Packed Unsigned Integer Byte Minimum Y : mm to mm 0f:da:c-mm1-mm2 : mem to mm 0f:da:md-mm-rm
    ' 0f d7 PMOVMSKB        - Move Byte Mask To Integer O : mm to reg32 0f:d7:c-mm1-r32 : 
    ' 0f f6 PSADBW          - Packed Sum of Absolute Differences I O : mm to mm 0f:f6:c-mm1-mm2 : mem to mm 0f:f6:md-mm-rm
    ' 0f 70 PSHUFW          - Packed Shuffle Word : mm to mmreg, imm8 0f:70:c-mm1-mm2: imm8 :   mem to mmreg, imm8 0f:70:c:md-mm-rm: imm8


'SSE2 extended

    ' 66 0f 10 MOVUPD   - Move Unaligned 
    ' 66 0f 12  MOVLPD   - Move  
    ' 66 0f 16 MOVHPD   - Move 
    ' 66 0f 14 UNPCKLPD   -
    ' 66 0f 15 UNPCKHPD   -  


'SSE3



    ' 66,0F,D0,/r ADDSUBPD xmm1, xmm2/m128 Add /Sub packed DP FP numbers from XMM2/Mem to XMM1. Y Y Y Y Y 
    ' F2,0F,D0,/r ADDSUBPS xmm1, xmm2/m128 Add /Sub packed SP FP numbers from XMM2/Mem to XMM1. Y Y Y Y Y
    ' DF /1 FISTTP m16int Store ST in int16 (chop) and pop. Y Y DB /1 FISTTP m32int Store ST in int32 (chop) and pop. Y Y
    ' 66,0F,7C,/r HADDPD xmm1, xmm2/m128 Add horizontally packed DP FP numbers XMM2/Mem to XMM1. Y Y Y Y Y
    ' F2,0F,7C,/r HADDPS xmm1,xmm2/m128 Add horizontally packed SP FP numbers XMM2/Mem to XMM1 Y Y Y Y Y
    ' 66,0F,7D,/r HSUBPD xmm1, xmm2/m128 Sub horizontally packed DP FP numbers XMM2/Mem to XMM1 Y Y Y Y Y
    ' F2,0F,7D,/r HSUBPS xmm1,xmm2/m128 Sub horizontally packed SP FP numbers XMM2/Mem to XMM1 Y Y Y Y Y
    ' F2,0F,F0,/r LDDQU xmm, m128 Load unaligned integer 128-bit. 0F,01,C8 MONITOR eax, ecx, edx Set up a linear address range to be monitored by hardware.
    ' F2,0F,12,/r MOVDDUP xmm1, xmm2/m64 Move 64 bits representing one DP data from XMM2/Mem to XMM1 and duplicate.
    ' F3,0F,16,/r MOVSHDUP xmm1, xmm2/m128 Move 128 bits representing 4 SP data from XMM2/Mem to XMM1 and duplicate high.
    ' F3,0F,12,/r MOVSLDUP xmm1,xmm2/m128 Move 128 bits representing 4 SP data from XMM2/Mem to XMM1 and duplicate low.
    ' 0F,01,C9 MWAIT eax, ecx Wait until write-back store performed within the range specified by the instruction MONITOR.


'SSE4


    ' 66 0F 3A 0D BLENDPD xmm1, xmm2/m128, imm8 Blend Packed Double Precision Floating-Point Values
    ' 66 0F 3A 0C BLENDPS xmm1, xmm2/m128, imm8 Blend Packed Single Precision Floating-Point Values
    ' 66 0F 38 15 BLENDVPD xmm1, xmm2/m128, <XMM0> Variable Blend Packed Double Precsion Floating-Point Values
    ' 66 0F 38 14 BLENDVPS xmm1, xmm2/m128, <XMM0> Variable Blend Packed Single Precision Floating-Point Values
    ' 66 0F 3A 41 DPPD xmm1, xmm2/m128 imm8 Dot Product of Packed Double Precision Floating Point Values
    ' 66 0F 3A 40 DPPS xmm1, xmm2/m128. imm8 Dot Product of Packed Single Precision Floating Point Values
    ' 66 0F 3A 17 EXTRACTPS r/m32, xmm imm8 Extract Packed Single Precision Floating-Point Value
    ' 66 0F 3A 21 INSERTPS xmm1, xmm2/m32, imm8 Insert Packed Single Precision Floating-Point Value
    ' 66 0F 38 2A MOVNTDQA xmm, m128 Load Double Quadword Non-Temporal Aligned Hint
    ' 66 0F 3A 42 MPSADBW xmm1, xmm2/m128, imm8 Compute Multiple Packed Sums of Absolute Difference
    ' 66 0F 38 2B PACKUSDW xmm1,xmm2/m128 Pack with Unsigned Saturation
    ' 66 0F 38 10 PBLENDVB xmm1,xmm2/m128, <XMM0> Variable Blend Packed Bytes
    ' 66 0F 3A 0E PBLENDW xmm1, xmm2/m128, imm8 Blend Packed Words
    ' 66 0F 38 29 PCMPEQQ xmm1, xmm2/m128 Compare Packed Qword Data for Equal
    ' 66 0F 3A 14 PEXTRB r32/m8, xmm, imm8 Extract Byte
    ' 66 0F 3A 16 PEXTRD r/m32, xmm, imm8 Extract Dword
    ' 66 REX.w 0F 3A 16 PEXTRQ r/m64, xmm, imm8 Extract Qword
    ' 66 0F 3A 15 PEXTRW r/m16, xmm, imm8 Extract Word ' ? ALTERNATIVE CODING
    ' 66 0F 38 41 PHMINPOSUW xmm1, xmm2/m128 Packed Horizontal Word Minimum
    ' 66 0F 3A 20 PINSRB xmm1, r32/m8, imm8 Insert Byte
    ' 66 0F 3A 22 PINSRD xmm1, r/m32, imm8 Insert Dword
    ' 66 REX.w 0F 3A 22 PINSRQ xmm1, r/m64, imm8 Insert Qword
    ' 66 0F 38 3C PMAXSB xmm1, xmm2/m128 Maximum of Packed Signed Byte Integers
    ' 66 0F 38 3D PMAXSD xmm1, xmm2/m128 Maximum of Packed Signed Dword Integers
    ' 66 0F 38 3F PMAXUD xmm1, xmm2/m128 Maximum of Packed Unsigned Dword Integers
    ' 66 0F 38 3E PMAXUW xmm1, xmm2/m128 Maximum of Packed Unsigned Word Integers
    ' 66 0F 38 38 PMINSB xmm1, xmm2/m128 Minimum of Packed Signed Byte Integers
    ' 66 0F 38 39 PMINSD xmm1, xmm2/m128 Minimum of Packed Signed Dword Integers
    ' 66 0F 38 3B PMINUD xmm1, xmm2/m128 Minimum of Packed Unsigned Dword Integers
    ' 66 0F 38 3A PMINUW xmm1, xmm2/m128 Minimum of Packed Unsigned Word Integers
    ' 66 0F 38 21 PMOVSXBD xmm1, xmm2/m32 Packed Move with Sign Extend - Byte to Dword 
    ' 66 0F 38 22 PMOVSXBQ xmm1, xmm2/m16 Packed Move with Sign Extend - Byte to Qword
    ' 66 0F 38 20 PMOVSXBW xmm1, xmm2/m64 Packed Move with Sign Extend - Byte to Word
    ' 66 0F 38 23 PMOVSXWD xmm1, xmm2/m64 Packed Move with Sign Extend - Word to Dword
    ' 66 0F 38 24 PMOVSXWQ xmm1, xmm2/m32 Packed Move with Sign Extend - Word to Qword
    ' 66 0F 38 25 PMOVSXDQ xmm1, xmm2/m64 Packed Move with Sign Extend - Dword to Qword
    ' 66 0F 38 31 PMOVZXBD xmm1, xmm2/m32 Packed Move with Zero Extend - Byte to Dword
    ' 66 0F 38 32 PMOVZXBQ xmm1, xmm2/m16 Packed Move with Zero Extend - Byte to Qword
    ' 66 0F 38 30 PMOVZXBW xmm1,xmm2/m64 Packed Move with Zero Extend - Byte to Word
    ' 66 0F 38 33 PMOVZXWD xmm1, xmm2/m64 Packed Move with Zero Extend - Word to Dword
    ' 66 0F 38 34 PMOVZXWQ xmm1,xmm2/m32 Packed Move with Zero Extend - Word toQword
    ' 66 0F 38 35 PMOVZXDQ xmm1, xmm2/m64 Packed Move with Zero Extend - Dword to Qword
    ' 66 0F 38 28 PMULDQ xmm1, xmm2/m128 Multiply Packed Signed Dword Integers
    ' 66 0F 38 40 PMULLD xmm1, xmm2/m128 Multiply Packed Signed Dword Integers and Store Low Result
    ' 66 0F 38 17 PTEST xmm1, xmm2/m128 Logical Compare 
    ' 66 0F 3A 09 ROUNDPD xmm1, xmm2/m128, imm8 Round Packed Double Precision Floating-Point Values
    ' 66 0F 3A 08 ROUNDPS xmm1, xmm2/m128, imm8 Round Packed Single Precision Floating-Point Values
    ' 66 0F 3A 0B ROUNDSD xmm1, xmm2/m64, imm8 Round Scalar Double Precision Floating-Point Values
    ' 66 0F 3A 0A ROUNDSS xmm1, xmm2/m32, imm8 Round Scalar Single Precision Floating-Point Values


' 3DNOW


    ' dn postfix
    ' flt=3:pn=4:pfx=" 0f 0f":lp=1:b1=&h0a
    ' 0C PI2FW Packed Integer to Floating-Point Word Conversion
    ' 0D PI2FD Packed Integer to Floating-Point Doubleword Conversion
    ' 1C PF2IW Packed Floating-Point to Integer Word Conversion
    ' 1D PF2ID Packed Floating-Point to Integer Doubleword
    ' 8A PFNACC Packed Floating-Point Negative Accumulate
    ' 8E PFPNACC Packed Floating-Point Positive-Negative Accumulate
    ' 90 PFCMPGE Packed Floating-Point Compare Greater or Equal
    ' 94 PFMIN Packed Single-Precision Floating-Point Minimum
    ' 96 PFRCP Floating-Point Reciprocal Approximation
    ' 97 PFRSQRT Packed Floating-Point Reciprocal Square Root Approximation
    ' 9A PFSUB Packed Floating-Point Subtract
    ' 9E PFADD Packed Floating-Point Add
    ' A0 PFCMPGT Packed Floating-Point Compare Greater Than
    ' A4 PFMAX Packed Single-Precision Floating-Point Maximum
    ' A6 PFRCPIT1 Packed Floating-Point Reciprocal Iteration 1
    ' A7 PFRSQIT1 Packed Floating-Point Reciprocal Square Root Iteration 1
    ' AA PFSUBR Packed Floating-Point Subtract Reverse
    ' AE PFACC Packed Floating-Point Accumulate
    ' B0 PFCMPEQ Packed Floating-Point Compare Equal
    ' B4 PFMUL Packed Floating-Point Multiply
    ' B6 PFRCPIT2 Packed Floating-Point Reciprocal or Reciprocal Square Root Iteration 2
    ' B7 PMULHRW Packed Multiply High Rounded Word
    ' BB PSWAPD Packed Swap Doubleword
    ' BF PAVGUSB Packed Average Unsigned Bytes
 

    'CACHE MANAGEMENT
    ' 0f 40 PREFETCHT0  - Prefetch to all cache levels : 0f:c0:01 mem 
    ' 0f 80 PREFETCHT1  - Prefetch to all cache levels : 0f:c0:10 mem 
    ' 0f c0 PREFETCHT2  - Prefetch to L2 cache 0f:c0:c mem 
    ' 0f 00 PREFETCHNTA - Prefetch to L1 cache 0f:c0:00 mem Y 



    'BSWAP
    if wr="bswap" then
        wd=word(s,i)
        v=regid(wd,wk)
        if (v>=0)and(wk=4) then co=" 0F"+hexb(&hc8+v): goto addcode
        ers="Expecting 16/32 bit rigister":ert=16: goto exita
    end if


'=======================================================================================================
' OPERAND PROCESSING
'=======================================================================================================



other:
        ' ops prefix codes
        ' opd flags and opcodes
        wr=ltrim(rtrim(wr))
        v=lookupc(wr)
        if v<0 then ert=9:ers="Unidentified instruction: "+wr : goto exita
        pfx=ops(v) : lp=len(pfx)*0.33
        k=cast(long,@opd(v,0))+8
        ' assume row major order
        asm
            mov edx,[k]
            mov eax,[edx]
            mov [flt],eax
            mov eax,[edx+04]
            mov [pn],eax
            mov eax,[edx+08]
            mov [b1],eax
            mov eax,[edx+12]
            mov [c], eax
            mov eax,[edx+16]
            mov [ima],eax
            mov eax,[edx+20]
            mov [im],eax
            mov eax,[edx+24]
            mov [ic],eax
            mov eax,[edx+28]
            mov [dn],eax
        end asm
        if ima<1 then ima=0
        'print v,flt,pn,b1,c,ima,im,ic
        if (b1<0)and(ima<1)and(dn<0) then goto addcode ' no operands expected
        ' otherwise procede to mos
        '
        '===
        mos:
        '===
        '
        do
          a=asc(s,i)
          if ise(a) then
            if pn=1 then ers="missing operand":ert=31: goto exita
            ers="missing operands":ert=31: goto exita
          end if
          wd=word(s,i)
          if wd="rip" then rip=1    : continue do 'IP-RELATIVE ADDRESSING (64 BIT MODE ONLY)
          if wd="float" then flot=1  : flos=" ns" :  continue do 'FLOATING POINT SINGLE
          if wd="double" then flot=2 : flos=" nd" : continue do 'FLOATING POINT DOUBLE
          if wd="fwd" then fwd=1    : continue do 'LOOK FORWARD ONLY
          exit do
        loop

        a=ascn
        if a=58 then
          k=SegOverride(wd)
          if k then pfx=hexb(k)+pfx : lp+=1 : i+=1 : wd=word(s,i)
        end if

            
        v=regid(wd,wk)


        if v>=0 then
          if wk=2 then
            if flt>0 then ers="Can't use 16 bit register here":ert=12: goto exita
            pfx66(pfx,lp)
          end if
          if flt=2 then ers="Can't use gp register with this mmx instruction":ert=3: goto exita
          if (flt=3)and(pn<>15) then
            if (b1<>&h50)and(im<>&hc5)and(im<>&hc4)and(b1<>&hd7) then
              ers="Can't use gp register with this simd instruction":ert=3: goto exita
            end if
          end if
        end if
        if v<0 then
          if pn=14 then
            ers="Expecting a general reg followed by mm? ":ert=11: goto exita
          end if
          if flt>1 then 
            v=xmmxid(wd,wk)
          end if
          if (flt=0)and(v<0)and(lp=0) then
            v=sregid(wd,wk) ' with di
            if b1=&h88 then ' mov
              if wk=129 then flt=0:b1=&h20: b0=&h0f ' to cr
              if wk=130 then flt=0:b1=&h21: b0=&h0f ' to dr
              if wk=131 then flt=0:b1=&h8c:         ' to segreg
            end if
            if sb=&h50 then ' push
              if wk=131 then
              if v=3 then co=" 1e"   : goto addcode ' ds
              if v=1 then co=" 0e"   : goto addcode ' cs
              if v=0 then co=" 06"   : goto addcode ' es
              if v=2 then co=" 16"   : goto addcode ' ss
              if v=4 then co=" 0F A0": goto addcode ' fs
              if v=5 then co=" 0F A8": goto addcode ' gs
            end if
          end if
          if sb=&h58 then ' pop
            if wk=131 then
              if v=3 then co=" 1f"   : goto addcode ' ds
              if v=0 then co=" 07"   : goto addcode ' es
              if v=2 then co=" 17"   : goto addcode ' ss
              if v=4 then co=" 0F A1": goto addcode ' fs
              if v=5 then co=" 0F A9": goto addcode ' gs
            end if
          end if
        end if
      end if




      '========================
      'ACCUMULATOR - MEM to EAX
      '========================

      if (axdi>=0)and(flt=0) then
        if b1=-1 then
          b1=axdi: goto memoperand ' mul div idiv
        end if
        if pn=12 then
          a=ascn
          if a<>44 then ' single operand
            b1=axdi:pn=1: goto memoperand ' imul
          end if                
          b0=&h0f:b1=&haf:im=&h69
        end if
      end if



      '===================================
      memoperand: 'MEMORY AS FIRST OPERAND
      '===================================

      if v<0 then
        ' catch later
        if pn=5 then ers="Expecting a register":ert=31: goto exita
        ptf=0
        m=i
        wk=4 ' set as default
        a=0
        '
        if flt=1 then
          '
          '=========
          'FPU TYPES
          '=========
          '
          if wd="word" then
            if qt=1 then a=2
            if qt=2 then a=2:ptf=1: b1+=6
            if qt=4 then ers="'word' not supported for float types":ert=16: goto exita
            if qt=5 then a=2:b1=&hdf ' fisttp
          elseif wd="dword" then
            a=4:ptf=1
            if qt=2 then b1+=2 ' f integer
            if qt=5 then b1=&hdb ' fisttp
          elseif wd="qword" then
            if qt=4 then a=8:ptf=1: b1+=4
            if qt=5 then a=8:b1=&hdd ' fisttp
            if qt=2 then
              if itf=0 then ers="qword not supported here":ert=16: goto exita
              a=8:ptf=1: b1+=6:c=itf
            end if
          elseif wd="eword" then
            if (et<0)or(qt=2)  then ers="eword not compatible here":ert=16: goto exita
            a=10:ptf=1
            if et>0 then b1+=2: c=et ' otherwise bbld or fbstp
          end if
          '
          if (a=0)and(et<>0)and(qt<>1) then
            ers="Expect FPU type: word,dword,qword,eword ":ert=16: goto exita
          end if
          '
        elseif flt=0 then
          '
          '=========
          'CPU TYPES
          '=========
          '
          if wd="qword" then a=8 : ptf=1
          if wd="dword" then a=4 : ptf=1
          if wd="word"  then a=2 : ptf=1
          if wd="byte"  then a=1 : ptf=1
               '
        elseif flt>1 then
          '
          '==========
          'SIMD TYPES
          '==========
          '
          if instr(" word dword qword eword "," "+wd+" ")>0 then 
            ers="SIMD instructions have implicit operand sizes":ert=31: goto exita
          end if
          '
        end if
        '
        '======================
        'VALIDATED OPERAND TYPE
        '======================
        '
        if a then
          wr=word(s,m)
          if wr="ptr" then i=m
          if wr="pointer" then i=m
          wk=a:wd=word(s,i)
          if (pn<6)and(ascw<>91) then
            v=regid(wd,k)
            if v>=0 then
              if (wk>1)and(pn>2) then b1+=1
                if b0>-1 then goto op1reg ' movsx movzx
                if k<>a then
                  ers="wrong size for this register: "+wd:ert=31: goto exita
                end if
                goto op1reg
              end if
            end if
          end if
          wk1=wk
          rg=c

          '===============================
          'MEMORY OPERAND AS FIRST OPERAND
          '===============================
            if wd="[" then
            if pn=3 then
              if flt=2 then ers="Expecting mmx1..7 register first":ert=31: goto exita
              if flt=3 then ers="Expecting xmm1..7 register first":ert=31: goto exita
              ers="Expecting register first":ert=31: goto exita
            end if
            if wk=2 then if flt=0 then pfx66(pfx,lp)
            di=0: goto nextop
          end if
          '
          if flt=1 then ers="Expecting '[..]'": ert=16: goto exita
          if pn=6 then ers="Expecting memory operand first [...],reg":ert=31: goto exita
          if pn=7 then ers="Expecting memory operand [...]":ert=31: goto exita
        end if




        '==========================
        'IMMEDIATE AS FIRST OPERAND
        '==========================


        if v<0 then
          if pn=3 then ers="Expecting register first ":ert=31: goto exita
        end if
        '
        if (v<0)and(ima>0) then
          if pn>1 then
           ers="Expecting  a register or [mem operand]":ert=31: goto exita
          end if
          wordeval(s,swd,i)
          if nan then ers="Unidentified "+wd:ert=10: goto exita
          if ert then goto exita
          v=dv
          ws=0
          if (v<-128)or(v>127) then ws=1
          if ws=0 then co=hexb(v)
          if ws=1 then co=hexl(dv)
          if flot then
            co=flos+str(dv) : ws=1 ' floating pt
          END IF
          '
          if im=&h68 then
            ' immed push
            if ws=0 then b1=im+2 ' s
            if ws>0 then b1=im   ' w
            co=hexb(b1)+co: goto addcode
          end if
          ers="This operand cannot be used in this position": ert=10: goto exita
        end if



        '=========================
        'REGISTER AS FIRST OPERAND
        '=========================



        '======
        op1reg:
        '======


        if v>=0 then
          if rexi then
            rex=rexcode(v,wk)
          end if
          rg=v
          if sb>0 then
            if wk>=4 then co=hexb(sb+rg) : goto addcode
            '
            if (sb=&h50)or(sb=&h58) then ers="byte push/pop not possible ":ert=11: goto exita
          end if
          '
          if pn=1 then
            '
            'INC DEC
            '-------
            '
            if (wk>=1)and(wk<=8) then
              if (wk>1)and(flt=0) then b1 or = 1
              if b0>=0 then co=hexb(b0)
              md=&hc0
              b2=md+c*8+rg
              co+=hexb(b1)+hexb(b2)
              goto addcode
            end if
            if co="" then ers="Wrong operand size "+wd:ert=11: goto exita
          end if
          '
          a=ascn
          '
          if a<>44 then
            if pn=13 then 'implicit  ,1 shift
              ws=0:if wk>1 then ws=1
              co=hexb(b1+ws)+hexb(&hc0+c*8+rg)
              goto addcode
            end if
            ers= "Expecting comma and operand": ert=10: goto exita
          end if
          '
          i+=1 ' skip comma
          '
          wk1=wk
          if (flt=0)and(pn<3) then di=2
          wd=word(s,i)
          a=ascn
          '
          if a=58 then k=SegOverride(wd) : if k then pfx=hexb(k)+pfx:lp=1:i+=1:wd=word(s,i)
          '
          if wd="[" then
            if wk>128 then wk=1 ' segregs etc
            if pn=4 then ers="Second operand must be a register":ert=15: goto exita
            if pn=11 then 
              ers="operand 2 must be a register,operand 3 is cl or 8 bit value "
              ert=15: goto exita
            end if
            goto nextop
          end if




          '==========================
          'REGISTER AS SECOND OPERAND
          '==========================

          rm=regid(wd,wk)

          if rm<0 then
            '
            'CHECK FOR OTHER KINDS OF REGISTERS
            '----------------------------------
            '
            if flt>1 then rm=xmmxid(wd,wk)
            if pn=14 then
              '
              'MOVMSKB
              '
              if rm>=0 then
                if rm>7 then rex or=&h44
                co=hexb(b1)+hexb(&hc0+rm*8+rg): goto addcode ' swapped rm and rg positions
              end if
              ers="Expecting general reg then mm? ":ert=11: goto exita
            end if
            '
            if pn=15 then
              'pextr
              if ascn<>44 then ers="Expecting 8 bit value as third operand":ert=10: goto exita
                i+=1:wd=word(s,i):v=wval(wd)
                if v>255 then ers="Expecting 8 bit value":ert=10: goto exita
                b1=im:co=hexb(&hc0+rm*8+rg)+hexb(v): goto encode ' swapped rm and rg positions
              end if
            end if

            if (rm<0)and(b1=&h88)and(lp=0) then
              rm=sregid(wd,wk)
              if rm>=0 then
                if wk1>=128 then ers="Expecting general purpose reg or mem [..]":ert=16: goto exita
                v=sregid(wd,wk) ' with di
                if wk=129 then b1=&h20: b0=&h0f ' from cr
                if wk=130 then b1=&h21: b0=&h0f ' from  dr
                if wk=131 then b1=&h8c:         ' from segreg
                di=0:swap rg,rm
              end if
            end if
            '
            '=============================
            'IF SECOND REGISTER IDENTIFIED
            '=============================
            '
            if rm>=0 then
              '
              if rexi then
                a=rex
                if (a and 1) then a+=3 'SHIFT B BIT TO R BIT
                rex=rexcode(rm,wk) or a
              end if
              '
              if (wk>128)or(wk1>128) then wk=1:wk1=1
              if (wk1<>wk)and(pn=2) then 
                if flt=0 then ers="Register size mismatch":ert=31: goto exita
              end if
              if (wk1<>4)and(wk1<>8)and(wk<>2) then wk=1 '??
              if (rsf<>0)and(wk<>0)and(rsf<>wk) then
                if rsf=4 then ers="Not expecting 8 bit register":ert=31: goto exita
                if rsf=1 then ers="Expecting 8 bit register":ert=31: goto exita
              end if
              '
              ' data register direct
              '
              if pn=13 then
                '
                if (rm<>1)and(wk<>1) then
                  ers="Expecting cl register or shift 1..64 ":ert=15: goto exita
                end if
                di=2
                rm=rg : rg=c
               if wk1>1 then b1 or = 1
               'itr AH BH CH DH not accessible in 64 bit mode eg: shr ??
              end if
              '
              '
              '=================================
              'CHECK FOR THIRD IMMEDIATE OPERAND
              '=================================
              '
              if (pn=10)or(pn=11)or(pn=12)or(pn=15) then
                a=ascn
                if a<>44 then
                  if pn=12 then co=hexb(&hc0+rg*8+rm)+co : goto encode '2 operand form
                  ers="Expecting third operand":ert=16: goto exita
                end if
                i+=1
                wd=word(s,i):a=ascw
                wordeval(s,swd,i):v=dv
                di=0:wk=0
                if nan=0 then 
                  b1=im
                  if pn<>12 then co=hexb(v)
                    if pn=12 then
                      b0=-1
                      if (v>=128)or(v<-128) then b1=&h69 : co=hexl(dv) else b1=&h6b : co=hexb(v)
                    end if
                  end if
                  if nan then
                    if pn=10 then ers="Expecting an 8 bit value as third operand":ert=16: goto exita
                    if (wd<>"cl") then ers="Expecting cl register ":ert=16: goto exita
                  end if
                end if 'THIRD OPERAND

                md=&hc0
                b1+=di
                if (pn=4)and(wk>1) then b1+=1
                b2=md+rg*8+rm
                co=hexb(b2)+co
                goto encode
            end if



            '===========================
            'IMMEDIATE AS SECOND OPERAND
            '===========================

            '======
            regimm:
            '======


            a=ascw
            if v<0 then
              if ima<1 then
                if(a>44)and(a<58)and(a<>47) then ers="Not expecting a number here": ert=31: goto exita
              end if
            end if
            if ima>0 then
              ws=0:se=0
              if a=35 then
                'load immediate address
                co=" "+wd
                '
                if wk1<4 then ers="#symbols only valid with 32+ bit regs":ert=11: goto exita
                  di=0:b1=im:wk=wk1
                  co=hexb(&hc0+ic*8+rg)+co
                  goto encode
                end if
                '
                wordeval(s,swd,i): if ert then goto exita
                '
                if nan then
                  if (a<>46)and(a<>45)and(a<>48) then
                    if wk1<4 then ers="label offsets only valid with 32 or 64 bit regs":ert=11: goto exita
                    wk=wk1
                    b1=im : co=hexb(&hc0+ic*8+rg)+" ga "+wd : goto encode
                  end if
                end if
                '
                v=dv
                ws=0
                if (v<-128)or(v>255) then ws=1 'REQUIRES LONG
                if ws=0 then co=hexb(v)
                if ws=1 then co=hexl(dv)
                '
                'REQUIRES BYTE
                '
                if (wk1=1)or(ima=8) then
                  if ws=1 then ers="Value out of range "+str(v):ert=12: goto exita
                  co=hexb(v)
                end if
                '
                if (wk1>1)and(pn<3) then
                  ws=1 : se=2                     'ASSUME LONG
                  if (v<-128)or(v>127) then se=0  'REQUIRES LONG
                  if ima=2 then se=0              'FORCE LONG
                  '
                  if se=2 then co=hexb(v) ' 
                  if se=0 then
                    if wk1=2 then co=hexw(v)
                    if wk1>=4 then co=hexl(dv)
                  end if
                  '
                  if flot then co=flos+str(dv) ': qq co,flot
                end if
                if wk1=2 then
                  if (dv>=2^16)or(dv<-2^15) then ers="Value out of range for 16 bit number":ert=10: goto exita
                end if
                if (wk1=4)and(flot=0) then
                  if (dv>=2^32)or(dv<-2^31) then ers="Value out of range for 32 bit number":ert=10: goto exita
                end if
                if pn=13 then
                  if (v<0)or(v>64) then ers=" bit-shift value out of range 1..32/64 ":ert=14: goto exita
                  b1=im:se=0:if wk1>1 then ws=1
                end if
                md=&hc0
                b1=im + se + ws
                b2=md+ic*8+rg
                co=hexb(b2)+co
                di=0:wk=0
                goto encode
            end if

            if ascn<>91 then
              '
              'IF RIP THEN ASSUME TO BE LABEL
              '
              if rip then
                if fwd then w1=" gf " else w1=" gl "
                if (rex and 1) then rex+=3
                co=hexb(rg*8+5)+w1+wd : goto encode
              end if
              '
              ers="Can't identify next operand ' ":ert=11: goto exita
              '
            end if
            goto nextop
        end if ' end of reg as first operand







  '=================================
  'MEMORY AS FIRST OR SECOND OPERAND
  '=================================






  '======
  nextop:
  '======






  if (rex and 1) then rex+=3 'SHIFT B BIT TO R BIT

  '-------------------
  ' [ebx+ecx*4+20],adx
  '-------------------


  if pn=14 then ers="Expecting reg,mmx not memory":ert=11: goto exita


  if wd="[" then

    ads="" : dss="" : se=0 : id=-1 : sc=0 : bs=-1 : md=0


    '----------------------
    dreg1: ' FIRST REGISTER
    '======================

    wd=word(s,i):a=ascw
    if a=93 then ers="Empty [] ":ert=12: goto exita
    '
    rm=regid(wd,nn)
    if rm<0 then
      rm=xmmxid(wd,nn)
        if rm<0 then rm=sregid(wd,nn)
        if rm>=0  then ers="mem operands require eax..edi registers":ert=13: goto exita
        '
        goto doffs 'OFFSET ONLY
        '
    end if
    '
    if nn=1 then ers="Need 32 bit register": ert=12: goto exita
    '
    wd=word(s,i):a=ascw

    'REGISTER, INDEX OR OFFSET?

    if a=42 then id=rm : goto dscale 'THIS IS AN INDEX BUT NO BASE YET
    if a=93 then goto dendbrak       'END OF OPERAND, SINGLE REG ONLY, MAY NOT REQUIRE SIB
    if a<>45 then wd=word(s,i)       'DROP THRU FOR REGISTER OR OFFSET


    '----------------------------------------------
    dreg2: 'OFFSET OR SECOND REGISTER REQUIRING SIB
    '==============================================

    re=regid(wd,nn)
    '
    if re<0 then
      re=xmmxid(wd,nn)
      if re<0 then re=sregid(wd,nn)
      if re>=0  then ers="mem operands require eax..edi registers":ert=13: goto exita
      '
      goto doffs 'ASSUME ITS AN OFFSET
      '
    end if
    '
    bs=rm 'FIRST REGISTER TO SIB BASE
    id=re 'SECOND REGISTER TO SIB INDEX

    '
    '======
    dreg2a:
    '======
    '
    if nn=1 then ers="Need 32bit register": ert=12: goto exita
    '
    wd=word(s,i):a=ascw
    if a=42 then goto dscale               'MAY BE SCALED
    if a=45 then goto doffs                'ITS AN OFFSET
    if a=43 then wd=word(s,i) : goto doffs 'ITS AN OFFSET
    if a=93 then goto dendbrak             'END OF OPERAND
    '
    ers="Syntax error in memory operand" : ert=16 : goto exita



    '===========================================
    dscale: ' SCALE FOR FIRST OR SECOND REGISTER
    '===========================================


    '
    'CHECK IF SCALE ALREADY DEFINED
    '
    if sc>1 then ers="Only one register may be scaled" : ert=15: goto exita
    '
    wd=word(s,i)
    sc=wval(wd) ' literal scale
    k=0: if (sc=1)or(sc=2)or(sc=4)or(sc=8) then k=1
    if k=0 then ers="Invalid scale (1 2 4 8): "+str(sc): ert=12: goto exita
    wd=word(s,i) : a=ascw
    if a=45 then
      goto doffs 'OFFSET FOLLOWS
    elseif a=43 then
      wd=word(s,i) : a=regid(wd,nn)
      if a>=0 then id=rm : bs=a : goto dreg2a: 'SECOND REGISTER (SIB BASE) FOLLOWS SCALE 
      goto doffs 'OFFSET FOLLOWS
    end if 
    goto dendbrak 'OTHERWISE NO OFFSET


    '==============
    doffs: ' OFFSET
    '==============

    a=ascw
    if a<>35 then
      wordeval(s,swd,i) : v=dv
      'i=swd : v=metaval(s,i,wd) ...
      'if nan then ers="Expecting an offset value" : ert=12
      if ert then goto exita
      if (v>=-128)and(v<128) then md=&h40:ads=hexb(v)
      if (v<-128)or(v>127) then md=&h80: ads=hexl(dv)
    end if
    ' short or long dsl
    if a=35 then
      ads=" "+wd : md=&h80 ' bound literal
    end if
    wd=word(s,i) ' expecting ']'



    '===============================
    dendbrak: 'END OF MEMORY OPERAND
    '===============================

    if wd<>"]" then ert=12: ers="Expecting  ']' ": goto exita
    if ascn<>44 then
      if pn=13 then if wk1>1 then b1 or=1
      goto dexit ' b1 the same. assume ,1 for single bit shift
    end if
    i+=1
    wd=word(s,i)
    if (pn=1)or(di>0) then ers="comma found, surplus operand":ert=12: goto exita



    '==============================
    secondop: ' A REGISTER OR VALUE
    '==============================

    v=regid(wd,wk)

    if v<0 then
      if flt>1 then 
        v=xmmxid(wd,wk)
        if v>=0 then
          ' reverse direction
          if (pn<>4)and(pn<>6) then
            if flt=2 then b1+=16
            if flt=3 then b1+=1
          end if
          '
          if pn=15 then
            'pextr
            rg=v
            if ascn<>44 then ers="Expecting 8 bit value as third operand":ert=10: goto exita
            i+=1:wd=word(s,i):wordeval(s,swd,i):v=dv
            if (v>255)or(nan=1) then ers="Expecting 8 bit value":ert=10: goto exita
            b1=im:dss=hexb(v): goto dexit
          end if
        end if
      end if
      '
      if v<0 then
        if (pn=4)and(ima<1) then ers="Second operand must be a register":ert=15: goto exita
        if pn=11 then ers="Operand 2 must be a register, Op 3 is either cl or 8 bit value":ert=15: goto exita
      end if
      ' 
      if (pn=10)or(pn=12)or(pn=15) then
        'third operand
        wordeval(s,swd,i):v=dv : if ert then goto exita
        ws=0:wk=0
        if nan=0 then
          if pn=12 then
            b0=-1
            if (v>=128)or(v<-128) then b1=&h69 : dss=hexl(dv) else b1=&h6b : dss=hexb(v)
            goto dexit
          end if
          b1=im:dss=hexb(v): goto dexit
        end if
        ers="Expecting an 8 bit value as third operand":ert=16: goto exita
      end if
      '
      if (v<0)and(flt=0)and(b1=&h88)and(lp=0) then
        v=sregid(wd,wk)
        if v>=0 then
          if wk=131 then b1=&h8c:wk=1:wk1=1 ' from segreg
          if (wk=129)or(wk=130) then ers="These registers move to general purpose  regs only":ert=16: goto exita
        end if
      end if
    end if
    '
    if v>=0 then
      '
      if rexi then
        a=rexcode(v,wk)
        if (a and 1) then a+=3 'SHIFT B BIT TO R BIT
        rex or=a
      end if
      '
      if wk=2 then
        pfx66(pfx,lp)
        if flt>1 then ers="Cant use a 16 bit register here":ert=12: goto exita
      end if
      'allow this
      'if ptf then if ima<>8 then ers=" word size is determined by register ":ert=13: goto exita
      if pn=13 then
        if (v<>1)and(wk<>1) then ers="Expecting cl register or shift 1..64 ":ert=15: goto exita
        wk=wk1
        if wk>1 then b1+=1
        di=2
        rg=c
        goto dexit
      end if
      rg=v
      wk1=wk
      '
      if (pn=10)or(pn=11) then
        a=ascn
        if a<>44 then ers="Expecting third operand":ert=16: goto exita
        i+=1
        wd=word(s,i):a=ascw
        wordeval(s,swd,i):v=dv
        ws=0:wk=0
        if nan=0 then b1=im:dss=hexb(v): goto dexit
        if pn=11 then if wd<>"cl" then ers="Expecting cl register (or 8 bit shift value)": ert=16: goto exita           
        goto dexit
      end if
      '
      if (pn=4)and(wk>1) then b1+=1
        goto dexit
    end if

    '=======
    immedop:
    '=======

    if ima<1 then ers="Must be a register ":ert=12: goto exita

    a=ascw

    if a=35 then
      dss=" "+wd
      if wk1<4 then ers="#symbols only valid with 32+ bit operands":ert=11: goto exita
      ws=1: b1=im+ws:rg=ic: goto dexit
    end if

    wordeval(s,swd,i): if ert then goto exita
    v=dv

    if nan then
      if wk1<4 then ers="label offsets only valid with 32+ bit operands":ert=11: goto exita
      rg=ic : ws=1 : b1=im+ws : dss=" ga "+wd
      goto dexit
      '
    end if

    ws=0:se=0
    if (wk1=1)or(ima=8) then
      if (ws=1)or(a=35) then ers="Value out of range ":ert=12: goto exita
      co=hexb(v)
    end if

    if wk1=2 then
      if (dv>=2^16)or(dv<-2^15) then ers="Value out of range for 16 bit number":ert=10: goto exita
    end if
    '
    if wk1=4 then
      if flot=0 then if (dv>=2^32)or(dv<-2^31) then ers="Value out of range for 32 bit number":ert=10: goto exita
    end if

    rg=ic

    if (wk1>1)and(pn<3) then
      ws=1:se=2 ' assume short sign extended
      if (v<-128)or(v>127) then se=0 ' long
      if ima=2 then se=0
      if se=2 then co=hexb(v) ' 
      if se=0 then
        if wk1=2 then co=hexw(v)
        if wk1>=4 then
          if flot=0 then co=hexl(dv)
          if flot then co=flos+str(dv)
        end if
      end if
    end if
    '
    if (wk1=8)and(cpuw=4) then
      ers="Invalid ptr size: qword":ert=13: goto exita
    end if
    '
    if wk1=10 then
      ers="Invalid ptr size: eword":ert=13: goto exita
    end if

    if pn=13 then
      if (v<0)or(v>64) then ers=" bit-shift value out of range 1..32/64 ":ert=14: goto exita
      ws=0:if wk1>1 then ws=1
      dss=hexb(v):b1=im+ws: goto dexit
    end if

    ' assume immediate value
    dss=co
    b1=im+ws+se
    '
    '=====
    dexit:
    '=====
    '
   'CHECK FOR FURTHER OPERANDS
    '--------------------------
    '
    a=ascn
    if a=44 then
      ers="Too many operands for this instruction": ert=10: goto exita
    end if
    '
    'DIRECTION OF ASSIGNMENT
    '-----------------------
    '
    if (di=2)and(flt=0) then
      b1+=2 'is a first op with a reg source
    end if
    '
    '
    'CHECK IF A SIB IS REQUIRED:
    '---------------------------
    '
    if (bs>=0)or(id>=0) then
      rm=-2 'SIGNAL EXPLICIT SIB ENCODING TO FOLLOW
    end if
    '
    w1="" 'POTENTIAL SIB BYTE
    '
    '
    'RM IS ESP AND THEREFORE REQUIRES SIB ENCODING
    '---------------------------------------------
    '
    if rm=4 then
      bs=4 : rm=-2 'MAKE USE OF SIB BASE (AND NULL THE INDEX REG)
    end if

    '
    'NON SIB EBP MUST HAVE AN OFFSET
    '-------------------------------
    '
    if rm=05 then
      if md=0 then
        md=&h40 : ads=" 00"
      end if
      goto nsib
    end if
    '
    '
    'OFFSET ONLY: (64BIT MODE COMPATIBLE)
    '------------------------------------
    '
    if (md>0)and(rm=-1) then
      '
      'RIP OR ABSOLUTE ADDRESSING
      '
      if rip then
        '
        '64 BIT CPU MODE ONLY
        '
        ert=144 : ers="RIP Addressing inappropriate here." : goto exita
        '
      else 'NON RIP ADDRESSES
        '
        'MAKE USE OF SIB FOR OFFSET-ONLY ADDRESSING
        '
        'THIS IS COMPATIBLE WITH BOTH 32 AND 64 BIT MODE
        '
        md=0 : rm=4 : w1=hexb(&h25) : goto nsib
        '
      end if
    end if
    '
    '
    'SIB ENCODING PROCEDURE
    '======================
    '
    if rm=-2 then
      '
      if (bs>=0)or(id>=0) then
        '
        'ESP IN THE INDEX FIELD MUST BE MOVED
        '------------------------------------
        '
        if id=4 then
          if sc>1 then
            ers="Cant have scaled ESP/RSP/R12 ":ert=12: goto exita
          elseif (bs<>4)and(sc<=1) then
            swap id,bs 'IF THE SCALE IS 1 THEN BASE AND INDEX CAN BE SWAPPED
          else 
            ers="Cant have ESP as both index and base in SIB" : ert=13 : goto exita
          end if
        end if
      end if
      '
      '
      'SIB BASE EBP MUST HAVE AN OFFSET
      '--------------------------------
      '
      if bs=5 then
        if id=5 then
          ers="Cant have EBP as both index and base in SIB" : ert=13 : goto exita
        elseif ((id<0)or(sc<=1))and(md=0) then
          swap bs,id 'EBP CAN BE SWAPPED INTO THE INDEX FIELD
        elseif md=0 then
          md=&h40 : ads=" 00" 'ADD A NULL OFFSET
        end if
      end if
      '
      'NO SIB INDEX REG SPECIFIED
      '--------------------------
      ' 
      if id<0 then id=4 'CODING FOR NO INDEX
      '
      '
      'INDEX  BUT NO BASE
      '------------------
      '
      'MUST HAVE 32 BIT DISPLACEMENT
      '
      if bs<0 then
        if md=0 then ads=" 00 00 00 00"  'MUST SPECIFY DISPLACEMENT
        if md=&h40 then ads+=" 00 00 00" 'MUST BE 32 BIT DISPLACEMENT
        md=0 : bs=5                      'CODING FOR NO BASE BUT 32 DISPLACEMENT
      end if
      '
      '
      'SCALE ENCODING
      '---------------
      '
      if sc<=1 then
        sc=&h00
      elseif sc=2 then
        sc=&h40
      elseif sc=4 then
        sc=&h80
      elseif sc=8 then
        sc=&hc0
      end if
      '
      '
      'COMPOSE REX FOR SIB REGISTERS
      '-----------------------------
      '
      if id>=8 then id-=8 : rex or=2 'EXTENDED INDEX REG
      if bs>=8 then bs-=8 : rex or=1 'EXTENDED BASE REG
      '
      'COMPOSE SIB
      '-----------
      '
      
      rm=4 : w1=hexb(sc+id*8+bs)
      '
    end if
    '
    '=====================
    nsib: 'COMPOSE OPCODES
    '=====================
    '
    if rm>=8 then rm-=8 : rex or=1 'EXTENDED RM REG
    co=hexb(md+rg*8+rm)+w1+ads+dss
    goto encode
    '
  end if   ' ....]

  '---------------
  'end of operands
  '---------------


  '======
  encode:
  '======

  if (flt=0)and(pn<3)and(wk>1) then b1=b1 or 1 ' word size ' alt pn<5
  if (co="")and(lp=0) then ers="Unidentified Operand or none":ert=12: goto exita
  co=hexb(b1)+co
  if b0>=0 then co=hexb(b0)+co : b0=-1
  if dn>=0 then co+=hexb(dn) : dn=-1 '3dnow postfix


  '=======
  addcode:
  '=======

  if rex then
    '
    a=asc(pfx,2)
    if a>=&h36 then
      pfx=left(pfx,3)+hexb(rex)+mid(pfx,4)
    else
      pfx=hexb(rex)+pfx
    end if
    rex=0 : lp=1
      '
  end if
  '
  if lp then co=pfx+co : pfx="" : lp=0
  '
  '
  ' now check for uninterpreted stuff
  '
  if len(co)=0 then 
    if pn>0 then ers="Unresolved operand type "+wd:ert=15: goto exita
  end if

  '=====
  flush:
  '=====

  '------------------------
  'CODE VERIFICATION SYSTEM
  '------------------------
  '
  ' correct opcodes are contained in the comment using prefix !? 
  ' eg : ; !? b0 2a
  '
  m=0:b=len(co)+1:k=0
  do
    a=asc(s,i)
    if a=9 then a=32 ' tab ignore
    if (a=58)and(m=0) then mid(s,i)=chr(13):a=13 ' separator colon
    if a<=13 then exit do
    if (m=2)and(a>32) then
      'compare code with commented code
      wd=word(s,i)
      v=wval("&h"+wd)
      wd=word(co,b)
      if wval("&h"+wd)<>v then k=1:m=1 'DISAGREE
      continue do
    end if
    if a=33 then
      if (m=1)and(vew=2) then
        i+=1:a=asc(s,i)
        if a=63 then m=2:b=1:i+=1
        continue do
      end if
    end if
    if isc(a) then m=1
    if (a>32)and(m=0) then
      'j-=len(co)
      ers="Junk after instruction: "+mid(s,bgl,i-bgl)+cr+">>"+co
      ert=200: goto exita
    end if
    'if a=9 then a=32 ' tab ignore
    'if a<=13 then exit do
    i+=1
  loop
  if (k=1)or(b<=len(co)) then co+=" "+chr(ct1)+" !! DISAGREE"


  '======================
  'ADDITIONS TO CODE LINE
  '======================


  if vew=0 then wr=cr ' EXCLUDE COMMENTS
  '
  'APPEND COMMENTS
  '---------------
  '
  if vew>0 then
    '
    'APPEND CLIPPED COMMENTS
    '-----------------------
    '
    a=i-bgl
    if a>64 then a=64 ' clip src comment
    if ncm then a=0 ' NO COMMENT
    '
    'PAD ASSEMBLY CODE TO 32 CHARS
    '-----------------------------
    '
    wr=space(32-len(co))+chr(ct1)+"  "+mid(s,bgl,a)+cr ' append source as comment

    'BLANK OUT TABS,CR,LF ETC INSIDE COMMENT
    '---------------------------------------
    v=0
    m=len(wr)-2
    do
      v+=1:if v>m then exit do
      a=asc(wr,v)
      if a=9 then a=32 ' tab ignore
      if a<32 then mid(wr,v)=" "
    loop
    ncm=0
  end if
  '
  'ADJUST SIZE OF BUFFER IF NECESSARY
  '----------------------------------
  '
  co+=wr : a=len(t): b=len(co)
  if j+b>a then t+=space(b+4000)
  '
  'ADD CODE LINE
  '-------------
  '
  mid(t,j)=co: j+=b ' add code

  '=====
  exita:
  '=====
    
  '
  'CHECK FOR ERROR MESSAGES
  '------------------------
  '
  if ert>0 then
    if ert=25 then ers="malformed number (. point) "+wd
    if ert=26 then ers="malformed number (- sign) "+wd
    if ert=27 then ers="malformed number (E exponent) "+wd
    if ert=101 then ers="Macro undefined or out of scope:  "+wd
    if ert=102 then ers="Macro recursion suspected:  "+wd
    '
    '
    'CAPTURE REST OF CURRENT LINE
    '----------------------------
    '
    v=i : endline(s,i)
    '
    'COMPLETE ERROR MESSAGE
    '----------------------
    '
    ers=htb+mid(s,bgl,i-bgl)+"!!  "+ers+cr
    if len(lbw)  then ers+=" ; AFTER:  "+htb+lbw+cr
    'if len(lnmk) then ers+=" ; LINE:    "+htb+lnmk+cr

    ersl+=ers+cr 'BUILD ERRORS LIST
    '
    'DECIDE MODAL BEHAVIOUR
    '----------------------
    '
    if vew<2  then i=k: exit do ' STOP ASSEMBLY NOW
    if vew>=2 then mid(t,j)=ers: j+=len(ers) ' ADD ERROR MESSAGE AS COMMENT THEN CONTINUE
    '
    'CHECK BUFFER SPACE
    '------------------
    '
    a=len(t) : b=len(ers)
    if j+b>a then t+=space(b+4000)
    '
    'ADD ERROR MESSAGE
    '-----------------
    '
    mid(t,j)=ers: j+=b



    '==============================
    'CLEARDOWN FOR NEXT INSTRUCTION
    '==============================
    '

    ert=0 : ers=""
    b0=-1 : b1=-1 : b2=-1 : dn=-1 : lp=0 : pfx=""
    end if


  loop ' main loop
  '
  '======
  'FINISH
  '======

  term:

  ers=ersl : ersl=""


  'if (ert=0)and(rtf=0) then ers="Missing ret":ert=20
  '
  t=left(t,j-1)
  '
  if vew>0 then
    if vwb then
      if vwe=0 then vwe=j
      t=mid(t,vwb,vwe-vwb)
    end if
  end if
  '
  if ert=0 then if len(t)=0 then ers="Empty":ert=10
  '
  if ert>0 then
    if vew=0 then t="c3"
  end if
  '
  function=t


  '===========
  'DIAGNOSTICS
  '===========
  '
  'DIM as sys FI=3
  'open "t.txt" for output as FI : print #FI,"ASSEMBLED  "+t : close FI
  'QQ LEFT(T,1024),777
    '
end function






