


  '        ##
  '       ####
  '      ######
  '     ########
  '    ##########
  '   ############
  '  ##############
  ' ################
  'GLOBAL DEFINITIONS
  '==================


  '-----------------
  'GLOBAL DATA TYPES
  '=================

  type hashref
    h  as sys   ' hash code
    l  as sys   ' linked list index (fwds only)
    m  as sys   ' macro list index
   'e  as sys   ' storage for equates (shortform)
    b  as sys   ' brc nesting level
    t  as sys   ' tally
  end type

  type preced
    pr as sys
    sw as sys
    le as sys
  end type

  type macotype
    a as sys
    b as sys
    c as sys
    d as sys
    e as sys
    f as sys
    g as sys
    h as sys
    i as sys
    j as sys
    k as sys
  end type

  type stack
    a as sys
    b as sys
    c as sys
    d as sys
    e as sys
    f as sys
    g as sys
    h as sys
    i as sys
    j as sys
    k as sys
    l as sys
  end type

  type composs
    i as sys
    a as sys
  end type



  '-----------------
  'GENERAL CONSTANTS
  '=================

  const as sys   iq4=250      'INTERNAL QUOTE CODE
  const as string sq=chr(252) 'TRANSFER MARKER START
  const as string eq=chr(253) 'TRANSFER MARKER END
  const as string iq=chr(iq4) 'INTERNAL QUOTE MARK
  '
  const as string htb=chr(9)
  const as string crg=cr+";"+cr
  const as string qu=chr(34)
  const as string cm=chr(44)
  const as string sp=cr+"("+cr
  const as string ep =cr+")"+cr
  const as string stp=" : "
  const as string snp=chr(1) 'SNAP-OFF MARKER
  const as string sep =" "




  'OP CODING TO JUMP INSTRUCTION = <> > >= <= <

  const as string jmpname=_
  " 12 jb  "_
  " 13 jae "_
  " 14 jz  "_
  " 15 jnz "_
  " 16 jbe "_
  " 17 ja  "_
  " 1C jl  "_
  " 1D jge "_
  " 1E jle "_
  " 1F jg  "_
  " 92 jae "_
  " 93 jb  "_
  " 94 jnz "_
  " 95 jz  "_
  " 96 ja  "_
  " 97 jbe "_
  " 9C jge  "_
  " 9D jl  "_
  " 9E jg  "_
  " 9F jle "_
  ""



  '--------------------
  'FLOATING POINT MACROS
  '====================

  const as string powers=_
  "sub esp,16 : fstcw [esp] : fstcw [esp+2] : or [esp],0xc00 : fldcw [esp]"+cr+_
  "fxch st(1) : fst qword [esp+8] : fabs : fyl2x : fld st(0),st(0) : frndint : fsub st(1),st(0)"+cr+_
  "fxch st(1) : f2xm1 : fld1 : faddp st(1),st(0) : fscale : fstp st(1),st(0)"+cr+_
  "and byte [esp+15],128  : jz fwd nng : fchs : .nng : fldcw [esp+2] : add esp,16"




  '========
  'CAPACITY
  '========

  '
  'MAXIT=100K: ABOUT 10-20 MEG MEMORY SPACE INCLUDING ASSOCIATED STRINGS
  '
  const as sys maxit=100000  'size of entity array
  const as sys smaco=10      'elements in maco
  const as sys smach=4       'elements in macho data structure
  const as sys smacd=smaco-1 'dim size spec
  const as sys omacs=smaco-4 'offset to maco string pointers (entity strings)



  '======
  'ARRAYS
  '======


  'ENTITY STORAGE
  '
  '===================================================================
  global as sys    opd(999,9), ope   'Assembly code data
  global as string  opn(999),ops(999) 'Assembly code data
  '-------------------------------------------------------------------
  global as sys    maco(maxit,smacd) ' buffer for all definitions
  global as hashref mach(maxit)       ' hashes
  global as composs compos(511)       ' composite/compound symbols
  '===================================================================
  '
  '
  'GENERAL

  '===================================================================
  global as sys    prc(127,1)    ' precedence buffer 0=op 1= pr level
  global as sys    ctb(99)       ' control block type
  global as stack   st(99)       ' general nesting stack
  global as stack   stk          ' general nesting stack
  global as sys    sta(99)       ' precedence stack
  global as sys    slc(99)       ' `select` stack cas
  global as sys    sle(99)       ' `select` stack enumeration
  global as preced  pre(99)      ' operator precedence
  global as string  nes(99)      ' nested names
  global as string  nxs(99)      ' nested next step
  '-------------------------------------------------------------------
  global as string  paw(99)      ' param wg word
  global as string  pas(99)      ' parameter expression
  global as sys    pao(99)       ' param last operator
  global as sys    pat(99)       ' param type
  global as string  pav(99)      ' param conversion code
  global as string  pax(99)      ' param idirect addr code
  '-------------------------------------------------------------------
  global as sys    libu(511)     ' library use flag
  global as sys    libo(511)     ' library offset list
  global as string  libs(511)    ' library name list
  global as string  libl(511)    ' library used proc list
  '-------------------------------------------------------------------
  global as string  wva(99)      ' var / dim statements
  global as sys    mle=512       ' macro link list boundary
  global as sys    scop(99,7)    ' nesting scope index
  '===================================================================
  global as string  sregs(100)   ' nesting indexers
  global as string  wp(63)       ' macro params
  global as string  ssf(63)      ' include file name
  global as string  sst(63)      ' include (preserve parent text)
  global as string  stb(63)      ' include (preserve included text)
  global as string  ssn(999)     ' include file name log
  global as sys    ssh(999)      ' include content hash log
  global as string  rgp(15)      ' register param macros (for 64 bit fast calls)
  global as string  regn(15)     ' register param names (for 64 bit fast calls)
  global as sys    typl(15)      ' local param type
  global as long   cbrk(63),cbri ' block nests {}
  '===================================================================
  'PROCEDURE FLAGS
  global as sys funi,atf(7),lcl(7),lcls(7),blcl(7),blcls(7),plcl(7),mlcl(7)
  global as sys reto(7),retb,th(7),ml(7),ccp(7)
  global as sys typp(7),noin(7),funn(7),dls(7),dts(7)
  '===================================================================
  global as any ptr psysfuns     ' runtime ebx table base ptr
  global as any ptr sysfuns(1023)' runtime fun table
  global as string  mdl_path     ' 
  '===================================================================
  global as string expwn(999)    ' export labels
  global as string expal(999)    ' export dll symbols
  global as sys    expi(999)     ' export index for sorting
  '===================================================================





'=======================------------
'SIMPLE GLOBAL VARIABLE DESCRIPTIONS
'===================================

'  fq      include file index
'  me      macro list end boundary
'  mp,mq   macro iteration index
'  mc,md  sem codes
'  mct     macro anti recursion counter
'  mex     macro anti recursion source buffer limit
'  swd     start of current word
'  nwd     start of next word
'  ewd     space count at end of word
'  dtf     dot flag for dotted words
'  aoff    aoffl,aoffs' offsets for indexers
'  asce    ascel,asces ' offset ascend/descend flag
'  regs    regsl,regss regst' indexers
'  woff    offset of element
'  voff    offset of variable
'  toff    offset of vf table
'  pwd     previous word including space (for macros)
'  pw      pw procedure word
'  bgl     beginning of current line
'  lct     line count
'  incli ' prevent %params from being substituted in next macro
'  mcf macro param insertion flags
'  nan     not a number flag
'  lmax    macro hash buckets max links
'  ascw    ascii of word
'  ascn    ascii of next word
'  ascy    ascii of symbol
'  elsize variable size from last element
'  varf    variable func mode
'  sigf    signature enable flag
'  sig     signature of func
'  sog     signature of element
'  ow      original word
'  vew     compile mode: 0 normal 2 include source with errors in o2 script (runtime)
'  noop    no operators flag
'  o2h     O2H flag
'  typ     operation type integer float or string
'  tye    type of element
'  xpr     expression flag
'  phr     conditional lhv rhv
'  cpa     comparator flag
'  leni    length of last insertion
'  inpi    forward insertion point
'  clon    clone flag (getas)
'  noo     new flag (getas)
'  lent    length of object (identype)
'  lenw    length of word (word)
'  op      operator coding
'  oq      last operator code
'  ind     indirection
'  wi      with flag
'  bg      beginning of current output line
'  j       output index
'  pt      any pointer
'  nst     nesting index
'  nx     `next` stack index
'  slx    `select` stack index
'  rga    cpu accum select
'  nquot  not a quote flag
'---------------------------------------------
'  wu      global word string
'  wu1     global word string
'  wu2     global word string
'  t       output string
'  wpfx    pointer prefix for byref vars etc
'  wth     `with` assignment prefix
'  asg     assignment string to appent post append to expression
'  asi     assigner/eqator flag
'  wg      last wr pword
'  opg     last op in expression
'  typg    assignment type
'  parp    post array pointering
'  cnc     conditional code
'  cnd     conditional flag
'  jn      join flag
'  tmpst   tmp storage offset
'  fpu     fpu directive flag
'  pc      param stack index
'  cco     calling convention
'  vwb     selected view start
'  vwe     selected view end
'  uk      call compatibility mode
'  libe    library list boundary
'  libr    library name for declared imports
'  impo    import block flag
'   dcl    declaratives flag
'   mth    sub/function/method flag
'   priv   private flag
'   brc    scope nesting index
'------------------------------------------------
'  da      value accumulator
'  dv      value register (64 bit float)
'  qv      value register (64 bit integer)
'------------------------------------------------
'  asgm    multiple assignment flag
'  asgo    offset
'  asgi    stride
'  asgj    structure array stride
'  asgk    structure string offset
'  asgn    structure element offset
'  asgs    structure string
'------------------------------------------------
'  composi composite symbol index index
'  compo   composite symbol flag
' opns     name of operations
' opnsl     operations name list
' adra     adress flag
' lbw      last label
' ipath    includepath
' lpath    librarypath
' nprec    no precedence flag
' nrs      not resolved flag
' dep      dependent code flag
' cnst     constantflag (Const like Dim)
' ovr      inheritance override flag
' ixb      index base
' vtp      virtual table pointer
' bref     byref flag
' ths      implicit this flag
' pef      pe format flag 1=dll 2=exe
' pem      pe mode flag 64=64 bit mode
' pexn     pe file name
' pdr      in procedure flag
' mel      lower boundary for inner local vars
' pps      popstack flag
' tmnt     terminate flag
' dlb      dll list base
' dlbf     dll list base late binding flag
' omo      oxygen io string mode
' rexi     64 bit mode register flag
' expf     export section flag
' rsrf     resource section flag
' indt     indirection of type
' enu      enumeration type indicator
' enuc     enumeration type indicator for case
' lclv     local variables flag
' ary      TYPE array descriptor accum string   
' extn     extern flag, C
' sps      string pool buffer string
' spe      string pool end index
' hlo      header language output
' warg     array offset macro
' cpuw     cpu width 32/64
' spw1     stack pointer width
' spw2     stack pointer width x 2
' pesp     [esp] or [rsp]
' casf     case mode flag
' dvl      default values retrieved from signature
' mess     state command for declarations, dims etc
' mesb     state intrinsic base index for declarations, dims etc
' mest     state local base index for declarations, dims etc
' vaf      carrier for varf (procedures() callcoc()
' vstp     force variable location step increment
' pres     string buffer 'preserve' flag
' minormajor flag for arrays ascending dimensional order (not C std)
' lwmk lnmk  inserted line number
' assx       assign flag
' mph        hash index
' num        generic number format spec
' cas        case flag
' nth        'that' flag suppresses 'this'
' oxypath    'oxygen path list
' hostdll    'oxygen path resolver macro
' bvg        'byval flag in expressions for procedures
' uniq       'unique flag to prevent duplicate definitions (at same nesting level)
' ispr       'expression contains string procedure. flag
' typk       'cast type
' dats       'initialised data block
' datc       'initialised data block item counter
' dati       'initialised data block boundary
' lnkc       'code side data link table
' lnkd       'data side data link table
' nsto       'prevent data being added to data section
' stkb       'stacked bytes - parameters
' dts        'delete temp strings flag
' dls        'delete local strings flag
'===================================================================



'----------------------
'SIMPLE GLOBAL VARIABLES
'======================


  global as sys mc,md,me,mp,mq,mct,mex,swd,nwd,ewd,dtf,aoff,aoffl,aoffs,asce,ascel,asces
  global as sys woff,voff,toff,bgl,lct,incli,mcf,nan,lmax,ascw,ascn,ascy,elsize,varf,vaf,sigf,fq
  global as sys noop,o2h,typ,tye,xpr,phr,cpa,leni,inpi,clon,noo,lent,lenw
  global as sys op,oq,ind,wi,bg,j,opg,typg,asi,nst,nx,slx,rga,parp,nquot
  global as sys lbr=40,rbr=41,iq1=34,iq2=96,iq3=96,ct1=39,ct2=59
  global as sys composi,compo,prec,prl,nsl,ipe,cnc,cnd,jn,tmpst,fpu,pc,cco
  global as sys vwb,vwe,uk,libe,impo,dcl,mth,priv,brc,dep,pps
  global as sys asgk,asgm,asgo,asgi,asgj,asgn,adra,nprec,nrs,cnst
  global as sys ovr,ixb,vtp,bref,ths,pef,pem,pdr,mel,tmnt,dlb,dlbf
  global as sys omo,rexi,expf,rsrf,indt,enu,enuc,lclv,extn,spe,hlo
  global as sys cpuw,casf,mesb,mest,vstp,pres,minormajor,lwmk,lnmk
  global as sys assx,mph,nodel,cas,nth,bvg,uniq,ispr,typk,datc,dati,nsto,stkb

  global as longint qv
  global as double da,dv
  global as any ptr pt

  global as string t,wu,wu1,wu2,ow,regs,regsl,regss,regst,pwd,pw,sig,sog,opns,opnsl
  global as string wpfx,wth,asg,asgs,wg,lbw,ipath,lpath,pexn,libr,ary,sps,warg,dvl,mess
  global as string qeax,qecx,qedx,qebx,qesp,qebp,qesi,qedi,peax,pecx,pesp,pedi,ledi,spw1,spw2
  global as string oxypath, hostdll,dats,lnkc,lnkd


'----------------
sub GlobalClear()
'================
  '
  dim as sys a
  ert=0 : ers=""
  brc=0
  asce=1
  lclv=0
  wth=""
  wi=0
  ths=0 : mel=0
  prec=0
  phr=0
  ipe=0
  nsl=0
  fq=0
  dv=0
  asi=0
  cnd=0
  jn=0
  adra=0
  lbw=""
  pef=0
  nst=0
  pdr=0
  bref=o2h 'default byref
  tmnt=0
  libe=1 : dlb=1 : dlbf=0
  expf=0
  rsrf=0
  enu=0
  enuc=0
  nrs=0
  funi=0
  libr=""
  extn=0
  cas=0
  casf=0
  cnst=0
  cbri=0
  uniq=0
  cpuw=4
  ispr=0
  typk=0
  datc=0
  dati=0
  dats=""
  lnkc=""
  lnkd=""
  stkb=0
  '
  for a=1 to 30 : wva(a)="" : next 'CLEAR DECLARATION BUFFERS
  '
end sub


'
'          ###
'         ## ##
'        ##   ##
'       ##     ##
'      ##       ##
'     #############
'    ##           ##
'   ##             ##
'  ##               ##


opcode_data:



' cpu no operands

data "cbw    ` 98`"
data "cdqe   ` 49 98`"
data "cwde   ` 98`"
data "cwd    ` 99`"
data "cdq    ` 99`"
data "cdqo   ` 49 99`"
data "clc    ` f8`"
data "cld    ` fc`"
data "cli    ` fa`"
data "clts   ` 0f 06`"
data "cmc    ` f5`"
data "cpuid  ` 0f a2`"
data "daa    ` 27`"
data "das    ` 2f`"
data "into   ` ce`"
data "invd   ` 0f 08`"
data "iret   ` cf`"
data "nop    ` 90`"
data "lahf   ` 9f`"
data "popa   ` 61`"
data "popad  ` 61`"
data "popf   ` 9d`"
data "pushf  ` 9c`"
data "pusha  ` 60`"
data "pushad ` 60`"
data "rdmsr  ` 0f 32`"
data "rdpmc  ` 0f 33`"
data "rdtsc  ` 0f 31`"
data "rsm    ` 0f aa`"
data "sahf   ` 9e`"
data "sec    ` f9`"
data "stc    ` f9`"
data "std    ` fd`"
data "sti    ` fb`"
data "wait   ` 9b`"
data "wbinvd ` 0f 09`"
data "wrmsr  ` 0f 30`"
data "xlat   ` d7`"
data "lock   ` f0`"
data "leave  ` c9`"
data "halt   ` f4`"
data "aaa    ` 37`"
data "aad    ` d5 0a`"
data "aam    ` d4 0a`"
data "hlt    ` f4`"
data "aas    ` 3f`"

data "sysenter ` 0f 34`"
data "sysexit  ` 0f 35`"
data "ud2      ` 0f 0b`"

' fpu no operands

data "fabs    ` d9 e1`"
data "fchs    ` d9 e0`"
data "fldz    ` d9 ee`"
data "fld1    ` d9 e8`"
data "fldpi   ` d9 eb`"
data "fsqrt   ` d9 fa`"
data "fsin    ` d9 fe`"
data "fcos    ` d9 ff`"
data "fsincos ` d9 fb`"
data "fptan   ` d9 f2`"
data "fpatan  ` d9 f3`"

data "fclex   ` 9b db e2`"
data "fnclex  ` db e2`"
data "fdecstp ` d9 f6`"
data "fincstp ` d9 f7`"
data "fnop    ` d9 d0`"
data "fprem   ` d9 f8`"
data "fprem1  ` d9 f5`"
data "frndint ` d9 fc`"
data "fscale  ` d9 fd`"
data "fstsw   ` df e0`"
data "ftst    ` d9 e4`"
data "fucompp ` da e9`"
data "fxam    ` d9 e5`"
data "fxtract ` d9 f4`"
data "finit   ` 9b db e3`"
data "fninit   ` db e3`"

data "fcompp  ` de d9`"
data "f2xm1   ` d9 f0`"
data "fldl2e  ` d9 ea`"
data "fldl2t  ` d9 e9`"
data "fldlg2  ` d9 ec`"
data "fldln2  ` d9 ed`"
data "fyl2x   ` d9 f1`"
data "fyl2xp1 ` d9 f9`"
data "fwait   ` 9b`"

' other cpu



' FORMAT:
'-------------------------------------
' flt pn `prefix codes` b1 c ima im ic
'=====================================
' flt=0 genereal instruction
' flt=1 fpu instruction
' flt=2 mmx instruction
' flt=3 xmm instruction
' flt=4 general instruction without di and ws additions
'
' pn=0  undefined
' pn=1  single operand
' pn=2  2 operands
' pn=3  2 operands - the first must be a register
' pn=4  2 operands - the first is an r/m, the second must be a register
' pn=5  2 operands -  the first must be a register
' pn=6  2 operands - the first must be a mem, not a register
' pn=7  1 operand  - must be a mem
' pn=8  undefined
' pn=9  undefined
' pn=10 3 operands - the third must be an 8 bit value eg some xmmx instructions
' pn=11 3 operands - the third must be an 8 bit value or the cl register eg: shld shrd
' pn=12 1 2 or 3 operands - specific to imul
' pn=13 1 or 2 operand bit shift shl ror etc
' pn=14 first reg is general purpose, second reg is xmmx, rg and rm octals are then swapped thus: md-rm-rg (PMOVMSKB)
' pn=15 r/m.xmm,imm8  (pextrb pextrw pextrd pextrq)

'---------------------------------

data "bt    0 4 ` 0f` a3 0 8 ba 4"
data "btc   0 4 ` 0f` bb 0 8 ba 7"
data "btr   0 4 ` 0f` b3 0 8 ba 6"
data "bts   0 4 ` 0f` ab 0 8 ba 5"
data "xadd  0 4 ` 0f` c0 0"
 
data "sgdt  4 7 ` 0f` 01 0"
data "sidt  4 7 ` 0f` 01 1"
data "sldt  4 1 ` 0f` 00 0"
data "smsw  4 1 ` 0f` 01 4"
data "str   4 1 ` 0f` 00 1"
data "verr  4 1 ` 0f` 00 4"
data "verw  4 1 ` 0f` 00 5"
data "cmpxchg   04 04 ` 0f` b0 0"
data "cmpxchg8b 04 07 ` 0f` c7 1"

data "lds  4 3 c5 0"
data "lea  4 3 8d 0"
data "les  4 3 c4 0"
data "lar  4 3 ` 0f` 02 0"
data "lfs  4 3 ` 0f` b4 0"
data "lgdt 4 7 ` 0f` 01 2"
data "lgs  4 7 ` 0f` b5 0"
data "lsl  4 3 ` 0f` 03 0"
data "lss  4 3 ` 0f` b2 0"
data "ltr  4 1 ` 0f` 00 3"
data "lidt 4 7 ` 0f` 01 3"
data "lldt 4 1 ` 0f` 00 2"
data "ldt  4 1 ` 0f` 00 2"
data "ldtr 4 1 ` 0f` 00 2"
data "lmsw 4 1 ` 0f` 01 6"

'---
'sse
'===

data "addps     3 3 ` 0f` 58"
data "addss     3 3 ` f3 0f` 58"
data "andnps    3 3 ` 0f` 55"
data "andps     3 3 ` 0f` 54"
data "cmpps     3 a ` 0f` - - 8 c2 0"
data "cmpss     3 a ` f3 0f` - - 8 c2 0"
data "comiss    3 3 ` 0f` 2f"
data "cvtpi2ps  3 3 ` 0f` 2a"
data "cvtps2pi  3 3 ` 0f` 2d"
data "cvtsi2ss  3 3 ` f3 0f` 2a"
data "cvtss2si  3 3 ` f3 0f` 2d"
data "cvttps2pi 3 3 ` 0f` 2c"
data "cvttss2si 3 3 ` f3 0f` 2c"

data "divps     3 3 ` 0f` 5e"
data "divss     3 3 ` f3 0f` 5e"
data "fxrstor   3 7 ` 0f` ae 1"
data "fxsave    3 7 ` 0f` ae 0"
data "ldmxcsr   3 7 ` 0f` ae 12"

data "maxps    3 3 ` 0f` 5f"
data "maxss    3 3 ` f3 0f` 5f"
data "minps    3 3 ` 0f` 5d"
data "minss    3 3 ` f3 0f` 5d"
data "movaps   3 2 ` 0f` 28"
data "movhlps  3 3 ` 0f` 12"
data "movlhps  3 3 ` 0f` 16"
data "movhps   3 2 ` 0f` 16"
data "movlps   3 2 ` 0f` 12"
data "movmskps 3 3 ` 0f` 50"
data "movss    3 2 ` f3 0f` 10"
data "movups   3 2 ` 0f` 10"
data "mulps    3 3 ` 0f` 59"
data "mulss    3 3 ` f3 0f` 59"
data "maskmovq 3 3 ` 0f` f7"
data "movntps  3 6 ` 0f` 2b"
data "movntq   3 6 ` 0f` e7"

data "orps     3 3 ` 0f` 56"
data "rcpps    3 3 ` 0f` 53"
data "rcpss    3 3 ` f3 0f` 53"
data "rsqrtps  3 3 ` 0f` 52"
data "rsqrtss  3 3 ` f3 0f` 52"
data "shufps   3 a ` 0f` - - 8 c6"
data "sqrtps   3 3 ` 0f` 51"
data "sqrtss   3 3 ` f3 0f` 51"
data "stmxcsr  3 7 ` 0f` ae 3"
data "subps    3 3 ` 0f` 5c"
data "subss    3 3 ` f3 0f` 5c"
data "sfence   ` 0f ae f8`"
data "ucomiss  3 3 ` 0f` 2e"
data "unpckhps 3 3 ` 0f` 15"
data "unpcklps 3 3 ` 0f` 14"
data "xorps    3 3 ` 0f` 57"

data "pavgb    3 3 ` 0f` e0"
data "pavgw    3 3 ` 0f` e3"
data "pextrw   3 f ` 0f` c5 - 8 c5"
data "pinsrw   3 a ` 0f` - - 8 c4"
data "pmaxsw   3 3 ` 0f` ee"
data "pmaxub   3 3 ` 0f` de"
data "pminsw   3 3 ` 0f` ea"
data "pminub   3 3 ` 0f` da"
data "pmovmskb 3 e ` 0f` d7"
data "psadbw   3 3 ` 0f` f6"
data "pshufw   3 a ` 0f` - - 8 70"


'sse2 extended: double precision
'--------------------------------
data "addpd      3 3 ` 66 0f` 58"
data "addsd      3 3 ` f2 0f` 58"
data "andnpd     3 3 ` 66 0f` 55"
data "andpd      3 3 ` 66 0f` 54"
data "cmppd      3 a ` 66 0f` - - 8 c2 0"
data "cmpsd      3 a ` f2 0f` - - 8 c2 0"
data "comisd     3 3 ` 66 0f` 2f"

data "cvtpi2pd   3 3 ` 66 0f` 2a"
data "cvtpd2pi   3 3 ` 66 0f` 2d"
data "cvtsi2sd   3 3 ` f2 0f` 2a"
data "cvtsd2si   3 3 ` f2 0f` 2d"
data "cvttpd2pi  3 3 ` 66 0f` 2c"
data "cvttsd2si  3 3 ` f2 0f` 2c"

data "divpd      3 3 ` 66 0f` 5e"
data "divsd      3 3 ` f2 0f` 5e"
data "maxpd      3 3 ` 66 0f` 5f"
data "maxsd      3 3 ` f2 0f` 5f"
data "minpd      3 3 ` 66 0f` 5d"
data "minsd      3 3 ` f2 0f` 5d"

data "movapd     3 2 ` 66 0f` 28"
data "movhlpd    3 3 ` 66 0f` 12"
data "movlhpd    3 3 ` 66 0f` 16"
data "movhpd     3 2 ` 66 0f` 16"
data "movlpd     3 2 ` 66 0f` 12"
data "movmskpd   3 3 ` 66 0f` 50"
data "movsd      3 2 ` f2 0f` 10"
data "movupd     3 2 ` 66 0f` 10"
data "mulpd      3 3 ` 66 0f` 59"
data "mulsd      3 3 ` f2 0f` 59"

data "maskmovdqu 3 3 ` 66 0f` f7"
data "movntpd    3 6 ` 66 0f` 2b"

data "orpd       3 3 ` 66 0f` 56"
data "shufpd     3 a ` 66 0f` - - 8 c6"
data "sqrtpd     3 3 ` 66 0f` 51"
data "sqrtsd     3 3 ` f2 0f` 51"
data "subpd      3 3 ` 66 0f` 5c"
data "subsd      3 3 ` f2 0f` 5c"
data "ucomisd    3 3 ` 66 0f` 2e"
data "unpckhpd   3 3 ` 66 0f` 15"
data "unpcklpd   3 3 ` 66 0f` 14"
data "xorpd      3 3 ` 66 0f` 57"
'---------------------------------

'----
'sse3
'====

data "addsubpd  3 4 ` 66 0f` d0"
data "addsubps  3 4 ` f2 0f` d0"
data "haddpd    3 4 ` 66 0f` 7c"
data "haddps    3 4 ` f2 0f` 7c"
data "hsubpd    3 4 ` 66 0f` 70"
data "hsubps    3 4 ` f2 0f` 7d"
data "lddqu     3 4 ` f2 0f` f0"
data "movddup   3 4 ` f2 0f` 12"
data "movshdup  3 4 ` f3 0f` 16"
data "movsldup  3 4 ` f3 0f` 12"
data "mwait 03  ` 0f 01 c9`"

'----
'sse4
'====

data "blendpd   3 a ` 66 0f 3a` 0d - 8 0d"
data "blendps   3 a ` 66 0f 3a` 0c - 8 0c"
data "blendvpd  3 4 ` 66 0f 38` 15"
data "blendvps  3 4 ` 66 0f 38` 14"
data "dppd      3 a ` 66 0f 3a` 41 - 8 41"
data "dpps      3 a ` 66 0f 3a` 40 - 8 40"
data "extractps 3 a ` 66 0f 3a` 17 - 8 17"
data "insertps  3 a ` 66 0f 3a` 21 - 8 21"
data "movntdqa  3 4 ` 66 0f 38` 2a"
data "mpsadbw   3 a ` 66 0f 3a` 42 - 8 42"
data "packusdw  3 4 ` 66 0f 38` 2b"
data "pblendvb  3 4 ` 66 0f 38` 10"
data "pblendw   3 a ` 66 0f 3a` 0e - 8 0e"
' pcmpeqq   3 4 ` 66 0f 38` 29"

data "pextrb     3 f ` 66 0f 3a` 14 - 8 14"
data "pextrd     3 f ` 66 0f 3a` 16 - 8 16"
' pextrw     3 f ` 66 0f 3a` 15 - 8 15"
data "phminposuw 3 4 ` 66 0f 38` 41"
data "pinsrb     3 a ` 66 0f 3a` 20 - 8 20"
data "pinsrd     3 a ` 66 0f 3a` 22 - 8 22"
data "pinsrq     3 a ` 66 0f 3a` 22 - 8 22"

data "pmaxsb     3 4 ` 66 0f 38` 3c"
data "pmaxsd     3 4 ` 66 0f 38` 3d"
data "pmaxud     3 4 ` 66 0f 38` 3f"
data "pmaxuw     3 4 ` 66 0f 38` 3e"

data "pminsb     3 4 ` 66 0f 38` 38"
data "pminsd     3 4 ` 66 0f 38` 39"
data "pminud     3 4 ` 66 0f 38` 3b"
data "pminuw     3 4 ` 66 0f 38` 3a"

data "pmovsxbd   3 4 ` 66 0f 38` 21"
data "pmovsxbq   3 4 ` 66 0f 38` 22"
data "pmovsxbw   3 4 ` 66 0f 38` 20"
data "pmovsxwd   3 4 ` 66 0f 38` 23"
data "pmovsxwq   3 4 ` 66 0f 38` 24"
data "pmovsxdq   3 4 ` 66 0f 38` 25"

data "pmovzxbd   3 4 ` 66 0f 38` 31"
data "pmovzxbq   3 4 ` 66 0f 38` 32"
data "pmovzxbw   3 4 ` 66 0f 38` 30"
data "pmovzxwd   3 4 ` 66 0f 38` 33"
data "pmovzxwq   3 4 ` 66 0f 38` 34"
data "pmovzxdq   3 4 ` 66 0f 38` 35"
data "pmuldq     3 4 ` 66 0f 38` 38"
data "pmulld     3 4 ` 66 0f 38` 40"
data "ptest      3 4 ` 66 0f 38` 17"

data "roundpd    3 a ` 66 0f 3a` 09 - 8 09"
data "roundps    3 a ` 66 0f 3a` 08 - 8 08"
data "roundsd    3 a ` 66 0f 3a` 0b - 8 0b"
data "roundss    3 a ` 66 0f 3a` 0a - 8 0a"


'-----
'3dnow
'=====

data "pi2fw    2 3 `0f ` 0f + 0c"
data "pi2fd    2 3 `0f ` 0f + 0d"
data "pf2iw    2 3 `0f ` 0f + 1c"
data "pf2id    2 3 `0f ` 0f + 1d"
data "pfnacc   2 3 `0f ` 0f + 8a"
data "pfpnacc  2 3 `0f ` 0f + 8e"
data "pfcmpge  2 3 `0f ` 0f + 90"
data "pfmin    2 3 `0f ` 0f + 94"
data "pfrcp    2 3 `0f ` 0f + 96"
data "pfrsqrt  2 3 `0f ` 0f + 97"
data "pfsub    2 3 `0f ` 0f + 9a"
data "pfadd    2 3 `0f ` 0f + 9e"
data "pfcmpgt  2 3 `0f ` 0f + a0"

data "pfmax    2 3 `0f ` 0f + a4"
data "pfrcpit1 2 3 `0f ` 0f + a6"
data "pfrsqit1 2 3 `0f ` 0f + a7"
data "pfsubr   2 3 `0f ` 0f + aa"
data "pfacc    2 3 `0f ` 0f + ae"
data "pfcmpeq  2 3 `0f ` 0f + b0"
data "pfmul    2 3 `0f ` 0f + b4"
data "pfrcpit2 2 3 `0f ` 0f + b6"
data "pmulhrw  2 3 `0f ` 0f + b7"
data "pswapd   2 3 `0f ` 0f + bb"
data "pavgusb  2 3 `0f ` 0f + bf"

' caxhe management

data "prefetcht0  4 1 ` 0f` 18 08"
data "prefetcht1  4 1 ` 0f` 18 10"
data "prefetcht2  4 1 ` 0f` 18 18"
data "prefetchnta 4 1 ` 0f` 18 00"

data "!end!"



'----------
elf_Header:
'----------

'data "7f `ELF` 01 01 01 00 hl0 hl0"  ' 0000 e_ident      (16 bytes)
'data "hw0000"        ' 0010 e_type 0     none 1 relocatable 2 executable 3 shared object 4 core ff00 processor-specific ffff processor specific
'data "hw0000"        ' 0012 e_machine    2 sparc 3 intel386 4 motorola68000
'data "hl00000000"    ' 0014 e_version    0 none 1 current
'data "hl00000000"    ' 0018 e_entry      virtual address entry point for code
'data "hl00000000"    ' 001c e_phoff      program header table offset (bytes) or null
'data "hl00000000"    ' 0020 e_shoff      section header table offset (bytes) or null
'data "hl00000000"    ' 0024 e_flags      processor specific flags
'data "hw0000"        ' 0028 e_ehsize     elf header size in bytes
'data "hw0000"        ' 002a e_phentsize  size of each program header entry
'data "hw0000"        ' 002c e_phnum      number of entries in program header
'data "hw0000"        ' 002e e_shentsize  section header entry size in bytes
'data "hw0000"        ' 0030 e_shnum      number of entries in the section header
'data "hw0000"        ' 0032 e_shstrndx   section header table index for section name string table

'34h


data "!end!"


'
'  ########    #########
'  ##     ##   ##
'  ##     ##   ##
'  ##     ##   ##
'  ########    ########
'  ##          ##
'  ##          ##
'  ##          ##
'  ##          #########
'



'==================
elf_section_header:
'==================

data "hl00000000"    'sh_name       index to section header string table section
data "hl00000000"    'sh_type       categorize section contents 1 progbits? 3 string table 6 dynamic linking
data "hl00000000"    'sh_flags      bit attributes 1 write 2 shf_alloc 4 executable
data "hl00000000"    'sh_addr       base address where section should be
data "hl00000000"    'sh_offset     position in the file
data "hl00000000"    'sh_size       section size in bytes
data "hl00000000"    'sh_link       various:
data "hl00000000"    'sh_info       various
data "hl00000000"    'sh_addralign  alignment of section 1 2 4 bytes etc
data "hl00000000"    'sh_entsize    fixed size for entries - otherwise 0

data "!end!"

'Special Sections:
' .bss         unitialised data
' .comment
' .data        initialised data
' .data1       initialised data
' .debug
' .dynamic     dynamic linking
' .dynstr      strings for dynamic linking
' .dynsym      symbols for dynamic linking
' .fini
' .got
' .hash
' .init
' .interp
' .line
' .note
' .plt
' .rel (name)
' .rela (name)
' .rodata
' .rodata1
' .shstrtab
' .strtab        string table
' .symtab        symbol table
' .text          executable instructions
'

'string table: 00 `string` 00 .... 00

'symbol table
'elf_symbol_table_entry:
'hl0 ' st_name    index into string table
'hl0 ' st_value   could be an address depending on context
'hl0 ' st_size    asociated size
'00  ' st_info    symbol type and binding attributes
'00  ' st_other   undefined
'hw00'st_shndx    relevant section header table index




'=========
dos_header:
'=========

data "`MZ`  90 00"     ' 0000
data "03 00 00 00"     ' 0004
data "04 00 00 00"     ' 0008
data "FF FF 00 00"     ' 000c
data "B8 00 00 00"     ' 0010
data "00 00 00 00"     ' 0014   
data "40 00 00 00"     ' 0018 e_lfanew
data "$20"             '      20 nulls
data "hle8"            ' 003c 'e8 was hl80
  '
data "0E 1F BA 0E"     ' 0040
data "00 B4 09 CD"     ' 0044
data "21 B8 01 4C"     ' 0048
data "CD 21"

data "`This program cannot be run in DOS mode.` 0d 0a 00"

data "/e8" 'e8 : adds &h68 to all offsets (was 80)

data "!end!"


 
'=========
pe_header:
'=========

'----------------------------
'IMAGE FILE HEADER (24 bytes)
'============================

data "`PE` 00 00"     ' 0080  Signature: 00004550 'PE
data "hw014c"         ' 0084  Machine:
                      '       IMAGE_FILE_MACHINE_I386  014c
                      '       IMAGE_FILE_MACHINE_AMD64 8664
data "hw0004"         ' 0086  Sections:
data "hl0"            ' 0088  TimeDateStamp: 489E0DEE
                      '       Date & Time: 09/August/2008  22:36:46
data "hl0"            ' 008C  Pointer to symbol table:
data "hl0"            ' 0090  Number of symbols:
data "hw00e0"         ' 0094  Size of Optional header:
data "hw2102"         ' 0096  Characteristics: was 30e
                      '       IMAGE_FILE_LINE_NUMS_STRIPPED
                      '       IMAGE_FILE_LOCAL_SYMS_STRIPPED
                      '       not IMAGE_FILE_32BIT_MACHINE
                      '       IMAGE_FILE_DEBUG_STRIPPED
                      '       IMAGE_FILE_DLL &h2000


'WITH NOTES FOR PE32 / PE32+

'---------------------------------------
'`OPTIONAL` FILE HEADER (96 / 112 bytes)
'=======================================

'
'0X10B for PE32 / 0X20B for PE32+
'
data "hw0*0b 'MAGIC"   ' 0098  magic: h010b for PE32, hw020b for PE32+
data "02"              ' 009A  major linker version: 08 was 02 08
data "00"              ' 009B  minor linker version: 00 was 38 00
data "hl0"             ' 009C  Size of Code:
data "hl0"             ' 00A0  Size of Initialised Data:
data "hl1000"          ' 00A4  Size of Uninitialised Data:

data "ga _main_"       ' 00A8  Address of Entry Point:
data "ga _code_"       ' 00AC  Base of Code:
'
'
'OMIT IN PE32+
'
data "^ga base_of_data" ' 00B0  Base of Data:
'
'
'DWORD IN PE32, QWORD IN PE32+
'
data "h?10000000" ' 00B4  00B0  Image Base: 10000000 (00400000 for EXE)
'
'
data "hl1000"     ' 00B8  Section Alignment:
data "hl200"      ' 00BC  File Alignment Alignment:
data "hw4"        ' 00C0  Major Operating System Version:
data "hw0"        ' 00C2  Minor Operating System Version:
data "hw1"        ' 00C4  Major Image Version: was 0
data "hw0"        ' 00C6  Minor Image Version:
data "hw4"        ' 00C8  Major Subsystem Version: WAS 5 4
data "hw0"        ' 00CA  Minor Subsystem Version: WAS 2 0
data "hl0"        ' 00CC  Reserved: (wIN32)
data "hl5000"     ' 00D0  Size of Image **
data "hl400"      ' 00D4  Size of headers
data "hl0"        ' 00D8  Checksum
data "hw*"        ' 00DC  Subsystem:
                  '       #define IMAGE_SUBSYSTEM_UNKNOWN 0
                  '       #define IMAGE_SUBSYSTEM_NATIVE 1
                  '       #define IMAGE_SUBSYSTEM_WINDOWS_GUI 2
                  '       #define IMAGE_SUBSYSTEM_WINDOWS_CUI 3
data "hw0"        ' 00DE  DLL Characteristics: 140: nxAware, can be relocated at load time (was 0)

'
'THESE ARE QUAD IN PE32+
'
data "h?00100000" ' 00E0  00E0  Size of Stack Reserve:
data "h?00001000" ' 00E4  00E8  Size of Stack Commit:
data "h?00100000" ' 00E8  00F0  Size of Heap Reserve:
data "h?00001000" ' 00EC  00F8  Size of Heap Commit:


data "hl0"        ' 00F0  0100  Loader Flags:
data "hl10"       ' 00F4  0104  Number of RVA and sizes
  

'
'RVA 96 / 112    (00F8 PE32 OR 0108 FOR PE32+)
'
  
'
'--------------------------------
'Optional Header Data Directories
'================================
' 

'giving offset and length: (2 DWORDS)

'    DESCRIPTION                 FILE ADDRESS (32 BIT)
' 1  export table                00F8  0108
' 2  import tables               0100  0110
' 3  resource table              0108  0118
' 4  exception table             0110  0120
' 5  certificate table           0118  0128
' 6  base relocation table       0120  0130
' 7  debug                       0128  0138
' 8  architecture                0130  0140
' 9  global ptr                  0138  0148
' 10 thread local storage        0140  0150
' 11 load configuration          0148  0158
' 12 bound import                0150  0160
' 13 import address table        0158  0168
' 14 delay import descriptor     0160  0170
' 15 CLR common language runtime 0168  0178
' 16 reserved                    0170  0180
' 
  


'RVA 0178/0188 (16 entries * 8 bytes)


'--------------------  
'SECTION HEADER TABLE
'====================

'SECTION HEADER FLAGES
' HL0001 reserved
' HL0002 reserved
' HL0008 IMAGE_SCN_TYPE_NO_PAD obsolete
' HL0010 reserved
' HL0020 IMAGE_SCN_CNT_COD contains executable code
' HL0040 IMAGE_SCN_CNT_INITIALIZED_DATA
' HL0080 IMAGE_SCN_CNT_UNINITIALIZED_ DATA
' HL0100 IMAGE_SCN_LNK_OTHER reserved
' HL0200 IMAGE_SCN_LNK_INFO contains comments (obj files only)
' HL0400 reserved
' HL0800 IMAGE_SCN_LNK_REMOVE not part of image (obj files only)
' HL1000 IMAGE_SCN_LNK_COMDAT
' HL8000 IMAGE_SCN_GPRE contains date refernce by global ptr

' HL10000000 IMAGE_SCN_MEM_SHARED can be shared
' HL20000000 IMAGE_SCN_MEM_EXECUTE can be executed as code
' HL40000000 IMAGE_SCN_MEM_READ can be read
' HL80000000 IMAGE_SCN_MEM_WRITE can be written to



data "!end!"


'----------
pe_imports:
'==========


data ".imports"
data "ga name_list1 hl0 hl0 ga module_name1 ga address_list1"
'data "ga name_list2 hl0 hl0 ga module_name2 ga address_list2"
data "ga name_list3 hl0 hl0 ga module_name3 ga address_list3"

data "hl0 hl0 hl0 hl0 hl0 ' termination"

data ".module_name1 `KERNEL32.DLL` 00"
'data ".module_name2 `OLEAUT32.DLL` 00"
data ".module_name3 `USER32.DLL` 00"


'IN PE32+ MODE THESE TABLES HAVE 64BIT ADDRESSES INSTEAD OF 32BIT ADDRESSES
'null termination


'data ".name_list1    g? LoadLibrary g? GetProcAddress g? FreeLibrary g? GetModuleHandle g? GetCommandLine g? GetExitCodeProcess g? ExitProcess h?0"
'data ".name_list2    g? SysAllocStringByteLen g? SysFreeString h?0"
'data ".name_list3    g? MessageBox h?0"

data ".name_list1    g? LoadLibrary g? GetProcAddress g? FreeLibrary"
data "g? GetModuleHandle g? GetCommandLine g? GetExitCodeProcess g? ExitProcess"
data "g? CreateFile g? ReadFile g? CloseHandle h?0"
'data ".name_list2    g? SysAllocStringByteLen g? SysFreeString h?0"
data ".name_list3    g? MessageBox h?0"


'-------------------------------
data "/+8 .import_address_table"
'===============================

data ".address_list1    g? LoadLibrary g? GetProcAddress g? FreeLibrary"
data "g? GetModuleHandle g? GetCommandLine g? GetExitCodeProcess g? ExitProcess"
data "g? CreateFile g? ReadFile g? CloseHandle h?0"
'data ".address_list2    g? SysAllocStringByteLen g? SysFreeString h?0"
data ".address_list3    g? MessageBox h?0"



data "/+4 .LoadLibrary        hw0 `LoadLibraryA` 00"             '00  00
data "/+4 .GetProcAddress     hw0 `GetProcAddress` 00"           '04  08
data "/+4 .FreeLibrary        hw0 `FreeLibrary` 00"              '08  16
data "/+4 .GetModuleHandle    hw0 `GetModuleHandleA` 00"         '12  24
data "/+4 .GetCommandLine     hw0  `GetCommandLineA` 00"         '16  32
data "/+4 .GetExitCodeProcess hw0 `GetExitCodeProcess` 00"       '20  40
data "/+4 .ExitProcess        hw0 `ExitProcess` 00"              '24  48
data "/+4 .CreateFile         hw0 `CreateFileA` 00"              '28  56
data "/+4 .ReadFile           hw0 `ReadFile` 00"                 '32  64
data "/+4 .CloseHandle        hw0 `CloseHandle` 00"              '36  72
                                                                 '40  80 gap
data "/+4 .MessageBox hw0 `MessageBoxA` 00"                      '44  88

'OLDER VERSION
'data "/+4 .SysAllocStringByteLen hw0 `SysAllocStringByteLen` 00" '32  64  88 
'data "/+4 .SysFreeString hw0 `SysFreeString` 00"                 '36  72  96
'                                                                 '40  80  104 gap


data "01 `end_of_imports` 01"

data "/+1000"
data "!end!"


''------------
'pe_resources:
''============


'LEVELS:
' TYPE
'   ID
'     LANG
'

' RT_CURSOR       = 1
' RT_BITMAP       = 2
' RT_ICON         = 3
' RT_MENU         = 4
' RT_DIALOG       = 5
' RT_STRING       = 6
' RT_FONTDIR      = 7
' RT_FONT         = 8
' RT_ACCELERATOR  = 9
' RT_RCDATA       = 10
' RT_MESSAGETABLE = 11
' RT_GROUP_CURSOR = 12
' RT_GROUP_ICON   = 14
' RT_VERSION      = 16
' RT_DLGINCLUDE   = 17
' RT_PLUGPLAY     = 19
' RT_VXD          = 20
' RT_ANICURSOR    = 21
' RT_ANIICON      = 22
' RT_HTML         = 23
' RT_MANIFEST     = 24




'data ".resources"
' Characteristics
' Time/Data stamp
' Major Version  : Minor Version
' Number of Name Entries
' Number of ID Entries

' EACH ENTRY:
'    ID or Name string pointer
'    LEAF: (bit31=0) 31 bit data entry address OR SUBDIRECTORY (bit31=1) 31 bit address
' 

' RESOURCE DIRECTORY STRING: 2BYTE_LENGTH : WCHARS
'data "hw0 hw0"

'data "/+10" 'align for source data entries


' RESOURCE DATA ENTRY
'    ADDRESS OF RESOURCE DATA
'    SIZE OF RESOURCE DATA
'    CODEPAGE 1252 ENGLISH (LOCALE UK 2057) 68000 UTF7 UNICODE   68001 UTF8 UNICODE
'    RESERVED


'  RAW RESOURCE DATA ... /+10 ...

'data "01 `end_of_resources` 01"
'data "/+1000"
'data "!end!"




