


  '=======================
  '
  '     #####    ##### 
  '    #     #  #     #
  '    #     #        #
  '    #     #   ##### 
  '    #     #  #
  '    #     #  # 
  '     #####   #####O2
  '
  '=======================
  '    OXYGEN RUNTIME
  '=======================

  ' 16:05 27/09/2008 split from o2prep (o2sema)

  dim shared as sys vew,ui1,ui2,ui3,ui4

  'DEBUGGING STRING MESSAGE
  
  '---------------------------------
  sub qq(byref s as string,v as sys)
  '=================================
    if vew=0 then messagebox 0,s,str$(v),0
  end sub

  '---------------------------------
  sub qqq()
  '=================================
  dim as string s=str(ui1)+"    "+str(ui2)+"    "+str(ui3)+"    "+str(ui4)
  dim as any ptr p=strptr(s)
  asm
    pushad
    sub esp,32
    mov ecx,esp
    push 1
    mov dword ptr [ecx],&h00747374
    push ecx
    push [p]
    push 0
    call MessageBox
    add esp,32   
    popad
    end asm
  end sub

  '================
  'RUN TIME GLOBALS
  '================

  type numformat
    dp  as sys  ' DECIMAL PLACES
    trz as sys  ' STRIP TRAILING ZEROS
    sn  as sys  ' SCIENTIFIC NOTATION BY DEFAULT
    sdp as sys  ' INHIBIT ZERO BEFORE DECIMAL POINT
  end type

  type ext
    bytes(9) as byte
  end type

  const as string cr=chr(13)+chr(10)

  'ert     error number
  'ers     error description
  'wdg     runtime messages string
  'num     number to ascii format specifier


  global as sys ert
  global as numformat num
  global as string ers,wdg


'-------------------------------------------------------------
sub init1(byval p as any ptr, byval le as sys, byval c as sys)
'=============================================================
  asm
  mov edx,[p]
  mov ecx,[le]
  mov al,[c]
  mov ah,al
  shl eax,16
  mov al,[c]
  mov ah,al
  shr ecx,2
  inib:
    dec ecx
    jl xbl
    mov [edx],eax
    add edx,4
    jmp inib
  xbl:
    mov ecx,[le]
    and ecx,3
  inib1:
    dec ecx
    jl xbl1
    mov [edx],al
    inc edx
    jmp inib1
  xbl1:           
  end asm
end sub



'--------------------------------
function float_to_ascii() as bstr
'================================
  static as ubyte s(23), t(23),u(15) 'BUFFERS
  static as ubyte bcd(11)
  dim as sys esize,tempdw,dp,sn,snv,b,nzero,oldcw,truncw
  static as zstring ptr ps,pt,pa
  '
  dim as sys num_trz,num_dp,num_sn,num_sdp
  '
  num_trz = num.trz
  num_dp  = num.dp
  num_sn  = num.sn
  num_sdp = num.sdp
  '
  ps=@s(0)
  pt=@t(0)
  pa=@u(0)
  '
  '
  '--
  asm
  '==
  mov eax,[pa]
  fstpt [eax] 'pop store ext number from fpu
  '
  mov eax,0
  mov [snv],eax
  mov [sn],eax
  mov [nzero],eax
  'mov [b],ebx
  '
  '
  'CHECK FOR ZERO INFINITY AND NAN
  '-------------------------------
  '
  mov ecx,[pa]

  mov eax,[ecx+8]

  '(
    and eax,&h7fff
    '
    'TEST FOR ZERO
    '
    '(
      cmp eax,0
      jnz xfa2  'exit EXCLUDE NON ZERO
      cmp dword ptr [num_trz],0
      jz xfa2 'exit ZERO STRIPPER FLAG
      'or eax,[ecx]
      or eax,[ecx+4]
      jnz xfa2 'exit
      '(
        test byte ptr [ecx+9],&h80
        jz xfa1 'exit

        '------
        end asm
        *pt="-0"
        asm
        '------

        jmp fadonez 'NEGATIVE ZERO
      ')
xfa1:

      '------
      end asm
      *pt="0"
      asm
      '------

      jmp fadonez 'POSITIVE ZERO
    ')

xfa2:

    cmp eax,&h7fff
    jnz xfa5n 'exit
    mov dword ptr [nzero],1
    '
    mov eax,[ecx+4]
    and eax,0x7fffffff 'exclude bit 63
    or  eax,[ecx]
    '
    'CHECK FOR NAN OR INFINITY
    '
    '(
      cmp eax,0
      jz xfa4 'exit
      '
      'sNAN OR qNAN
      '
      '(
        test byte ptr [ecx+7],&h40
        jnz xfa3 'exit
        '----------
        end asm
        *pt="#sNAN"
        asm
        '----------
        jmp fadonez 'SIGNALLING NAN
      ')

xfa3:
      '----------
      end asm
      *pt="#qNAN"
      asm
      '----------
     jmp fadonez 'QUIET NAN
    ')

xfa4:

    'NEGATIVE / POSITIVE INFINITY
    '
    '(
      test byte ptr [ecx+9],&h80
      jz xfa5 'exit

      '---------
      end asm
      *pt="#-INF"
      asm
      '---------
      jmp fadonez 'NEGATIVE INFINITY
    ')

xfa5:

    '----------
    end asm
    *pt="#INF"
    asm
    '----------
    
    jmp fadonez 'POSITIVE INFINITY
  ')

xfa5n:

  mov eax,[pa]
  fldt [eax]

  '---------------------------
  ' get the size of the number
  '---------------------------
  '(

    '
    'CHECK FOR ZERO
    '
    mov dword ptr [esize],0
    fldz
    fcomip st(0),st(1)
    jz xfa6 'exit
    '
    mov dword ptr [nzero],1
    

    fldlg2                    'log10(2)
    fld   st(1)               'copy Src
    fabs                      'insures a positive value
    fyl2x                     '->[log2(Src)]*[log10(2)] = log10(Src)
      
    fstcw [oldcw]             'get current control word
    fwait
    mov   ax,[oldcw]
    or    ax,&hc00            'code it for truncating
    mov   [truncw],ax
    fldcw [truncw]            'insure rounding code of FPU to truncating
  
    fist dword ptr [esize]    'store characteristic of logarithm
    fldcw [oldcw]             'load back the former control word

    ftst                      'test logarithm for its sign
    fstsw ax                  'get result
    fwait
    sahf                      'transfer to CPU flags
    sbb   dword ptr [esize],0 'decrement esize if log is negative
    fstp  st(0)               'get rid of the logarithm
  ')

xfa6:

  '
  'DECIMAL PLACES LIMIT
  '---------------------
  '
  mov eax,[num_dp]
  '(
   cmp eax,16
   jle xfa7 'exit
   mov eax,16 'LIMIT DECIMAL PLACES
  ')

xfa7:

  mov [dp],eax


  'IS SCIENTIFIC NOTATION ALWAYS REQUIRED

  cmp byte ptr [num_sn],0
  jnz ENotation

  '
  'VERY LARGE NUMBERS
  '
  '(
    mov ecx,[esize]
    'add ecx,dp
    cmp ecx,18
    jl xfa8 'exit
    jmp ENotation
  ')

xfa8:

  '
  'SMALL NUMBERS
  '
  '(
    cmp dword ptr [esize],0
    jge xfa9 'exit
    mov ecx,[dp]
    mov edx,[esize]
    neg edx
    cmp edx,4
    jg ENotation 'LIMIT FOR SIMPLE FORMAT
    mov eax,ecx
    mov [dp],ecx
    jmp PowerAdjust
  ')

xfa9:

  '
  'NUMBERS NOT REQUIRING SCIENTIFIC NOTATION
  '
  '(
    mov eax,[dp]
    mov ecx,eax   'DECIMAL PLACES
    add ecx,[esize] 'INTEGER DIGITS 
    sub ecx,16
    jle xfa10 'exit
    '
    'TOO MANY DIGITS? (ecx contains excess digits)
    '
    '
    sub eax,ecx 'REDUCE MULTIPLIER PLACES IF NECESSARY
    sub [dp],ecx  'REDUCE DECIMAL PLACES ALSO
  ')

xfa10:

  jmp PowerAdjust

  ENotation:
  '---------

    mov ecx,[esize]
    mov [snv],ecx
    mov eax,[dp]
    sub eax,ecx
    mov dword ptr [sn],1 'SCIENTIFIC NOTATION FLAG

  PowerAdjust:
  '-----------

  mov [tempdw],eax 'ADJUSTED MULTIPLIER


  'Multiply the number by the power of 10
  '---------------------------------------
  '(
    mov eax,[tempdw]
    cmp eax,0
    jz xfa11 'exit
    '
    fild dword ptr [tempdw]
    fldl2t
    fmulp st(1),st(0)       '->log2(10)*exponent
    fld st(0)
    frndint                 'get the characteristic of the log
    fxch st(1)
    fsub st(0),st(1)        'get only the fractional part but keep the characteristic
    f2xm1                   '->2^(fractional part)-1
    fld1
    faddp st(1),st(0)                    'add 1 back
    fscale                  're-adjust the exponent part of the REAL number
    fstp  st(1)             'get rid of the characteristic of the log
    fmulp st(1),st(0)       '->16-digit integer
  ')

xfa11:

  fbstp [bcd] 'SAVE AS PACKED BINARY CODED DECIMAL


'  /*
'  'TRAP ERRORS
'  '
'  fstsw ax                'retrieve exception flags from FPU
'  fwait
'  shr   eax,1             'test for invalid operation
'  jc    srcerr            'clean-up and return error
'  */


  '
  'EXPAND DIGITS
  '

  lea edx,[bcd]
  lea ecx,[s]
  '
  push ebx
  mov bl,10

rfa12:

  '(
    dec bl
    jl xfa12 'exit
    '
    mov ah,[edx]
    inc edx
    '
    mov al,ah
    and al,15
    add al,48
    mov [ecx],al
    inc ecx
    '
    mov al,ah
    shr al,4
    and al,15
    add al,48
    mov [ecx],al
    inc ecx
    jmp rfa12 'repeat
    ')

xfa12:

  mov byte ptr [ecx],0

  '
  'COPY FORMATTED
  '--------------
  '
  lea edx,[t]
  '
  'NEGATIVE SIGN NEEDED?
  '
  '(
    cmp al,48
    jz xfa13 'exit
    mov byte ptr [edx],45
    inc edx
  ')

xfa13:

  lea ebx,[s]
  add ebx,18
  mov cl,19
  mov ah,0
  mov ch,[dp]
  dec ch

rfa18:

  '(
    dec cl
    jl xfa18 'exit
    '
    'INSERT DECIMAL POINT
    '
    '(
      cmp cl,ch
      jnz xfa15 'exit
      '
      'PLACE LEADING ZERO
      '
      '(
       cmp dword ptr [num_sdp],0
       jnz xfa14 'exit SDP FLAG TO INHIBIT
       cmp ah,0
       jnz xfa14 'exit
       mov byte ptr [edx],48
       inc edx
      ')

xfa14:

      mov byte ptr [edx],46
      inc edx
      mov ah,1 'STOP STRIPPING ZEROS
    ')

xfa15:

    mov al,[ebx]
    dec ebx
    '(
      '(
        cmp ah,0
        jnz faok
      ')

xfa16:

      cmp al,48
      jz xfa17 'exit STRIP LEADING ZEROS
      mov ah,1 'INHIBIT FUTURE STRIPPING
      faok:
      mov [edx],al
      inc edx
    ')

xfa17:

    jmp rfa18 'repeat
  ')

xfa18:

  pop ebx

  '
  fadone:
  '
  'REMOVE ENDING ZEROS
  '
  '(
    cmp dword ptr [num_trz],0
    jz xfa21 'exit
    lea ecx,[t] 'BASE ADDRESS OF NUMBER STRING

rfa20:

    '(
      dec edx
      cmp edx,ecx      
      jle xit1 'exit LEAVE FIRST CHARACTER ALONE
      mov al,[edx]
      '(
       cmp al,46
       jnz xfa19 'exit
       dec edx
       jmp xit1 'STRIP DOT AND EXIT
      ')

xfa19:

      cmp al,48
      jnz xfa20 'exit ONLY LOOK AT RIGHT HAND ZEROS
      jmp rfa20 'repeat 'STRIP ZERO AND CONTINUE
    ')

xfa20:
    
    xit1:
    '
    inc edx
  ')

xfa21:

  'ENSURE AT LEAST ONE DIGIT
  '
  lea ecx,[t]
  mov al,[ecx]
  '(
    cmp al,45
    jnz xfa22 'exit
    inc ecx
  ')

xfa22:

  '(
    cmp ecx,edx
    jnz xfa23 'exit
    mov byte ptr [edx],48
    inc edx
  ')

xfa23:

  '
  'CHECK FOR SCIENTIC NOTATION
  '
  '(
    cmp dword ptr [sn],0
    jz xfa27 'exit
    cmp dword ptr [nzero],0
    jz xfa27 'exit
    mov eax,[snv]
    cmp eax,0
    jz xfa27 'exit E VALUE ZERO SO OMIT
    mov byte ptr [edx],69
    inc edx 'E'
    mov cl,43
    '(
      cmp eax,0
      jge xfa24 'exit
      neg eax
      mov cl,45
    ')

xfa24:

    mov [edx],cl
    inc edx 'SIGN
    mov cl,100
    div cl
    push eax
    and eax,&hff
    mov cl,10
    div cl

    '(
      cmp ax,0
      jz xfa26 'exit
      or eax,&h3030 'TO ASCII THOUSANDS AND HUNDREDS
      '( 
        cmp al,48
        jz xfa25 'exit
        mov [edx],al
        inc edx
      ')

xfa25:

      mov [edx],ah
      inc edx
    ')

xfa26:

    pop eax
    shr eax,8
    div cl
    or eax,&h3030 'TO ASCII TENS AND UNITS
    mov [edx],aX
    add edx,2
  ')

xfa27:

  '
  mov byte ptr [edx],0 'APPEND NULL TERMINATOR
  '
  fadonez:

  '
  'ASSIGN RESULT TO BSTRING
  '
  mov ecx,[pt]
  mov edx,ecx
  rnends:
  mov al,[ecx]
  inc ecx
  cmp al,32
  jg rnends
  sub ecx,edx
  dec ecx 'length
  push ecx 'max bytes
  push edx
  call SysallocStringByteLen
  mov [function],eax
  '

  end asm
  '
end function





'------------
sub hexaval()
'============
  asm
  '
  'ECX POINTS TO LEFT BOUNDARY OF TEXT NUMBER
  '
  xor edx,edx
  xor esi,esi
  '
  rhexconv:
    inc ecx
    mov al,[ecx]
    cmp al,48 '0
    jb nhexconv 'boundary reached
    '
    'CONVERT TO UPPERCASE
    '
    cmp al,96
    jbe nnlc2
    cmp al,122
    ja nnlc2
    sub al,32
    nnlc2:
    '
    cmp al,&h46 'F
    ja nhexconv
    cmp al,57 '9
    jbe nadjal
      cmp al,65
      jb nhexconv 'boundary character
      sub al,7
    nadjal:
    sub al,48 'ascii to hex number
    shld esi,edx,4 'shift nybble
    shl edx,4
    add dl,al
    '
    'itr overflow
    '
  jmp rhexconv
  '
  nhexconv: 'done conversion 'result in edx
  '
  mov eax,edx 'return lower dword
  mov edx,esi 'possible upper dword
  '
  end asm
end sub



type guid
  a as long
  b as short
  c as short
  d(7) as byte
end type


'--------------------------------------------
sub guidval(byref g as guid, byval s as bstr)
'============================================
  '
  '{dddddddd-wwww-wwww-bbbb-bbbbbbbbbbbb}
  '
  asm
    mov edi,[g]
    mov ecx,[s]
    mov al,[ecx]
    cmp al,123
    jz gguid
      dec ecx
    gguid:
    call hexaval
    mov [edi],eax
    call hexaval
    mov [edi+4],ax
    call hexaval
    mov [edi+6],ax
    call hexaval
    mov [edi+8],ah
    mov [edi+9],al
    call hexaval
    mov [edi+10],dh
    mov [edi+11],dl
    mov edx,eax
    shr edx,16
    mov [edi+12],dh
    mov [edi+13],dl
    mov [edi+14],ah
    mov [edi+15],al
    inc ecx 'move to txtguid boundary
    nguid:
  end asm
end sub


'---------
sub ghex()
'=========
  asm
    mov dh,al
    and dh,15
    add dh,48
    cmp dh,57
    jle nghexadj1
    add dh,7
    nghexadj1:
    shr eax,4
    mov dl,al
    and dl,15
    add dl,48
    cmp dl,57
    jle nghexadj2
    add dl,7
    nghexadj2:
    shr eax,4
  end asm
end sub


'----------------------------------------
function guidtxt(byref g as guid) as bstr
'========================================
  asm
    push 38
    push 0
    call SysAllocStringByteLen
    mov edi,eax
    mov [function],eax
    mov ecx,[g]
    mov byte ptr [edi],123
    mov byte ptr [edi+37],125
    inc edi
    ''-------
    'dddddddd
    '--------
    mov eax,[ecx]
    call ghex
    mov [edi+6],dx
    call ghex
    mov [edi+4],dx
    call ghex
    mov [edi+2],dx
    call ghex
    mov [edi],dx
    mov byte ptr [edi+8],45
    add edi,9
    '----
    'wwww
    '----
    mov ax,[ecx+4]
    call ghex
    mov [edi+2],dx
    call ghex
    mov [edi],dx
    mov byte ptr [edi+4],45
    add edi,5
    '----
    'wwww
    '----
    mov ax,[ecx+6]
    call ghex
    mov [edi+2],dx
    call ghex
    mov [edi],dx
    mov byte ptr [edi+4],45
    add edi,5
    '----
    'bbbb
    '----
    mov ax,[ecx+8]
    call ghex
    mov [edi],dx
    call ghex
    mov [edi+2],dx
    mov byte ptr [edi+4],45
    add edi,5
    '------------
    'bbbbbbbbbbbb
    '------------
    add ecx,10
    mov esi,6
    rghexb:
      mov al,[ecx]
      call ghex
      mov [edi],dx
      inc ecx
      add edi,2
      dec esi
    ja rghexb
    '--------
  end asm
end function





'------------------------------------
sub ascii_to_float(byval s as string) 
'====================================
  dim as sys stt,dpf,dpl,enf,eno,digi,sgf,sgg,ten=10
  dim as any ptr p=strptr(s)
  asm

  mov ecx,[p]
  '
  'SKIP LEADING WHITE SPACE
  '
raf1:
  mov al,[ecx]
  cmp al,0
  jz numnok 'end of string (error)
  cmp al,32
  jg xaf1 'exit 'start of word
  inc ecx
  jmp raf1 'repeat
xaf1:
  '
  mov [stt],ecx 'START OF NUMBER
  '
  '
  'filter word types
  '=================
  '
  cmp al,&h23 'include #  special numbers
  jz spnums
  cmp al,&h26 'include &  hex number
  jz numhok
  cmp al,&h2d 'include -  neg number
  jz normf
  cmp al,&h2e 'include .  decimal point
  jz normf
  cmp al,&h30 'exclude below 0
  jb numnok
  cmp al,&h3a 'include below :
  jb normf

  'NAKED HEXADECIMAL
  'cmp al,&h41 'exclude below A
  'jb numnok
  'cmp al,&h48 'include below H
  'jb numhok
  'cmp al,&h61 'exclude below a
  'jb numnok
  'cmp al,&h68 'include below h
  'jb numhok
  '
  '--------------------------
  numnok: 'cannot be a number
  '==========================
  '
  fldz
  jmp NumErr
  
  '---------------------------------
  numhok: 'HEX OCTAL OR BINARY MAYBE
  '=================================
  '
  '
  cmp al,38 '&
  jnz spnums
  fldz
  '
  inc ecx
  mov al,[ecx]
  cmp al,32
  jbe ParseHExit
  '
  'CONVERT TO UPPERCASE
  '
  cmp al,96
  jbe nnlc1
  cmp al,122
  ja nnlc1
  sub al,32
  nnlc1:
  '
  cmp al,&h48 'h
  jnz tryoctal
  '
  '
  'HEXADECIMAL
  '-----------
  '
  call hexaval
  jmp cputofpu
  '
  '
  tryoctal: 'OCTAL
  '--------------
  '
  cmp al,&h4f 'o
  jnz trybinary
  '
  xor edx,edx 'zero the accum
  roctconv:
    inc ecx
    mov al,[ecx]
    cmp al,48 '0
    jb noctconv
    cmp al,55 '7
    ja noctconv
    sub al,48 'ascii to hex number
    shl edx,3 'shift octo
    add dl,al
    '
    'itr overflow
    '    
  jmp roctconv
  noctconv: 'done conversion
  mov eax,edx
  jmp cputofpu
  '
  '
  '
  '
  trybinary: 'BINARY BITS
  '----------------------
  '
  cmp al,&h42 'b
  jnz ParseHExit
  '
  xor edx,edx 'zero the accum
  rbinconv:
    inc ecx
    mov al,[ecx]
    cmp al,48 '0
    jb nbinconv
    cmp al,49 '1
    ja nbinconv
    sub al,48 'ascii to hex number
    shl edx 'shift bit
    add dl,al
    '
    'itr overflow
    '    
  jmp rbinconv
  nbinconv: 'done conversion
  mov eax,edx
  jmp cputofpu
  '
  '
  'TREAT AS UNSIGNED INTEGER
  '
  cputofpu:
  '
  push 0
  push eax
  fstp st(0) ' dump default 0 
  fild qword ptr [esp]
  add esp,8
  '
  '
  ParseHExit:
  '
  end asm
  exit sub
  asm
  '
  '
  '---------------
  'SPECIAL NUMBERS
  '---------------
  '
  spnums:
  '
  cmp al,35 '#
  jnz normf 'NORMAL NUMBERS
  sub esp,16
  mov edx,esp
  '
  'DEFAULT ZERO
  '
  mov dword ptr [edx],0
  mov dword ptr [edx+4],0
  mov word ptr [edx+8],0
  '
  inc ecx
  mov eax,[ecx]
  add ecx,4
  or eax,&h20202020 'QUICK LOWERCASE
  '
  cmp eax,&h666e692d '#-INF
  jnz xsnum1 'exit
  mov word ptr [edx+8],&hffff
  jmp xitsn
xsnum1:
  cmp eax,&h6e616e71 '#QNAN
  jnz xsnum2 'exit
  mov dword ptr [edx+4],&h40000000
  mov word ptr [edx+8],&h7fff
  jmp xitsn
xsnum2:
  cmp eax,&h6e616e73 '#SNAN
  jnz xsnum3 'exit
  mov dword ptr [edx+4],&h20000000
  mov word ptr [edx+8],&h7fff
  jmp xitsn
xsnum3:
  and eax,&hffffff 'IGNORE 4TH CHAR
  '  
  cmp eax,&h666e69 '#INF
  jnz xsnum4 'exit
  mov word ptr [edx+8],&h7fff
  dec ecx
  jmp xitsn
xsnum4:
  '
  mov dword ptr [edx+4],&h40000000 'DEFAULT #QNAN
  mov word ptr [edx+8],&h7fff
  
  xitsn:
  '
  fldt [edx]
  add esp,16
  end asm
  exit sub
  '
  '
  asm

  '-------------------------------------
  normf: 'OTHERWISE CONVENTIONAL NUMBERS
  '-------------------------------------
  '
  fldz
  dec ecx     'PRE DECR
  '
  '---------
  ParseLoop:
  '---------
  '
raf2:
  inc ecx
  mov al,[ecx]
  cmp al,32
  jle ParseExit
  '
  'TEST FOR E
  '
raf3:
  cmp al,&h65
  jz xaf3 'exit
  cmp al,&h45
  jz xaf3 'exit
  jmp nexne
xaf3:

    'E ENCOUNTERED
raf4:
  mov eax,ecx
  inc eax
  mov dword ptr [enf],eax
  fldz
  mov al,[sgf]
  mov [sgg],al
  mov dword ptr [sgf],0
  jmp ParseLoop
xaf4:
  '
  '-------------------
  nexne: 'BYPASS E SETUP
  '-------------------
  '
  'NEGATIVE SIGN
  '
raf5:
  cmp al,45
  jnz xaf5 'exit
  cmp byte ptr [sgf],0
  jnz NumErr 'NEG SIGN ALREADY ENCOUNTERED
  mov byte ptr [sgf],1 'SET SIGN FLAG
  jmp ParseLoop
xaf5:

raf6:
  cmp al,43
  jnz xaf6 'exit
  cmp ecx,[stt]
  jz ParseLoop 'PLUS SIGN AT START OF NUMBER
  cmp byte ptr [sgf],0
  jnz ParseExit 'PLUS SIGN MARKING BOUNDARY OF NUMBER
  cmp [enf],ecx
  jz ParseLoop 'PLUS SIGN IMMEDIATELY FOLLOWING E
  jmp ParseExit
xaf6:

  'CHECK FOR DECIMAL POINT
  '
raf7:
  cmp al,46
  jnz xaf7 'exit
  cmp dword ptr [enf],0
  jnz NumErr 'DECIMAL POINT AFTER E
  cmp byte ptr [dpf],0
  jnz NumErr 'DECIMAL POINT ALREADY PRESENT
  mov byte ptr [dpf],1
  jmp ParseLoop
xaf7:
  '
  'VALIDATE DIGIT
  '
  sub al,48
  jb ParseExit 'ASCII BELOW '0'
  cmp al,9
  ja ParseExit 'exit  'ASCII ABOVE '9'
  '
  'ACCUM * 10 + DIGIT
  '
  fimul dword ptr [ten]
  mov [digi],al
  fiadd dword ptr [digi]
  '
raf8:
  cmp byte ptr [dpf],0
  jz xaf8 'exit  'NO DECIMAL POINT
  cmp byte ptr [enf],0
  jnz xaf8 'exit 'EXCLUDING E NUMBER
  inc dword ptr [dpl]
xaf8:
  jmp ParseLoop 
xaf2:
  '
  '---------
  ParseExit:
  '---------
  '
  'CHECK FOR NEG SIGN
raf9:
  cmp byte ptr [sgf],0
  jz xaf9 'exit
  fchs
xaf9:
  '
  'DECIMAL PLACES BUT NO E NUMBER
  '
raf10:
   cmp dword ptr [enf],0
   jnz xaf10 'exit
   mov dword ptr [enf],1 'SET TO SCALE
   fldz
xaf10:
  '
  '
  'SCALE VALUE PRESENT?
  '
raf11:
  cmp dword ptr [enf],0
  jz xaf11 'exit
  '
  fisub dword ptr [dpl] 'ADJUST SCALER FOR DECIMAL PLACES
  fldl2t
  fmulp  st(1),st(0)   '->log2(10)*exponent
  fld   st(0)
  frndint              'get the characteristic of the log
  fxch
  fsub st,st(1)        'get only the fractional part but keep the characteristic
  f2xm1                '->2^(fractional part)-1
  fld1
  faddp st(1),st(0)    'add 1 back
  fscale               're-adjust the exponent part of the REAL number
  fstp  st(1)          'get rid of the characteristic of the log
  fmulp st(1),st(0)    '->16-digit integer
  '
  'CHECK FOR NEG SIGN
  '
raf12:
  cmp byte ptr [sgg],0
  jz xaf12 'exit
  fchs
xaf12:

xaf11:

  '
  numokay: 'NUMBER COMPLETED
  '-------------------------
  '
  'result remains on fpu stack.
  '
  end asm
  exit sub
  asm
  '
  NumErr: 'NUMBER ERRORS
  '---------------------
  '
  'itr runtime error?
  '
  end asm
  'print "Number error"
 
end sub





'--------------------------------------
function getmem(byval a as sys) as BSTR
'======================================
  asm
    push [a]
    push 0
    call SysAllocStringByteLen
    'call [ebx+160] 'AllocString
    mov [function],eax
    push 0
    push [a]
    push [function]
    mov eax,[a]
    and al,3
    jnz nini4
      pop edx
      pop ecx
      pop eax
      shr ecx,2
      cmp ecx,0
      jz xini
      rini:
        mov [edx],eax
        add edx,4
        dec ecx
        jg rini 
      jmp xini
    nini4:
      call init1
    xini:
  end asm
  'init1 p,a,0 ' BYTE NULLS
end function



'---------------------------
sub FreeMem(byval a as BSTR)
'===========================
  asm
    mov eax,[a]
    'cmp eax,0
    'jz nfreestr
      push eax
      call SysFreeString
      'call [ebx+168]
    'nfreestr:
  end asm
end sub



'---------------------------------------------
sub binderr(byval z as string, byval e as sys)
'=============================================
  '
  wdg=left(z,e)
  '
  'ADD TO RUNTIME ERRORS
  '
  ers+="Unable to bind "+wdg+cr
  '
end sub



'-----------------------------------------------------------------------------
sub procaddrs(byval li as sys ptr, byval p as zstring ptr, byval a as sys ptr)
'=============================================================================
dim as sys erc
asm
  mov esi,[p]  ' NAME LIST
  mov ebx,[li] ' LIBRARY HANDLE
  mov edi,[a]  ' PROC ADDRESS LIST PTR
               '
  '
  '--------------------
  'CHAR COLLECTION LOOP
  '--------------------
  '
  dec esi
  rprocl:
    inc esi
    mov al,[esi]
    cmp al,3 'SIGNAL END OF LIST
    jz xprocl
    cmp al,32
    jle rprocl
    mov ecx,esi 'START OF PROCNAME
    dec esi
  rproclw:
    inc esi
    mov al,[esi]
    '
    'CHECK FOR LIST TERMINATOR
    '-------------------------
    '
    cmp al,3
    jz xprocl
    '
    'CHECK FOR NAME BOUNDARY (NULL CRLF ETC)
    '-----------------------
    '
    cmp al,32
    jg rproclw
    '
    'PREPARE PROC NAME
    '-----------------
    '
    'NO PATCHING ALLOWED IN PE CODE SECTION
    'mov byte ptr [esi],0 'PATCH NULL TERMINATOR
    '
    push ecx ' PRESERVE START OF NAME
    '
    'GET PROC ADDRESS
    '----------------
    '
    push ecx ' START OF NAME
    push ebx ' LIB HANDLE
    call GetProcAddress
    'call [ebx+40] ' GetProcAddress
    '
    pop ecx ' RESTORE START OF NAME PTR
    '
    'CHECK VALID
    '-----------
    '
    cmp eax,0
    jnz cprocl 'WAS VALID PROCADDRESS
      mov eax,esi
      sub eax,ecx
      push eax
      push ecx
      call binderr
      'inc dword ptr [erc]
    cprocl:
    '
    'PATCH ADDRESS INTO TABLE
    '------------------------
    '
    mov [edi],eax
    add edi,4
    '
    'NEXT PROC NAME
    '--------------
    '
    jmp rprocl
    '
    'END OF LIST
    '-----------
    '
  xprocl:
  '
end asm
'if erc then qq ers,1 'then terminate app?
end sub



'---------------------------------------
sub copy0(byval a as sys,byval b as sys)
'=======================================
asm
mov edi,[a]
mov esi,[b]
copy0r:
  mov al,[esi]
  mov [edi],al
  inc esi
  inc edi
  cmp al,0
  jnz copy0r
end asm
end sub




'----------------------------------------
sub copy00(byval a as sys,byval b as sys)
'========================================
'
asm
mov edi,[a]
mov esi,[b]
copy00r:
  mov ax,[esi]
  mov [edi],ax
  inc esi
  inc esi
  inc edi
  inc edi
  cmp ax,0
  jnz copy00r
end asm
end sub


'---------------------------------------------------------
sub copyn(byval a as sys,byval b as sys,byval q as sys)
'=========================================================
asm
push ecx
mov edi,[a]
mov esi,[b]
mov ecx,[q]
copyqr:
  dec ecx
  jl  copyqx
  mov al,[esi]
  mov [edi],al
  inc esi
  inc edi
  jmp copyqr
copyqx:
pop ecx
end asm
end sub


'------------------------------------
function asclc(byval a as sys) as sys
'====================================
  '
  if(a>64)and(a<91) then a+=32
  '
  function=a
  '
end function


'------------------------------------------------------
function ascl(byref s as string, byref i as sys) as sys
'======================================================
  '
  function=asclc(asc(s,i))
  '
end function

'POSSIBLY A NUMBER

'----------------------------------
function isn(byval a as sys) as sys
'==================================
  asm
    mov al,[a]
    xor ecx,ecx
    inc ecx
    cmp al,45
    jz disn
    cmp al,46
    jz disn
    cmp al,48
    jl xisn
    cmp al,57
    jg xisn
    disn:
    mov [function],ecx
    xisn:
  end asm
end function



'------------------------------------------
function wval(byref w1 as string) as double
'==========================================
  '
  dim as sys a,b,e
  dim as any ptr p
  '
  '
  a=asc(w1) : e=len(w1)
  '
  if a=48 then 
    b=ascl(w1,2)
    if b=&h78 then mid(w1,1)="&h" : goto valuate '0x
    if b=&h6f then mid(w1,1)="&o" : goto valuate '0o
    if b=&h62 then mid(w1,1)="&b" : goto valuate '0b
  end if
  '
  if isn(a) then
    if e>1 then
      b=asc(w1,e)
      if b=&h68 then w1="&h"+w1 'eg: 1ae6h
      if b=&h6f then w1="&o"+w1 'eg: 10507o
      if b=&h62 then w1="&b"+w1 'eg: 10101b
    end if
    goto valuate
  elseif a=38 then
    if e>2 then
      b=ascl(w1,2)
      if (b=&h68)or(b=&h6f)or(b=&h62) then goto valuate ' &h &o or &b
    end if
  end if
  '
  exit function
  '
  '-------
  valuate:
  '-------
  '
  p=strptr(w1)
  asm
    push [p]
    call ascii_to_float 'in o2runt.bas
    fstp qword ptr [function] 
  end asm
  '
  'function=val(w1) 'fails with FB 0.21
  '
end function




''---------------------------------------------------
'sub strd(byval p as zstring ptr, byref dv as double)
''===================================================
'  *p=str(dv)
'end sub


''---------------------------------------------------
'sub vald(byref dv as double, byval p as zstring ptr)
''===================================================
'  dv=wval(*p)
'end sub





'##############################

'     #####    #####   #     #
'    #     #  #     #  #     #
'    #     #        #  #     #
'    #     #   #####   #######
'    #     #  #        #     #
'    #     #  #        #     #
'     #####   #######  #     #

'##############################







''-----------------------------------------------
'function vals (byval p as zstring ptr) as double
''===============================================
'  if lcase(left(*p,2))="0x" then mid(*p,1)="&h"
'  function=wval(*p)
'end function


''-----------------------
'function strs () as BSTR
''=======================
'  dim as double v
'  dim as string s
'  dim as ext    ev
'  dim as any ptr p=@ev
'  #if 1
'    asm
'      mov eax,[p]
'      .byte &hdb, &h38 'fstp eword [eax]
'    end asm
'    s=float_to_ascii(ev)
'  #else
'    asm
'      fstp qword ptr [v]
'    end asm
'    s=str(v)
'  #endif
'  function=AllocString(strptr(s), len(s))
'end function

'----------------------
function hexs() as BSTR
'======================
  #if 1
     asm
     sub esp,32 'workspace
     mov esi,esp
     fistp dword ptr [esi]
     mov edx,[esi]
     add esi,28  'offset for working backwoards
     mov edi,esi 'hold end position
     inc edi
     mov byte ptr [edi],32 'endstop space
     mov ecx,8   'down count
     rhextoc:
       mov al,dl
       shr edx,4
       and al,15
       add al,48
       cmp al,58
       jb nadjhexal
         add al,7
       nadjhexal:
       mov [esi],al
       dec esi 'move to left
       dec ecx 'downcount
     jg rhextoc
     rtrimzer:  'trim leading zeros
      inc esi
      mov al,[esi]
      cmp al,48 'is it a leading zero?
     jz rtrimzer
     cmp esi,edi
     jl nsinglez 'leave at least 1 digit
       dec esi
     nsinglez:
     sub edi,esi 'calc length
     push edi 'length
     push esi 'pointer
     call SysAllocStringByteLen
     'call [ebx+160] 'AllocString 'create BSTR
     mov [function],eax 'return it
     add esp,32
     end asm 
  #else
    dim as sys v
    dim as string s
    asm
      fistp dword ptr [v]
    end asm
    s=hex(v)
    function=AllocString(strptr(s), len(s))
  #endif
end function


'--------
sub diagn
'========
asm
jmp xnnak
  qqw:
  pushad
  '
  push 0
  push &h44434241
  '
  mov eax,esp
  '
  push 0
  push eax
  push eax
  push 0
  call messagebox
  '
  add esp,8
  popad
  ret

xnnak:
end asm
end sub


'----------
sub strsh() 
'==========
  asm
  push ebx
  push esi
  mov ebx,0
  '
  'create workspace on stack
  '-------------------------
  '
  sub esp,64
  mov eax,esp

  mov esi,eax
  mov edi,eax
  add esi,52
  push edi
  '
  'working forwards
  '
  '3 decimal places
  '----------------
  '
  push 1000
  fild dword ptr [esp]
  add esp,4
  fmulp st(1),st(0)
  mov ch,3
  '
  fbstp [esi]
  add esi,9 
  mov cl,18 'downcounter for 18 digits to follow
  '
  'CHECK FOR NEGATIVE SIGN
  '-----------------------
  '
  mov al,[esi]
  cmp al,0
  jge nnegs
    mov bh,1
    mov byte ptr [edi],45
    inc edi
  nnegs:
  '
  dec esi ' ignore rest of sign byte
  '
  '----------------------------
  rbcd:  'digit conversion loop
  '============================
  '
  'get digit pair
  mov dl,[esi]
  '
  'decimal point check
  '
  cmp cl,ch
  jnz ndpt1
    mov byte ptr [edi],46
    inc edi
    inc bl
  ndpt1:
  dec cl

  'unpack and store
  mov al,dl
  shr al,4
  and al,15
  '
  'trimming off leading zeros
 
  jnz nzer
    cmp bl,0
    jz nxdigit
  nzer:
  inc bl
  add al,48
  '
  'more significant digit
  '----------------------
  '
  mov [edi],al
  inc edi

  nxdigit:

  '
  'decimal point check
  '-------------------
  '
  cmp cl,ch
  jnz ndpt2
    mov byte ptr [edi],46
    inc edi
    inc bl
  ndpt2:
  dec cl

  mov al,dl
  and al,15

  'trimming off leading zeros
  '--------------------------
  ' 
  jnz nzer1
    cmp bl,0
    jz nxdigit1
  nzer1:
  inc bl
  add al,48
  '
  'less significant digit
  '----------------------
  '
  mov [edi],al
  inc edi
  '
  'next digit pair
  '
  nxdigit1:

  dec esi
  '
  'loop for next pair
  '------------------
  '
  '
  cmp cl,0

  jg rbcd
  '
  ndigits:
  
  'create string
  mov eax,edi
  '
  'NEG SIGN ADJUST
  '---------------
  '
  cmp bh,0
  jz nisneg1
    dec eax
  nisneg1:
  '
  'INSERT 0
  '--------
  '
  sub eax,[esp]  
  jnz nzull
    mov byte ptr [edi],48
    inc eax 'put in `0`
    inc edi 'for null term
  nzull:
  mov byte ptr [edi],0
  pop edi 'restore base
  '
  'NEG SIGN ADJUST
  '---------------
  '
  cmp bh,0
  jz nisneg2
    inc eax
  nisneg2:
  '
  'new string with copy of number
  push eax
  push edi
  call SysAllocStringByteLen
  'call [ebx+160] 'Allocstring
  'mov dword ptr [eax],&h44434241
  '
  'return string pointer
  '
  '
  'deallocate workspace
  '--------------------
  '
  add esp,64
  '
  'restore regs
  pop esi
  pop ebx
  end asm
end sub


'---------------------------------------------------------------------------
function instrsh(byval i as sys, byval s0 as bstr, byval w0 as bstr ) as sys
'===========================================================================
asm
  push ebx
  push esi
  mov ebx,[i]
  dec ebx
  cmp ebx,0
  jl xinstr       'invalid offset
  mov edi,[s0]    'main string
  cmp edi,0
  jz xinstr       'empty string
  mov edx,[w0]    'keyword
  cmp edx,0
  jz xinstr       'empty keyword
  mov ecx,[edx-4] 'length of keyword
  '
  mov esi,edi
  add esi,[edi-4] 'main string boundary
  sub esi,ecx     'minus length of keyword
  mov eax,esi     'search limit
  sub eax,ebx     'offset
  cmp eax,edi     '
  jl xinstr       'no room for keyword
  '
  add edi,ebx     'set offset
  mov ah,[edx]
  '
  trinstr:
  '-------
    cmp edi,esi 'boundary check
    jg xinstr
    mov al,[edi]
    inc edi
    cmp al,ah
    jnz trinstr 'check 1st letter against next
    '
    push edi
    push edx
    push ecx
    inc edx   'second letter
    rinstr:
    '------
      dec ecx     'downcount (second letter onward)
      jle ninstr  'match complete
      mov al,[edi]
      cmp al,[edx]
      jnz nminstr
      inc edx
      inc edi
    jmp rinstr
    '
    nminstr: 'no match
  pop ecx
  pop edx
  pop edi
  jmp trinstr 'carry on searching
  '
  ninstr: 'done
  '------------
  pop ecx
  pop edx
  pop edi
  sub edi,[s0]
  mov [function],edi
  '
  xinstr: 'exit
  '------------
  pop esi
  pop ebx
end asm
end function



'------------------------------------------------------------------------------
function replaces(byval s0 as bstr, byval f0 as bstr, byval r0 as bstr) as bstr
'==============================================================================
  '
  dim as sys a,b,lw,lr,ls,lp
  dim as any ptr p=s0
  '
  'uses customised string concat
  '
  asm
    mov eax,[s0]
    cmp eax,0
    jz norpl 'void string
    mov eax,[eax-4]
    cmp eax,0
    jz norpl 'empty string
    mov [ls],eax
    '-----------
    mov eax,[f0]
    cmp eax,0
    jz norpl 'void keyword
    mov eax,[eax-4]
    cmp eax,0
    jz norpl 'empty keyword (protection)
    mov [lw],eax
    '-----------
    mov eax,[r0]
    cmp eax,0
    jz nunr0 'void replacement
    mov eax,[eax-4]
    mov [lr],eax
    nunr0:
    '
    'make copy of original string
    '----------------------------
    '
    push [ls]
    push 0
    call SysallocStringByteLen 'new uninitialised string
    mov [p],eax
    push [ls]
    push [s0]
    push eax
    call copyn
    mov eax,[p]
    mov [s0],eax
    '
  end asm
  '
  'lw=len(W)
  'lr=len(r)
  '
  a=1
  do
    a=instrsh(a,s0,f0)
    if a=0 then
      exit do
    else
      'ls=ls+lr-lw to calc length of new string
      asm
      mov eax,[ls]
      sub eax,[lw]
      add eax,[lr]
      mov [lp],eax 'save length of new string
      cmp eax,[ls]
      jnz newrpl   'new string is required
      mov eax,[s0] 'new string is not required
      jmp nnewrpl
      '------
      newrpl:
      '------
      push eax
      push 0
      call SysallocStringByteLen 'new uninitialised string
      '---------
      nnewrpl:
      '---------
      mov [p],eax 'new or existing string
      mov eax,[a] 'left length
      dec eax
      push eax
      push [s0]
      push [p]
      call copyn 'append left of s0
      '---------
      mov eax,[lr]
      cmp eax,0
      jz nappsr0 'empty replacement
      push eax
      push [r0]
      mov eax,[p]
      add eax,[a]
      dec eax
      push eax
      call copyn 'append r0
      '---------
      nappsr0:
      '---------
      mov eax,[ls]
      sub eax,[a]
      inc eax
      sub eax,[lw]
      push eax 'length of remaining mid s0
      mov eax,[s0]
      add eax,[a]
      add eax,[lw]
      dec eax
      push eax 'mid s0 position
      mov eax,[p]
      add eax,[a]
      dec eax
      add eax,[lr]
      push eax
      call copyn 'append mid s
      '---------
      mov eax,[p]
      cmp eax,[s0]
      jz nfrepl 'original string was used
      push [s0]
      call SysFreeString 'free Original s0
      mov eax,[p]
      mov [s0],eax 'new s0
      mov eax,[lp]
      mov [ls],eax 'new s0 length
      '------
      nfrepl:
      '------
      mov eax,[lr]
      add [a],eax 'next position to search from
      '----------
      end asm     
      's=left(s,a-1)+r+mid(s,a+lw)
      'a=lr+a'-1
    end if
  loop
  '
  asm norpl:
  '
  function=p
  '
end function



'-----------------------------------------
function getfile(byval w as bstr) as bstr
'=========================================
  '
  dim as sys b,h,p,pf,ph,le,leh
  '
  asm
    '
    'CHECK VALID NAME
    '
    cmp dword ptr [w],0
    jz ngetfile
    '
    'OPEN FILE
    '
    push 0             'HANDLE hTemplateFile OPT
    push 128           'FILE_ATTRIBUTE_NORMAL
    push 3             'CREATE (NEW 1) (ALWAYS 2) (OPEN 4) (OPEN EXISTING 3)
    push 0             'LP SECURITY  ATTRIBUTES OPT
    push 1             'SHARE MODE read(1) write(2)
    push &h80000000    'GENERIC_READ (0x80000000) GENERIC_WRITE (0x40000000)
    push [w] 'name
    call Createfile
    mov [h],eax
    '
    'SET FILE POINTER
    '
    push 0              'DWORD dwMoveMethod 0,FILE_BEGIN(0) FILE_CURRENT(1) FILE_END (2) 
    lea eax,[ph]        'PLONG lpDistanceToMoveHigh
    push eax
    push 0              'LONG lDistanceToMove
    push [h]            'DWORD HANDLE
    call SetFilePointer '
    mov [pf],eax        'File Pointer position low
    '
    'GET FILE SIZE
    '
    lea eax,[leh]       'PLONG lpFileSizeHigh
    push eax            '
    push [h]            'DWORD HANDLE
    call GetFileSize    '
    mov [le],eax        '
    '
    'CREATE STRING BUFFER
    '
    push [le]           'FILE LENGTH
    push 0              'OPTIONAL COPY POINTER
    call SysAllocStringByteLen 'CREATE BSTR
    mov [p],eax
    mov [function],eax
    '
    'READ FILE
    '
    push 0              'LPOVERLAPPED lpOverlapped
    lea eax,[b]         'lpNumberOfBytesRead
    push eax            '
    push [le]           'DWORD nNumberOfBytesToRead
    push [p]            'LPVOID lpBuffer
    push [h]            'DWORD HANDLE
    call ReadFile
    '
    'CLOSE HANDLE
    '
    push [h]
    call CloseHandle
    '
    ngetfile:
    '
  end asm

end function



'-------------------------------------------------------------------------
function putfilen(byval w as bstr, byval s as sys, byval le as sys) as sys
'=========================================================================
  '
  dim as sys b,h,p,pf,ph,leh
  '
  asm
    '
    'CHECK VALID NAME
    '
    xor eax,eax
    cmp dword ptr [w],0
    jz nputfile
    '
    'OPEN FILE
    '
    push 0             'HANDLE hTemplateFile OPT
    push 128           'FILE_ATTRIBUTE_NORMAL
    push 2             'CREATE (NEW 1) (ALWAYS 2) (OPEN 4) (OPEN EXISTING 3)
    push 0             'LP SECURITY  ATTRIBUTES OPT
    push 0             'SHARE MODE read(1) write(2)
    push &h40000000    'GENERIC_READ (0x80000000) GENERIC_WRITE (0x40000000)
    push [w] 'name
    call Createfile
    mov [h],eax
    '
    'SET FILE POINTER
    '
    push 0              'DWORD dwMoveMethod 0,FILE_BEGIN(0) FILE_CURRENT(1) FILE_END (2) 
    lea eax,[ph]        'PLONG lpDistanceToMoveHigh
    push eax
    push 0              'LONG lDistanceToMove
    push [h]            'DWORD HANDLE
    call SetFilePointer '
    mov [pf],eax        'File Pointer position low
    '
    'WRITEFILE
    '
    push 0              'LPOVERLAPPED lpOverlapped
    lea eax,[b]         'lpNumberOfBytesWritten
    push eax            '
    push [le]           'DWORD nNumberOfBytesToWrite
    push [s]            'LPVOID lpBuffer
    push [h]            'DWORD HANDLE
    call WriteFile
    mov [function],eax
    '
    'CLOSE HANDLE
    '
    push [h]
    call CloseHandle

    '
    nputfile:
    '
  end asm

end function


'---------------------------------------------------------
function putfile(byval w as bstr,byval s as bstr) as sys
'=========================================================
  asm
    '
    'GET LENGTH of BSTR TO WRITE
    '
    mov eax,[s]
    '
    '
    push dword ptr [eax-4]
    push [s]
    push [w]
    call putfilen
    mov dword ptr [function],1
    '
  end asm
end function

'


'----------------------------------------------
Function errors() as BSTR
'==============================================
  '
  function=AllocString(strptr(ers), len(ers) )
  ers="" 'clear error buffer
end function





'##############################'
'##                            #
'##                            #
'##############################'
' ############################
' # ||                     | #
' # ||       MAP           | #
' # ||    FUNCTIONS        | #
' # ||                     | #
' # ||                     | #
' # ||                     | #
' # ||                     | #
' # ||                     | #
'##############################'
'##                            #
'##############################'
'

  #define mboxa       2048 'display string in message box
  '#define newlista    2056 'create a generic list (header of 16)
  #define addlista    2064 'add to list
  #define delista     2072 'delete
  #define delchaina   2080 'delete chain of lists
  #define strinstla   2088 'check string instance local
  #define strinstga   2096 'check string instance global
  #define deltmpa     2104
  #define delloca     2112
  'noof               2120
  #define compnnula   2128
  'noofa              2136
'------------------'-----
  #define sysdelbufsa 2144 'del system buffs
  #define catbufprpa  2152 'clear string lists
  #define badcatla    2160 'add byref bstr to cat list [640]
  #define zadcatla    2168 'add z string to cat list   [640]
  #define remimsa     2176 'redim dynamic array
  #define joinsa      2184 'join strings: copy into one
  #define compsa      2192 'compare bstring
  #define compza      2200 'compare zstrings
  #define rworda      2208 'runtime read word
  #define assloca     2216 'assign to local bstr local list [656]
  #define asstmpa     2224 'ssign to temp bstr list [648]
  #define newara      2232 'create new array with header
  #define asstrla     2240 'assign bstring [local list 656]
  #define asstrga     2248 'assign bstring [global list 664]
  #define trbstra     2256 'transfer bstr
  #define shjoinsa    2264 'string shuffle and join for str+=...
  #define sadcatla    2272 'add byval bstr to list (bstr params passed byval)
  #define compisa     2280 'compare with bstr byref with byval
  #define comprisa    2288 'compare with bstr byref with byval
  #define deref0a     2296 'dereference if possible or return 0
  #define compna      2304 'compare n bytes
'------------------'-----
  #define ltrima      2312 'ltrim
  #define rtrima      2320 'rtrim
  #define lcasesa     2328 'lcase
  #define ucasesa     2336 'ucase
  #define leftsa      2344 'left
  'noofa              2352
  #define midsa       2360 'mid
  #define ascsa       2368 'asc
  #define lensa       2376 'len
  #define chrsa       2384 'chr
  #define midza       2392 'mid for asciiz string literals
  #define leftza      2400 'left for asciiz
  'noofa              2408
  #define mids2a      2416 '2 param mid
  #define midz2a      2424 '2 param mid for asciiz
  #define ascs1a      2432 '1 param asc
'------------------'-----
  #define bindlsa     2440 'bind imported ibs and procs
  #define freelsa     2448 'free dlls
  #define midbufa     2456 'mid(s,i)=t
  #define stringaa    2464 'string byte
  #define stringza    2472 'string ztring
  #define stringsa    2480 'string string
  #define spacesa     2488 'space incl zstring
  #define printsa     2496 'print string
  #define instrs2a    2504 '2 parm instr(s,u)
  #define getfile2a   2512 'getfile "t.txt",f
  #define printva     2520 'print value

  #define allocsa     160 'AllocString
  #define freesa      168 'FreeString
  #define atofa       192 'ascii to float
  #define ftoaa       200 'float to ascii


'==============
sub mapruntimes
'==============

' compact functions
' "here" header returns their entry points - 2
'=================='=====
asm                '      [ebx+..]
  adrf (mbox)      ' 2048 display string in message box
  adrf (noof)      ' 2056 was newlist. create a generic list (header of 16)
  adrf (addlist)   ' 2064 add to list
  adrf (delist)    ' 2072 delete
  adrf (delchain)  ' 2080 delete chain of lists
  adrf (strinstl)  ' 2088 check string instance local
  adrf (strinstg)  ' 2096 check string instance global
  adrf (deltmp)    ' 2104 
  adrf (delloc)    ' 2112 
  adrf (noof)      ' 2120
  adrf (compnnul)  ' 2128 
'------------------'-----
  adrf (noof)      ' 2136 
  adrf (sysdelbufs)' 2144 del system buffs
  adrf (catbufprp) ' 2152 clear string lists
  adrf (badcatl)   ' 2160 add byref bstr to cat list [640]
  adrf (zadcatl)   ' 3168 add z string to cat list   [640]
  adrf (redims)    ' 2176 redim dynamic array
  adrf (joins)     ' 2184 join strings: copy into one
  adrf (comps)     ' 2192 compare bstring
  adrf (compz)     ' 2200 compare zstrings
  adrf (rword)    ' 2208 unused
  adrf (assloc)    ' 2216 assign to local bstr local list [656]
  adrf (asstmp)    ' 2224 assign to temp bstr list [648]
  adrf (newar)     ' 2232 create new array with header
  adrf (asstrl)    ' 2240 assign bstring [local list 656]
  adrf (asstrg)    ' 2248 assign bstring [global list 664]
  adrf (trbstr)    ' 2256 transfer bstr
  adrf (shjoins)   ' 2264 string shuffle and join for str+=...
  adrf (sadcatl)   ' 2272 add byval bstr to list (bstr params passed byval)
  adrf (compis)    ' 2280 compare with bstr byref with byval
  adrf (compris)   ' 2288 compare with bstr byref with byval
  adrf (deref0)    ' 2296 dereference if possible or return 0
  adrf (compn)     ' 2304 compare n bytes
'------------------'-----
  adrf (ltrim)     ' 2312 ltrim
  adrf (rtrim)     ' 2320 rtrim
  adrf (lcases)    ' 2328 lcase
  adrf (ucases)    ' 2336 ucase
  adrf (lefts)     ' 2344 left
  adrf (noof)      ' 2352 
  adrf (mids)      ' 2360 mid
  adrf (ascs)      ' 2368 asc
  adrf (lens)      ' 2376 len
  adrf (chrs)      ' 2384 chr
  adrf (midz)      ' 2392 mid for asciiz string literals
  adrf (leftz)     ' 2400 left for asciiz
  adrf (noof)      ' 2408 
  adrf (mids2)     ' 2416 2 param mid
  adrf (midz2)     ' 2424 2 param mid for asciiz
  adrf (ascs1)     ' 2432 1 param asc
'------------------'-----
  adrf (bindls)    ' 2440 bind imported ibs and procs
  adrf (freels)    ' 2448 free dlls
  adrf (midbuf)    ' 2456 mid(s,i)=t
  adrf (stringa)   ' 2464 string byte
  adrf (stringz)   ' 2472 string string
  adrf (strings)   ' 2480 string zstring
  adrf (spaces)    ' 2488 space zstring
  adrf (prints)    ' 2496 print string
  adrf (instrs2)   ' 2504 2 parm instr(s,u)
  adrf (getfile2)  ' 2512 getfile "t.txt",f
  adrf (printv)    ' 2520 print value
'------------------'-----
  jmp xmrt         '
'=================='=====


'LOCATE ENTRY POINT'

'=================='
addrunfun:         '
  add eax,2        '
  mov [ecx],eax    '
  add ecx,8        '
  ret              '




'PASSING LAZY STRINGS BYREF ? VOID



                   '
'=================='
noof: ' unused slots
'------------------'
  here             '
  ret
'------------------'


'=================='
mbox: '2048        '
'------------------'
  here             '
  mov eax,[esp+4]  '
  pusha            '
  push &h324f      ' title: O2
  mov ecx,esp      '
  push 0           '
  push ecx         ' title string
  push eax         ' message string
  push 0           '
  call messagebox  '
  pop eax          ' unstack title string
  popa             '
  ret 4            '
                   '
'=================='
'STRINGS           '
'=================='


'ADD TO CHAINABLE LIST
'=====================

'
'  LIST OF LISTS (from [ebx+640]
'
'  -------------------------------------------------------------------
'  |CAT            |TEMP           |LOCAL          |GLOBAL         |
'  -------------------------------------------------------------------
'  640             648             656             664             672
'
'
'  LIST UNIT:
'
'         if<len   if <len
'  =====----------------------------------------------------------------
'   LEN | lbound | ubound | stride | flags |  DATA                      |
'  =====---------------------------------------------------------------
'       0        4        8        12      16
'  =====----------------------------------------------------------------
'   LEN | lptr   | rptr   | stride | flags |  DATA                      |
'  =====----------------------------------------------------------------
'         if>len   if>len
'
'
'

'=================='
addlist: '2064     ' ( eax strptr edi list pointer ) retains string pointer in eax : return ptr edi for dyn string
'------------------'
  here             '
  addlisti:        '
  push ecx         'save reg
  push edi         'address of list ptr
  mov edi,[edi]    'address of list 'lea edi,[ebx+...]
  mov ecx,[edi+4]  '
  add ecx,16       '
  cmp ecx,4096     'check against list length 4096
  jl addsok        'skip if within list
    '
    'CREATE NEW LIST AND ADD TO CHAIN OF LISTS
    '
    push eax       'save BSTR
    '
    push 4096      'list block size
    call getmem    'space filled with nulls
    '
    mov ecx,[esp+4]'get base list ptr 2nd up on stack
    mov [ecx],eax  'assign as current list in .. to [ebx+ ...]
    mov [eax],edi  'link chain backward from new list to previous list
    mov edi,eax    'make this list current in edi
    mov ecx,16
    '
    pop eax        ' restore BSTR
    '
'------------------'
  addsok:           '
  add dword ptr [edi+4],4    ' new ubound offset
  add edi,ecx      'new edi for dynamic string
  mov [edi],eax    'save BSTR
  pop ecx          'discard main list ptr
  pop ecx          'restore reg
  ret              '
'=================='




'DELETE STRINGS IN LIST
'======================

'------------------'
delist: '2072      ' (ecx index_limit edi list pointer)
'=================='
  here
  '
  delisti:
  '---------
  '
  push esi
  '
  delisti1:
  '
  mov esi,edi      'save list base address
  mov edx,[edi+4]  'ubound
  add edi,edx      'start at end of list
  add edi,16       'offset
  '
  rdofreem:        '
    sub edi,4      '
    sub edx,4      'in reverse order
    jl xdofreem    'done or empty 
    mov eax,[edi]  'get bstring
    cmp eax,1      'check for stop marker
    jz xdofreem1   'to return 1
    push edx       'save downcount
    push eax       '
    call freemem   'free the string
    pop edx        'restore downcount
  jmp rdofreem     '
  '
  xdofreem: 'list completed
  '--------
  '
  mov edi,esi      'restore base
  mov edx,0        'zero records
  mov eax,[edi]    'check for back link
  cmp eax,0        '
  jz xdofreem1     'no more lists
  push edi         'as param for freemem
  mov edi,eax      'back link
  call freemem     'free original list (already on stack)
  jmp delisti1     'go for next list
  '
  xdofreem1:
  '---------
  '
  mov edi,esi
  mov [edi+4],edx  'record remainin records
  pop esi          'restore esi
  ret              '
'=================='




'DELETE CHAINED LISTS OF STRINGS BACKWARDS
'=========================================
                   '
'------------------'
delchain: '2080    '
'=================='
  here
  cmp dword ptr [edi],0 'no list available
  jz ndelchain     '
  '
  delchaini:       '
  push eax
  push edx         '
  '
  push edi         'address of list chain
  mov edi,[edi]    'first list in the chain
  call delisti     'delete current list bstrs
  pop edx          '
  mov [edx],edi    'make current base list
  mov edi,edx      'restore list chain base
  '
  pop edx
  pop eax
  ndelchain:
  ret
'=================='

'=================='
strinstl: '2088
'=================='
here
  cmp dword ptr [ecx],0
  jz nstrinstl
  ret
  nstrinstl:
  push ecx
  push 0
  call getmem
  pop ecx
  'mov eax,0
  lea edi,[ebx+656]
  call addlisti
  mov [ecx],edi  ' assign pointer to variable
  ret

'=================='
strinstg: '2096
'=================='
here
  cmp dword ptr [ecx],0
  jz nstrinstg
  ret
  nstrinstg:
  push ecx
  push 0
  call getmem
  pop ecx
  'mov eax,0
  lea edi,[ebx+664]
  call addlisti
  mov [ecx],edi  ' assign pointer to variable
  ret



'=================='
deltmp: '2104
'=================='
  here
  deltmpi:
  lea edi,[ebx+648]
  call delchaini   'delete temp strings
  ret
'=================='



'=================='
delloc: '2112
'=================='
  here
  lea edi,[ebx+656]
  call delchaini   'delete local strings
  ret
'=================='


'=================='
compnnul: '2128
'=================='
  here
  mov ecx,[esp+8]  ' length
  mov edi,[esp+4]  ' address
  cmp edi,0        ' test null pointer
  jz cmpbnok       '
  '
  cmpbdo:          ' compare each char
    dec ecx   
    jge cmpb2
      '
      'end string zero flag
      '
      xor eax,eax
      ret 8
    cmpb2:
    cmp byte ptr [edi],0
    jnz cmpbnok    '
    inc edi        '
  jmp cmpbdo       '
  cmpbnok:
  ret 8
'=================='



'=================='
'=================='
                   '

'##################'
' TYPLIST: LEN PTR '
'##################'

'
'
'
'
'
'   =============
'   |  |  |  |  |
'   ============
'   #  #  #  #  #
'   #  #  #  #  #
' 
'  ###############
'  #             #
'  #             #
'  #             #
'  #             #
'  #             #
'  #             #
'  #             #
'  #             #
'  ###############


'===============================
'SYSTEM BUFFERS FOR STRING LISTS
'===============================

'NEW SET OF BUFFERS

''=================='
'sysnewbufs: '2136  ' setup sysem buffers: string lists etc
''=================='
' here 
''itr size of local and glo lists             '
' lea edi,[ebx+640]'
''------------------'
' call snewbuf      ' 640 CONCAT LIST
' call snewbuf      ' 648 TEMP DEL LIST
' call snewbuf      ' 656 LOCAL DEL LIST 
' call snewbuf      ' 664 STATIC & GLOBAL DEL LIST
''------------------'
' '
' 'SETUP LIBRARY HANDLE STORE
' '
' push 2048 'FOR 512 LIB HANDLES
' callgetmem
' mov [ebx+680],eax
' '
' ret               '
''------------------'
' snewbuf:          '
' push 1024         '
' call getmem       '
''------------------'
''create init header'
' mov byte ptr [eax],16
' mov byte ptr [eax+4],16
' mov byte ptr [eax+8],4
' mov [edi],eax     '
' ' mov [edi+32],eax  ' dup base to record base list
' add edi,4
' ret               '
'=================='



'DELETE LIST BUFFERS

'=================='
sysdelbufs: '2144  '
'=================='
 here
              '
   push [ebx+640]    'concatenation buffer
   call freemem      '
   lea edi,[ebx+648] 'temp list
   call cdelsysbufs
   lea edi,[ebx+656] 'local list
   call cdelsysbufs
   lea edi,[ebx+664] 'global list
   call cdelsysbufs
   push [ebx+680]    'lib handle buffer
   call freemem
   '
 ret

 cdelsysbufs:      ' repeat
'------------------'
'delete each list  '
'------------------'
  cmp  dword ptr [edi],0
  jz ndempty
  call delchaini'delete strings in list
  push [edi]
  call freemem     'free this final list
'------------------'
  ndempty:
  ret               '
'=================='




'PREPARE JOIN-BUFFER

'=================='
catbufprp: '2152        '
'=================='
  here
  push edi
  mov edi,[ebx+640]
  cmp dword ptr [edi],16
  jg ncatbufprp
    mov dword ptr [edi],16
  ncatbufprp:
  add dword ptr [edi],8
  add edi,[edi]
  mov dword ptr [edi-8],-1 'PLACE STOP MARKER
  pop edi
  ret



'ADD BSTR TO LIST  ' byref ptr in eax, list in edi

'=================='
badcatl: '2160     ' ptr in eax, list in edi
'=================='
 here
 cmp eax,0         ' pointer exist?
 jnz nbadcatl1     '
   ret             '
 nbadcatl1:        '
 mov eax,[eax]     ' deref
 push edi
 mov edx,0
 cmp eax,0
 jz nbadcatl2        '
 mov edx,[eax-4]   ' get length
 nbadcatl2:
 mov edi,[ebx+640] ' catlist 
 mov ecx,[edi]     ' next place
 add ecx,8         ' preinc stride of 2 dwords
 mov [edi],ecx     '
 add ecx,edi       '
'------------------'
 mov [ecx-8],edx   ' store length
 mov [ecx-4],eax   ' store pointer
 pop edi
 ret               '
'=================='



'ADD ZSTR TO LIST  '

'=================='
zadcatl: '2168     ' ptr in eax, list in edi
'=================='
 here              '
 cmp eax,0 'check for null pointer
 jnz nzad
 ret
 nzad:
 push edi
 mov edi,[ebx+640]' catlist 
 mov ecx,[edi]     ' next place
 add ecx,8         ' preinc place in list
 mov [edi],ecx     '
 add ecx,edi       '
'------------------'
 push eax          ' save string base pointer
 push ecx          ' save list place pointer
 xor edx,edx       ' clear counter         ' 
   rzadl:          '
     mov cl,[eax]  ' get character
     inc edx       ' add to count
     inc eax       ' add to pointer
     cmp cl,0      ' is it a null char
   jnz rzadl       ' repeat if not
 pop ecx           ' restore list place pointer
 pop eax           ' restore string base pointer
 dec edx           ' count excluding null terminator char
 mov [ecx-8],edx   ' store length excl null
 mov [ecx-4],eax   ' store pointer
 pop edi
 ret               '
'=================='






'JOIN STRINGS TOGETHER
'
'STACKING VERSION TO HANDLE NESTED STRING EXPRESSIONS
'
'=================='
' FORMAT: LEN PTR '
'=================='

'  #################################           ############################
'  # |  |  |  |  |  |  |  |  |  |  #  =====|>  #                          #
'  #################################           ############################



'STACKING SCHEME (ascending stack)

'------------
' HEADER:
'  0 LIMIT BOUNDARY
'  4 CURRENT BOUNDARY
'  8 UNUSED
' 12 UNUSED
'------------
' STRING LIST
'------------
' stop marker
'------------
' new string
' new string
'------------
' stop marker
'------------
' new string
' new string
'...
'==================

'
'REDIM M(I) macro
'
'mov eax,[ebx+i] : inc eax : sub eax,indexbase : mul eax,extentof m : lea edi,[ebx+m] : call [ebx+2176]
'
'MACRO REDIM
'ecx=%2 * sizeof %1 : lea edi,%1 : call [ebx+2176]
'
'==================
redims: '2176       'pass effective address in edi, and size in eax
'==================
  here
  'mov ecx,[esp+8]
  'mov edi,[esp+4]
  mov eax,[edi]
  cmp ecx,0
  jnz nnuldim
    cmp eax,0
    jz znuldim     'null item
      push eax     '
      call freemem 'free BSTR
      mov dword ptr [edi],0
    znuldim:
    ret
  nnuldim:
  push ecx
  push ecx
  call getmem
  pop ecx
  cmp dword ptr [edi],0
  jnz nexdims
    mov [edi],eax 'new BSTR
    ret
  nexdims:
  push esi
  mov esi,eax     'address
  mov edx,[edi]   'original BSTR
  mov eax,[edx-4] 'original length
  cmp ecx,eax
  jge ncopmin
    mov ecx,eax 'min amount to copy
  ncopmin:
  push esi 'save new BSTR
  rcopmin: 'copy dwords (min 4 bytes)
    mov eax,[edx]
    mov [esi],eax
    add edx,4
    add esi,4
    sub ecx,4
  jg rcopmin
  pop esi        'restore new BSTR
  push [edi]     'free old BSTR
  call freemem   '
  mov  [edi],esi 'transfer BSTR
  pop esi  
  ret




'null strings must not be present in the buffer list.

'================== '
joins: '2184        ' ( eax destptr if exists, edi list of strings to) eax new string ptr
'================== '
  here              '
  '                 '
  joinsi:           '
  '                 '
  push esi          ' save reg
  push edi          ' save reg
  '
  mov edi,[ebx+640] 'the join string list
  mov esi,[edi]     ' count step
  add edi,esi       ' end of data
  sub esi,16        ' base zero
'------------------ '
  xor ecx,ecx       ' byte counter
  '
  '-------
  docount:          ' do
  '-------
  
    sub edi,8       ' last data downward
    sub esi,8       ' down counter
    jl xdocount     ' exit
    mov edx,[edi]   '
    cmp edx,-1      ' CHECK FOR STOP MARKER
    jz xdocount     '
    add ecx,edx     ' add length of string
  jmp docount       ' repeat
  xdocount:         ' finished counting bytes
  '
  'CHECK EMPTY?
  '
  cmp ecx,0
  jnz nejoinsi
    cmp eax,0
    jz nejoinsi 'to create a null Bstring
    mov word ptr [eax],0 ' NULL TERMINATION: 2 NULL BYTES
    jmp ajoinsi    
  nejoinsi:
  '
  mov esi,ecx       ' byte total req
  '
  'accepts 0 byte requests
  '
  cmp eax,0         ' request new Bstring or use existing Zstring
  '
  'itr check overflow before
  '
  jnz nnews         '
    push ecx        'req n bytes
    call getmem     'create new string
    cmp eax,0       'test for success
    jz ajoinsi      'failure so exit with null bstr
    cmp dword ptr [eax-4],0
    jz ajoinsi      'no bytes to transfer so exit with valid bstr
    jmp dnews       'otherwise prepare for copy joining
  '
  nnews: 'for Zstrings
  '
  mov word ptr [eax+esi],0 'insert double null into target boundary
  '
  '-----
  dnews: 'entry point for copy joining
  '-----
  '
  push eax          'target base
  mov ecx,esi       'byte count
  xor edx,edx       'clear byte adder
  '
  push edi          'save stop point
  '
  rcopa:
    add edi,8       'step forward for next string
    cmp edx,ecx     'check byte count
    jge xcopa       'copied all the bytes so exit
    add edx,[edi]   'n to copy
    push ecx        'save byte count
    push edx        'save byte tally
    mov ecx,[edi]   'LENGTH OR STOP MARKER
    cmp ecx,0
    jle ncops
    mov esi,[edi+4] 'pointer
    '
    rcops:          'copy over
      mov dl,[esi]  'source byte
      mov [eax],dl  'dest
      inc eax       'inc dest
      inc esi       'inc src
      dec ecx       'downcount bytes to copy
    jg rcops        'continue copying
    '
    ncops:
    '
    pop edx         'restore byte tally
    pop ecx         'restore byte count
  jmp rcopa
  '
  '-----
  xcopa:
  '-----
  '
  pop ecx           'restore stop point
  '
  mov edi,[ebx+640]
  sub ecx,edi
  mov [edi],ecx    'boundary for next string
  cmp ecx,16
  jg nemptyb
    mov dword ptr [edi],16
  nemptyb:
  '
  'call deltmpi 'RELEASE TMP STRINGS

  '
  pop eax          'restore target base
  '
  xjoinsi:
  '
  pop edi          'restore edi
  pop esi          'restore esi
  ret     
  '
  '(null string or Bstring denied)
  '
  '
  '-------
  ajoinsi: 'cleardown for null byte strings
  '-------
  '
  push eax
  push ecx
  jmp xcopa
  





'COMPARE DYNAMIC STRINGS

'=================='
comps: '2192       '  (compare [esp+8]-[esp+4] )
'------------------'
here               '
compsi:            ' select least length
  mov edx,[esp+8]  '
  mov ecx,[esp+4]  '
  cmp edx,0        ' test null ptr
  jz cmpnok1       '
  mov edx,[edx-4]  '
  cmpnok1:         '
  cmp ecx,0        ' test null ptr
  jz cmpnok2       '
  mov ecx,[ecx-4]  '
  cmpnok2:         '
  cmp edx,0        ' test zero length
  jz cmpnok        '
  cmp ecx,0        ' test zero length
  jz cmpnok        '
  cmp edx,ecx      '
  cmovl ecx,edx    ' select least length
  mov edx,[esp+8]  '
  mov edi,[esp+4]  '
  cmpdo:           ' compare each char
    mov al,[edx]   ' from L string 
    cmp al,[edi]   ' from R string
    jnz cmpxr1     '
    inc edx        '
    inc edi        '
    dec ecx        '
  jge cmpdo        '
                   ' tie break: which string is longer
  mov edx,[esp+8]  '
  mov edx,[edx-4]  ' get  Llength
  mov ecx,[esp+4]  '
  mov ecx,[ecx-4]  ' get R length
  cmpnok:         '
  cmp edx,ecx      ' null ptrs, null lengths or tie breaks
  cmpxr1:          ' flags hold result
  ret 8            '
                   '
'=================='



'COMPARE Z STRINGS

'=================='
compz: '2200       '  (compare [esp+8]-[esp+4] ) zstrings
'------------------'
  here             '
  mov edx,[esp+8]  '
  mov ecx,[esp+4]  '
  cmp edx,0        ' test null pointers
  jz cmpznok       '
  cmp ecx,0
  jz cmpznok       '
  mov edi,ecx      '
  cmpzdo:          ' compare each char
    mov al,[edx]   ' from L string
    mov cl,[edi]   '
    cmp al,cl      ' from R string
    jnz cmpzxr     '
    cmp al,0       '
    jz cmpzxr      '
    inc edx        '
    inc edi        '
  jmp cmpzdo       '
  cmpzxr:          ' flags hold result
  ret 8            '
  cmpznok:
  cmp edx,ecx
  ret 8
                   '
'=================='



'=================='
rword: '2208
'=================='
  '
  here
  '
  '
  '-----------------------
  'SKIP SPACE AND COMMENTS
  '-----------------------
  '
  mov dl,0
  rworsp:
    '
    mov al,[esi]
    inc esi
    cmp al,0
    jz xwor
    cmp al,32
    jle rworsp
    cmp al,44
    jz rworsp 'ignore comma
    cmp al,39
    jnz wordr
    '
    rcommr: 'bypass comment line
      '
      mov al,[esi]
      inc esi
      cmp al,0
      jz xwor
      cmp al,13
      jle rworsp 'end of comment reached so continue
    jmp rcommr
  '
  '-------------------
  wordr: 'first letter
  '-------------------
  '
  dec esi
  mov ecx,esi
  '
  mov al,[esi]
  inc esi
  '
  cmp al,34 'double quote
  jz oqwor
  cmp al,96 'back quote
  jz oqwor
  jmp nqwor
  '
  '-----------------------------
  oqwor: 'capture between quotes
  '-----------------------------
  '
  mov dl,34
  mov ah,al
  '
  rqwor: 'next character
    mov al,[esi]
    cmp al,0
    jz xwor
    inc esi
    cmp al,ah
  jnz rqwor
  '
  '
  jmp xwor 'end of quote / end of word
  '
  '-----------------------
  nqwor: 'npn-quoted words
  '-----------------------
  '
  'locate next boundary (space or comma or quote)
  '
  rspc: 'repeat for next word
    '
    mov al,[esi]
    inc esi
    cmp al,96
    jz nspc
    cmp al,44 
  ja rspc
  '
  nspc:
  '
  dec esi
  '
  'assign variable according to type ??
  '
  '
  '--------------------
  xwor: 'word 'captured
  '--------------------
  '
  'updated pointer returned in esi
  'start of word ptr in eax
  'length in ecx
  'quote flag in dl
  '
  mov eax,ecx 'start of word
  neg ecx
  add ecx,esi 'convert to length
  '
  'strip quotes
  '
  cmp dl,34 ' "
  jnz noqts
  cmp dl,96 ' `
  jnz noqts
  inc eax   'move pointer forward
  sub ecx,2 'deduct 2 from length
  '
  noqts:
  '
ret



'ADD BSTR TO LOCAL LIST

'=================='
assloc: '2216      ' ecx addr of chainable list
'------------------'
here               '
  lea edi,[ebx+656]
  call addlisti
  ret              '
'=================='



'ADD BSTR TO TEMP LIST

'=================='
asstmp: '2224      '
'=================='
here
  asstmpi:
  lea edi,[ebx+648]
  call addlisti
ret
'=================='



' CREATE NEW ARRAY WITH HEADER

'=================='
newar: '2232       ' byte size in ecx, return ptr in eax
'=================='
here               '
newari:            '
  push ecx         ' array size bytes
  call getmem      ' create array string
  mov byte ptr [eax],16 ' internal lbound
  mov byte ptr [eax+4],16 ' internal ubound
  mov byte ptr [eax+8],4 ' default stride
  ret              '
'=================='



'ASSIGN LOCAL BSTRING

'=================='
asstrl: '2240      ' dyn addr in ecx, bstr in eax
'=================='
here
  mov edi,[ecx]    '
  cmp edi,0        ' pointer exists?
  jnz naddl        '
    lea edi,[ebx+656]
    call addlisti  ' add to chainable list
    mov [ecx],edi  ' assign pointer to variable
   ret
  naddl:           '
  cmp dword ptr [edi],0' bstring already exists?
  jz nwipe         '
    push eax       '
    push [edi]     '
    call freemem   ' release original bstr
    pop eax        '
  nwipe:           '
  mov [edi],eax    ' assign bstr to pointer
ret                '
'=================='



'ASSIGN GLOBAL/STATIC BSTR

'=================='
asstrg: '2248      ' dyn addr in ecx, bstr in eax
'=================='
here               '
  mov edi,[ecx]    '
  cmp edi,0        ' pointer exists?
  jnz naddlg       '
    lea edi,[ebx+664]
    call addlisti  ' add to chainable list
    mov [ecx],edi  ' assign pointer to variable
     ret
  naddlg:          '
  cmp dword ptr [edi],0' bstring already exists?
  jz nwipeg        '
    push eax
    push [edi]     '
    call freemem   ' release original bstr
    pop eax        '
  nwipeg:          '
  mov [edi],eax    ' assign bstr to pointer
ret                '
'=================='



'TRANSFER BSTRING (return value in function)

'=================='
trbstr: '2256      ' transfer dyn string for returning BSTR
'=================='
here               '
  cmp edi,0        '
  jnz nxis1        '
    xor eax,eax    '
    ret            '
  nxis1:           '
 cmp dword ptr [edi],0 ' string already exists?
  jnz nxis2        '
    xor eax,eax    '
    ret            '
  nxis2:           '
  mov eax,[edi]    '
  mov dword ptr [edi],0 ' null record on del list
ret                '
'=================='



'SHUFFLE LAST TO FIRST THEN JOIN

'=================='
shjoins: '2264     ' shuffle and join
'=================='
here
  push eax         '
  push esi
  push edi         '
'------------------'
  mov edi,[ebx+640]'the join string list
  mov esi,[edi]    ' count step
  cmp esi,16       ' empty
  jle xshjoins     '
  add edi,esi      ' end of data
  sub edi,8        ' last string record
  sub esi,16       ' base counter zero
  mov ecx,[edi]    ' hold length last string
  mov edx,[edi+4]  ' hold ptr last string
  'cmp edx,0        ' CHECK FOR NULL STRING PTR
  'jz  xshjoins     '
  'cmp ecx,0        ' CHECK FOR EMPTY STRING
  'jz xshjoins      '
'------------------'
  doshuf:          ' do
    mov eax,[edi-8]' TRANSFER LENGTH
    cmp eax,-1     ' CHECK FOR END MARKER
    JZ xdoshuf     ' EXIT IF MARKER
    mov [edi],eax  '
    mov eax,[edi-4]' TRANSFER POINTER
    mov [edi+4],eax'
    sub edi,8      ' next string back
    jmp doshuf     ' repeat
  xdoshuf:         ' finished counting bytes
'------------------'
  mov [edi],ecx    ' insert length
  mov [edi+4],edx  ' insert ppointer
'------------------'
  xshjoins:
  pop edi
  pop esi          '
  pop eax          '
'------------------'
  call joinsi      '
ret                '
'=================='


'ADD BSTR TO LIST  ' byval bstr in eax, list in edi

'=================='
sadcatl: '2272     ' bstr byval in eax
'=================='
 here
 mov edx,0
 cmp eax,0         ' bstr exist?
 jz nsadcatl1      '
 mov edx,[eax-4]   ' get length
 nsadcatl1:        '
 push edi          '
 mov edi,[ebx+640] ' catlist 
 mov ecx,[edi]     ' next place
 add ecx,8         ' preinc stride of 2 dwords
 mov [edi],ecx     '
 add ecx,edi       '
'------------------'
 mov [ecx-8],edx   ' store length
 mov [ecx-4],eax   ' store pointer
 pop edi
 ret               '
'=================='



'BSTRING BYREF COMPARE

'=================='
compis: '2280      'bstr byref compare operand with accum
'=================='
here               '
mov eax,[esp+8]    ' operand
cmp eax,0          '
jz ncompis         '
mov eax,[eax]      '
ncompis:           '
  mov [esp+8],eax  '
jmp compsi         '
'=================='

'=================='
compris: '2288     'bstr byref compare with accum with operand
'=================='
here               '
mov eax,[esp+8]    ' operand
cmp eax,0          '
jz ncompris        '
mov eax,[eax]      '
ncompris:          '
  mov ecx,[esp+4]  '
  mov [esp+8],ecx  ' swap so that accum is compared with operand
  mov [esp+4],eax  ' 
jmp compsi         '
'=================='



'DEREF IF POSSIBLE OR RETURN 0

'=================='
deref0: '2296
'=================='
here
  cmp eax,0
  jnz derefok
  ret
  derefok:
  mov eax,[eax]
  ret
'=================='


'=================='
compn: '2304       '  COMPARE [esp+12] WITH [esp+4] NSTRING
'------------------'
  here
  mov edx,[esp+12] ' lstring
  mov edi,[esp+4]  ' rstring
  cmp edx,0        ' test null pointer
  jz cmpnnok       '
  cmp edi,0        ' test null pointer
  jz cmpnnok       '
  mov ecx,[esp+16]  ' length lstring
  cmp ecx,[esp+8]   ' compare length of rstring
  cmovg ecx,[esp+8] 'least length
  '
  cmpndo:           ' compare each char
    dec ecx   
    jge cmpn2
      '
      'tie break on length
      '
      mov ecx,[esp+16] 'l length
      cmp ecx,[esp+8]  'r length
      ret 16
    cmpn2:
    mov al,[edx]   ' from L string
    cmp al,[edi]   ' from R string
    jnz cmpnxr     '
    inc edx        '
    inc edi        '
  jmp cmpndo       '
  cmpnxr:          ' flags hold result
  ret 16
  '
  'tie break on null ptr
  '
  cmpnnok:
  cmp edx,edi
  ret 16
                   '
'=================='

 

'
'                                      ####
'         ###                        ###   ####
'       ##   ##                    ##          ####STRINGS
'     ##       ##                 ##
'   ##          ##               ##
'  ##            ##            ##
'  ##             ##         ##
'                   ##     ##
'                     #####
'
'
'=================
'string management
'=================
'


'=================='
ltrim: '2312
'=================='
here
  push esi
  mov edi,0
  mov esi,[esp+8] 'pointer
  cmp esi,0
  jz xltrim1
  mov edi,[esi-4] 'length
xltrim1:
  cmp edi,0
  jle xltrim2
ltrimr:
  dec edi
  jl ltrimx
  mov al,[esi]
  inc esi
  cmp al,32
  jle ltrimr
ltrimx:
  inc edi
  dec esi
xltrim2:
  push edi
  push 0
  call SysAllocStringByteLen
  'call [ebx+160] 'AllocString
  push eax
  '
  push edi ' remaining length
  push esi ' start of str
  push eax ' new string dest
  call copyn
  '
  pop eax
  pop esi
  ret 4
'=================='


'=================='
rtrim: '2320
'=================='
here
  push esi
  mov edi,0
  mov esi,[esp+8]  ' pointer
  cmp esi,0        'check null ptr
  jz xrtrim1
  mov edi,[esi-4]  ' length
xrtrim1:
  cmp edi,0
  jle xrtrim2
  add esi,edi   ' end of string
rtrimr:
  dec edi
  jl rtrimx
  dec esi
  mov al,[esi]
  cmp al,32
  jle rtrimr
rtrimx:
  mov esi,[esp+8]
  inc edi
xrtrim2:
  push edi
  push 0
  call SysAllocStringByteLen
  'call [ebx+160] ' AllocString
  push eax
  '
  push edi ' remaining length
  push esi ' start of str
  push eax ' new string dest
  call copyn
  '
  pop eax
  pop esi
  ret 4
'=================='


'=================='
lcases: '2328
'=================='
here
  push esi
  mov esi,[esp+8]
  mov edi,0
  cmp esi,0 'null string test
  jz lwrx1
  mov edi,[esi-4]
  lwrx1:
  push edi
  push 0
  call SysAllocStringByteLen
  mov edx,edi
  mov edi,eax
  push eax
lwrr:
  dec edx
  jl lwrx
  mov al,[esi]
  cmp al,65
  jl lwrn
  cmp al,90
  jg lwrn
  add al,32
  lwrn:
  mov [edi],al
  inc esi
  inc edi
  jmp lwrr
lwrx:
  pop eax
  pop esi
  ret 4
'=================='


'=================='
ucases: '2336
'=================='
here
  push esi
  mov esi,[esp+8]
  mov edi,0
  cmp esi,0 'null string test
  jz uprx1
  mov edi,[esi-4]
  uprx1:
  push edi
  push 0
  call SysAllocStringByteLen
  mov edx,edi
  mov edi,eax
  push eax
uprr:
  dec edx
  jl uprx
  mov al,[esi]
  cmp al,97
  jl uprn
  cmp al,122
  jg uprn
  sub al,32
  uprn:
  mov [edi],al
  inc esi
  inc edi
  jmp uprr
uprx:
  pop eax
  pop esi
  ret 4
'=================='



'=================='
lefts: '2344
'=================='
here
  pop eax  'return address
  pop edx  'string
  push 1   'insert offset
  push edx 'string
  push eax 'return address
  jmp midsi
'=================='

'2352 ?



'===================='
mids: '2360
'===================='
here
  '
midsi: 'entry point for bstrings
  '
  mov ecx,0          ' default source length is 0
  mov edi,[esp+4]    ' ptr
  cmp edi,0
  jz midok1
  mov ecx,[edi-4]    'get source length
  '
midok1: ' the length of source
  '
'------------------------------                   '
astrin: 'entry point for asciiz
'------------------------------
                     '
  push esi           ' preserve esi
  mov edx,[esp+12]   ' get offset
  '                  '
  '-------------     '
  'NEG OFFSETS       '
  '-------------     '
  '                  '
  cmp edx,0          '
  jnz midnoinc
  inc edx            'change offset 0 to 1
midnoinc:

  jg midok2         'skip if offset not negative
  '
  inc edx
  add edx,ecx       'add length to negative offset to obtain offset
  jg midok2         '
  mov edx,1         'must be at least 1
  '
midok2: 'assess whether any bytes are available    
  '         '
  cmp edi,0          'null or empty source string
  jz midnul          '
  cmp ecx,edx        'compare bytes available with offset
  jge midok3         'not past end end of source string
  '
midnul: 'no bytes are available so a null string is to be returned
  '
  push 0             '
  push 0             '
  call SysAllocStringByteLen
  'call [ebx+160]    'AllocString
  jmp midx           'null string allocation done
  '
midok3: 'at least one byte is available to return
  '
  mov eax,ecx        'length of source
  dec edx            'zero base adjust the offset
  sub eax,edx        'deduct from source to get bytes available
  cmp eax,[esp+16]   'bytes requested
  jle midok4
  mov eax,[esp+16] 'bytes requested iss less than bytes avail
  '
midok4:
  '
  push eax           'bytelength for copyn
  add edi,edx        'src base+offset
  push edi           'source for copyn
  push eax           'bytelength for SysAlloc
  push 0             'null string for SysAlloc
  call SysAllocStringByteLen
  'call [ebx+160] 'AllocString
  push eax           'new string dest for copyn
  mov esi,eax        'retain new string in non-volatile reg
  call copyn         '
  mov eax,esi        ' new bstring to return
  '
midx:                '
  '
  pop esi            'restore esi
  ret 12             '
'===================='


'=================='
ascs: '2368
'=================='
here               '
  ascsi:
  xor eax,eax
  push esi         '
  mov esi,[esp+8]  'pointer
  cmp esi,0
  jz ascx
  mov edi,[esi-4]  'length
  cmp edi,0
  jle ascx
ascsi1:            '
  xor eax,eax      'clear
  mov edx,[esp+12] 'req pos
  cmp edx,0        '
  jnz asco1        '
  inc edx          'set to 1
asco1:             '
  jge ascso2       'neg spec
  add edx,edi      '
  inc edx          'base adjust
ascso2:            '
  cmp edx,1        'lower limit check
  jl ascx          'leave as null
  cmp edi,edx      'upper limit check
  jl ascx          'leave as null
  dec edx          'base adjust
  add esi,edx      '
  mov al,[esi]     '
ascx:              '
  pop esi          '
  ret 8            '
'=================='


'=================='
lens: '2376        '
'=================='
here               '
  mov eax,[esp+4]  '
  cmp eax,0        '
  jz nlens         '
  mov eax,[eax-4]  '
  nlens:           '
  ret 4            '
'=================='



'=================='
chrs: '2384
'=================='
here               '
  push 1           '
  push 0           '
  call SysAllocStringByteLen
  'call [ebx+160] 'AllocString
  mov dl,[esp+4]   '
  mov [eax],dl     '
  ret 4            '
'=================='


'mid for asciiz

'=================='
midz: '2392
'=================='
here
midzi:
  mov edi,[esp+4] 'pass base in edi
  mov ecx,edi
rmidz:
  mov al,[ecx]
  inc ecx
  cmp al,0
  jnz rmidz
  dec ecx          'exclude null term in count
  sub ecx,edi      'pass length in ecx
  jmp astrin
'=================='

'=================='
leftz: '2400
'=================='
here
  pop eax  'return address
  pop edx  'string base
  push 1   'insert offset
  push edx 'string basr
  push eax 'return address
  jmp midzi
'=================='



'2 PARAM MID

'=================='
mids2: '2416
'=================='
here
  pop eax  'return address
  pop ecx  'string base
  pop edx  'string offset
  '
  cmp ecx,0
  jnz nnulm2el
    '
    push 0 'length req
    jmp nnulm2ei
    '
  nnulm2el:
    '
    push [ecx-4] 'length req
    '
  nnulm2ei:
  '
  push edx 'string offset
  push ecx 'string base
  push eax 'return address
  jmp midsi
'=================='


'=================='
midz2: '2424
'=================='
here               '
  pop eax          'return address
  pop edi          'address base
  pop edx          'offset
  push &h7fffffff  'req max length
  push edx         'offset
  push edi         'ptr
  push eax         'return address
  jmp midzi        '
'=================='


'SINGLE PARAM ASCII

'=================='
ascs1: '2432
'=================='
here
pop ecx            'return address
pop eax            'string base
push 1             'offset
push eax           'string pointer
push ecx           'return address
jmp ascsi          '2 term asc
'=================='






'O2H RUNTIME BIND TO IMPORTED DLLS

'------------
'COMMAND BYTE
'============
'00 NULL TERMINATOR
'01 NEW LIBRARY NAME
'02 PROCADDRESS
'03 END

'======================'
bindls: '2440
'======================'
here
'
  'SAVE BASE
  '---------
  '
  push ebx 'GLOBAL BASE [ESP+4]
  '
  'STORE BINDING DATA
  '------------------
  '
  mov edi,eax
  mov [ebx+672],edi 'BINDING DATA
  '
  'PREPARE LIST FOR LIBRARY HANDLES (512)
  '--------------------------------------
  '
  'this list is used for unloading libraries with FREELIBRARY
  '
  mov eax,[ebx+680]
  add eax,[eax]         '1ST DWORD HOLDS OFFSET FOR NEXT DATA
  add eax,4
  mov dword ptr [eax],1 'SET MARKER
  add eax,4
  push eax  'HOLD LIBRARY LIST BASE ON STACK [ESP]
  '
  '
  'GET COMMAND
  '-----------
  '
  mov al,[edi]
  '
  '--------------------
  rbindlsa: 'LOOP POINT
  '====================
  '
  'CHECK FOR TERMINATORS
  '---------------------
  '
  cmp al,0
  jz xbindls 'NULL TERMINATION OF LIST
  cmp al,3
  jz xbindls 'FORMAL END OF LIST
  '
  'CHECK FOR LOAD LIBRARY
  '----------------------
  '
  cmp al,1
  jz bindlslok
  mov eax,100 'REPORT INVALID COMMAND
  jmp xbindls
  bindlslok:
  '
  call bindlsw
  push ecx
  push ecx
  call LoadLibrary
  'call [ebx+24] 'library
  pop ecx
  '
  'CHECK VALID LIBRARY HANDLE
  '--------------------------
  '
  cmp eax,0
  jnz nbindlsl
  mov eax,101 'REPORT INVALID LIBRARY NAME
  jmp xbindls
  nbindlsl:
  '
  'HOLD/SAVE LIBRARY HANDLE
  '------------------------
  '
  mov esi,eax 'LIBRARY HANDLE
  pop eax
  mov [eax],esi
  add eax,4 'NEXT LIBRARY HANDLE STORAGE ADDRESS
  push eax
  mov al,[edi]
  '
  'CHECK FOR GETPROCADDRESS
  '------------------------
  '
  cmp al,2
  jnz rbindlsa 'NEXT PROC ADDRESS OR NEXT LIBRARY
  '
  '
  'NEXT PROC ENTRY
  '---------------
  '
  '-----------------------------------
  rbindlsp: 'LOOP POINT FOR PROCEDURES
  '===================================
  '
  'HOLD TABLE OFFSET
  '-----------------
  '
  inc edi
  mov edx,[edi] 'VARIABLE ADDRESS (will be an offset from esi)
  push edx
  add edi,3
  '
  'GET PROC NAME
  '-------------
  '
  call bindlsw
  push ecx   ' PROCNAME PTR
  push ecx   ' PROCNAME PTR
  push esi   ' LIBRARY
  call getprocaddress
  'call [ebx+40] 'getprocaddress
  pop ecx    ' RESTORE PROCNAME PTR
  pop edx    ' RESTORE TABLE OFFSET
  '
  'CHECK VALID PROC ADRESS
  '-----------------------
  '
  cmp eax,0
  jnz bindlspok
  mov eax,102 ' REPORT PROCADDRESS ERROR
  jmp xbindls
  '
  '---------
  bindlspok:
  '=========
  '
  'STORE PROCADDRESS IN TABLE
  '--------------------------
  '
  add edx,[esp+4] ' ADD STATIC VARIABLE BASE [ESI]
  mov [edx],eax   ' STORE ADDRESS
  mov al,[edi]
  '
  'ANOTHER PROC?
  '-------------
  '
  cmp al,2
  jz rbindlsp 'ANOTHER PROCADRESS ENTRY
  '
  'NEXT LIB OR EXIT
  '----------------
  '
  jmp rbindlsa 'OTHERWISE NEXT LIB OR FINISH
  '
  'EXIT POINT
  '----------
  '
  '-------
  xbindls:
  '=======
  '
  'MUST RETAIN EAX/AL CONTENTS
  '
  pop esi 'NEXT LIB HANDLE STORAGE ADDRESS
  mov edx,[ebx+680]
  sub esi,edx
  sub esi,4
  mov [edx],esi 'STORE NUMBER OF LIBRARY ADDRESSES *4
  pop ebx 'RESTORE BASE
  ret     'RETURN
  '
  '
  'READ FOLLOWING NAME
  '-------------------
  '
  '-------------------------------------
  bindlsw: 'ADVANCE BEYOND WORD BOUNDARY
  '=====================================
  '
  inc edi
  mov ecx,edi
  '
  '---------------------
  rbindlsw: ' LOOP POINT
  '---------------------
  '
  mov al,[edi]
  inc edi
  cmp al,0
  jnz rbindlsw
  ret

  '=================='





'FREE DLLS USING LIST

'=================='
freels: '2448
'=================='
here
  '
  'LOCATE END POSITION
  '
  mov edi,[ebx+680]
  mov eax,[edi]
  cmp eax,0      'CHECK IF EMPTY
  jz xxfreels
  add edi,eax
  add edi,4
  '
  '
  '--------------------------
  'REPEAT TILL MARKER OR NULL
  '--------------------------
  '
  'FREE LIBS WORKING BACKWARDS TILL BOUNDARY MARKER
  '
  rfreels:
    sub edi,4
    'cmp dword ptr [edi],0
    'jz xfreels
    cmp dword ptr [edi],1 'EXIT AT MARKER
    jz xfreels
    push [edi]
    call FreeLibrary
    'call [ebx+32] 'FreeLibrary
  jmp rfreels
  '
  xfreels:
  '
  mov eax,[ebx+680]
  sub edi,eax
  sub edi,4
  mov [eax],edi
  xxfreels:
  ret




'COMMAND FORMAT:
'
'MID()=
'  
'=================='
midbuf: '2456
'=================='
here
  mov ecx,[esp+4]   'byref buffer ptr
  cmp ecx,0
  jz xmidbuf        'null buffer
  mov ecx,[ecx]     'deref
  cmp ecx,0
  jz xmidbuf
  mov edx,[ecx-4]   'length of buffer
  sub edx,[esp+8]   'offset
  inc edx           'space available
  mov edi,[esp+12]  'source
  cmp edi,0
  jz  xmidbuf       'nul source
  cmp edx,[edi-4]   'check length of source
  jle nmidbuf1      '
    mov edx,[edi-4] 'least qty to transfer
  nmidbuf1:
  cmp edx,0         'check if any to transfer
  jle xmidbuf
  add ecx,[esp+8]   ' add index to target
  dec ecx           ' base zero
  rmidbuf:
    mov al,[edi]
    inc edi
    mov [ecx],al
    inc ecx
    dec edx         'check n
    jg rmidbuf
  xmidbuf:
  '
  mov eax,[esp+4]
  mov ecx,[esp+12]
ret 12





'STRING(N,BYTE)


' p=AllocString(0,a)
' init1 p,a,0 ' NULLS


'=================='
stringa: '2464
'=================='
here
stringi:
  mov eax,[esp+4]  'length
  push eax         'length
  push 0           'no copy
  '
  call SysAllocStringByteLen
  'call [ebx+160] ' AllocString
  '
  mov ecx,[esp+4]  'length
  mov edx,[esp+8]  'byte fill
  push eax         'addr
    push edx       'byte fill
    push ecx       'length
    push eax       'ptr
    call init1     'fill
  pop eax ' BSTR addr
ret 8

'=================='
stringz: '2472
'=================='
here
  stringj:
  mov eax,[esp+8]
  cmp eax,0
  jz nstringz
    mov eax,[eax]
    mov [esp+8],eax
  nstringz:
jmp stringi

'=================='
strings: '2480
'=================='
here
jmp stringj

'=================='
spaces: '2488
'=================='
here
  pop eax
  pop ecx
  push 32  '+8
  push ecx '+4
  push eax
jmp stringi

'================
prints: '2496
'================
here
mov eax,[esp+4]
push eax
call [ebx+2048]
ret 4


'================
instrs2: '2504
'================
here
  pop eax
  push 1
  push eax
  jmp [ebx+320]


'GETFILE "T.TXT",F

'================
getfile2: '2512
'================
here
  mov edi,[esp+8]
  push [edi]
  call freemem 'dump existing string
  mov eax,[esp+4]
  push eax
  call getfile
  mov [edi],eax
  ret 8  
'=================='


'=================='
printv: '2520
'=================='
here
  '
  'VALUE IN FPU
  '
  call float_to_ascii 'was strs
  push eax
  push eax
  call [ebx+2048]
  call freemem
  ret
'=================='

xmrt:              '
end asm
end sub






