

  'COMPILILING WITH FREEBASIC 0.21.1
  '
  'fbc Oxygen.bas -dll -Wl -e,_DllMain
  '

  'OXYGEN
  '14:50 19/April/2008 ' start
  '05:11 23/April/2008 ' o2_View_file
  '05:46 09/June/2008  ' o2_len o2_buf o2_exec o2_asmo o2_asmo_file


  #define OS_MS
  #define freebasic 'compiling with FreeBasic / therwise Oxygen self compiling (in progress)
  '
  '
  #ifndef freebasic
    basic
  #endif



  '--------------------------------------------------------
  'IF OXYGEN IS NOT EMBEDDED INTO ANOTHER LIBRARY OR MODULE
  '========================================================
  '
  #ifndef HOSTED
    '
    #include "o2cmpl.bas" 'CORE DECLARATIONS FOR COMPILING WITH OXYGEN OR FREEBASIC
    '
    function GetvarPtr(byval VarName as string) as sys
      '
      function=0 'host variable not available
      '
    end function
    '
  #endif ' NOT HOSTED



  '--------------------
  'THE RUN TIME LIBRARY
  '====================
  '
  'functions which are referenced by the EBX register to an address table at ".bssdata"
  '
  '
  #ifdef OS_MS
    Extern "Windows-MS"
  #else
    extern "C"
  #endif
  #include "o2runt.bas" 'ALSO USED IN STANDALONE BINARIES
  end extern


  '--------------------------
  'THESE MUST BE NON EXTERNAL
  '==========================
  '
  #include "o2glob.bas"
  #include "o2keyw.bas"



  '----------------------------------
  'BUT THE REST OF THESE ARE EXTERNAL
  '==================================
  '
  #ifdef OS_MS
    Extern "Windows-MS"
  #else
    extern "C"
  #endif
  '
  '
  #include "o2lexi.bas" 'LEXICAL FUNCTIONS
  #include "O2link.bas" 'O2 MACHINE SCRIPT LINKER
  #include "o2pars.bas" 'PARSING FUNCTIONS
  #include "o2meta.bas" 'META PROGRAMMING (PREPROCESSOR)
  #include "o2assm.bas" 'ASSEMBLER (TO O2 MACHINE SCRIPT)
  #include "o2enco.bas" 'ENCODING FUNCTIONS (BASIC TO ASSEMBLER AND PE HEADERS)
  #include "o2expr.bas" 'EXPRESSION TRANSLATOR (BASIC TO ASSEMBLER)
  #include "o2decl.bas" 'DECLARATIVES TRANSLATOR
  #include "o2sema.bas" 'OXYGEN / O2BASIC SEMANTICS (TOP LEVEL)




  '==========================-
  'LIBRARY EXPORTED FUNCTIONS
  'FOR COMPILING AND EXECUTING
  '===========================


  dim shared as string dbuf(511) 'BUFFERS FOR COMPILE CODE
  dim shared as sys   lbuf       'LENGTH OF SELECTED BUFFER
  dim shared as sys   ibuf       'INDEX FOR SELECTED BUFFER
  dim shared as any ptr pbuf     'POINTER TO SELECTED BUFFER







'--------------------------------------------------
sub o2_mode alias "o2_mode" (byval m as sys) export
'==================================================
  omo=m
End Sub

'----------------------------------------------
Function o2_len alias "o2_len" () as sys export
'==============================================
  Function = lbuf
End Function

'------------------------------------------------------------
Function o2_buf alias "o2_buf" (byval p as sys) as sys export
'============================================================
'
  if (p>511)or(p<0) then
    p=0: ers=" Buffer number out of range (0..511): "+str(p): p=0
  end if
  ibuf=p
  lbuf=len(dbuf(ibuf)) : pbuf = strptr(dbuf(p))
  function=cast(long,pbuf)
End Function


'----------------------------------------------
Function o2_lib alias "o2_lib" () as sys export
'==============================================
  function=cast(long,psysfuns)
end function


'--------------------------------------------------------------
Function o2_exec alias "o2_exec" (byval p as sys) as sys export
'==============================================================
  '
  '
  'NUL PROGRAM GIVEN A SINGLE RET INSTRUCTION
  '------------------------------------------
  '
  if p=0 then
    if lbuf=0 then
      dbuf(ibuf)=chr(&hc3)
      lbuf=1
      pbuf=strptr(dbuf(ibuf))
    end if
    p=cast(long,pbuf)
  end if
  '
  asm
    mov ecx,[p]                        'ADDRESS OF CODE
    cmp dword ptr [ecx],&h00905A4D     'DOS  `MZ` SIGNATURE: `MZ` 90 00
    jnz npef                           'SKIP IF NOT PE
    add ecx,&hff0                      'MOVE o2 ENTRY POINT
    npef:                              '
    mov ebx,[psysfuns]                 'BASE ADDRESS OF RUNTIME FUNCTION TABLE
    call ecx                           'CALL CODE
    mov [function],eax                 'RETURN DATA
  end asm

'qq "ui"+cr+str(ui1)+cr+str(ui2),42
  '
End Function


'--------------------------------------------------------------
Function o2_proc alias "o2_proc" (byval n as sys) as sys export
'==============================================================
  asm
    mov ecx,[pbuf]        ' address of code
    cmp ecx,0
    jz nullprocx
    mov ebx,[psysfuns] ' address of virtual table of system functions
    mov eax,[n]
    shl eax,3 ' step of 8
    add eax,ecx
    call eax           ' call code
    mov [function],eax ' return value
    nullprocx:
  end asm
End Function


'-------------------------------------------------------
Sub o2_put alias "o2_put" (byval srcbstr as BSTR) export
'=======================================================
  '
  'itr non bstr : length?
  '
  bstr_to_fstr(srcBSTR,dbuf(ibuf))
  lbuf=len(dbuf(ibuf))
  pbuf=strptr(dbuf(ibuf))	
end sub


'----------------------------------------------
Function o2_get alias "o2_get" () as sys export
'==============================================
  '
  'itr non bstr
  '
  function=fStr_to_ostr(pbuf,lbuf)
End Function


'---------------------------------------------------------------------
Function O2_link alias "O2_link" (byval isrc as any ptr) as sys export
'=====================================================================
  '
  dim src as string
  dim as sys p,i
  src=istr_to_fstr(isrc)
  i=1
  dbuf(ibuf)=hexlink(src)
  lbuf=len(dbuf(ibuf)) : pbuf=strptr(dbuf(ibuf))
  p = fstr_to_ostr( pbuf, lbuf )
  pbuf=cast(any ptr,p)	
  Function = p
End Function

'-------------------------------------------------
function o2_compile(byref src as string) as string
'=================================================
  dim as sys le
  dim as string s
  s=translate(src)
  '
  le=len(s)
  '
  if vew=3 then
    if vwb then
      if vwe=0 then vwe=le+1 else vwe=instr(s,"#endv"+cr)+7
      vwb=instr(s,"#view"+cr)
      function=mid(s,vwb,vwe-vwb)
    else
      function=s
    end if
    exit function
  end if
  '
  if ert=0 then 
    function=assemble(s)
  else
    if vew=3 then
      function="Preprocessor error:"+cr+ers+cr+s+cr
    else
      function="c3"
    end if
  end if
end function


'-------------------------------------------------
sub o2_a(byref src as string, byref sco as string)
'=================================================
  dim as sys le
  dim as string s
  '
  ert=0 : ers="" : vwb=0 : vwe=0
  '
  sco=o2_compile(src)

  if vew then
    vew=0 : exit sub
  end if
  '
  if ert=0 then
    dbuf(ibuf)=HexLink(sco)
  else
    dbuf(ibuf)=chr(&hc3)
    'vew=3 : sco=o2_compile(src) 'trace error : vew=0
  end if
  '
  lbuf=len(dbuf(ibuf)) : pbuf=strptr(dbuf(ibuf))
  '
  'FILING AN EXE OR DLL
  '--------------------
  '
  if ert=0 then if pef then makePE(pexn,dbuf(ibuf))

End Sub


'------------------------------------------------
sub o2_f(byref fs as string, byref sco as string)
'================================================
  dim as sys fi
  dim as string src
  fi=freefile : open fs for binary access read as fi : src=space(lof(fi)) : get #fi,,src : close fi
  o2_a(src,sco)
End Sub


'--------------------------------------------------------------
function o2 alias "o2" (byval src as zstring ptr) as sys export
'==============================================================
  static as string sco
  o2_a(*src,sco) : function=cast(long,strptr(sco))
End Function


'---------------------------------------------------------
sub o2_asmo alias "o2_asmo" (byval isrc as any ptr) export
'=========================================================
  '
  dim as string  src,sco
  src=istr_to_fstr(isrc) : o2_a(src,sco)
End Sub


'-----------------------------------------------------------
sub o2_basic alias "o2_basic" (byval isrc as any ptr) export
'===========================================================
  '
  o2h=1 : o2_asmo(isrc)
End Sub


'-----------------------------------------------------------------------------
Function o2_assemble alias "o2_assemble" (byval isrc as any ptr) as sys export
'=============================================================================
  '
  o2_asmo(isrc)
  function = fstr_to_ostr( pbuf, lbuf )
End Function


'-------------------------------------------------------------------
sub o2_asmo_file alias "o2_asmo_file" (byval isrc as any ptr) export
'===================================================================
  '
  dim as string  fs,sco
  fs=istr_to_fstr(isrc)
  o2_f(fs,sco)
end sub


'---------------------------------------------------------------------------------------
Function O2_assemble_file alias "o2_assemble_file" (byval isrc as any ptr) as sys export
'=======================================================================================
  '
  o2_asmo_file(isrc)
  function = fstr_to_ostr( pbuf, lbuf )
End Function


'-------------------------------------------
Function O2_Vp(byval isrc as any ptr) as sys
'===========================================
  '
  dim codBSTR As BSTR '---OLE string
  dim as string src
  static as string  sco
  src=istr_to_fstr(isrc)
  o2_a(src,sco)
  function = fstr_to_ostr( strptr(sco),len(sco))	
End Function


'---------------------------------------------------------------------
Function o2_view alias "o2_view" (byval isrc as any ptr) as sys export
'=====================================================================
  vew=2 : function=O2_Vp(isrc)
End Function


'---------------------------------------------------------------------
Function o2_prep alias "o2_prep" (byval isrc as any ptr) as sys export
'=====================================================================
  vew=3 : function=O2_Vp(isrc)
End Function


'-------------------------------------------------------------------------------
Function O2_view_file alias "O2_view_file" (byval isrc as any ptr) as sys export
'===============================================================================
  '
  dim as string  fs
  static as string sco
  fs=istr_to_fstr(isrc) : vew=2 : o2_f(fs,sco)
  function = fstr_to_ostr( strptr(sco), len(sco))
End Function


'--------------------------------------------------
Function o2_errno alias "o2_errno" () as sys export
'==================================================
  '
  function = ert
  '	
End Function


'--------------------------------------------------
Function o2_error alias "o2_error" () as sys export
'==================================================
  '
  function = fstr_to_ostr( strptr(ers), Len(ers) )
  '	
End Function







'==============================================================
'THE COMPILE FUNCTIONS ARE NOT AVAILABLE IN STANDALONE BINARIES
'==============================================================



'--------------------------------------------------------------
function compile(byval srcBSTR as BSTR, byval dp as sys) as sys
'==============================================================
  '
  dim as string  src,sco,cod,s
  dim as any ptr p
  dim as sys    ert,a
  src+=cr
  bstr_to_fstr(srcBSTR,src)
  dep=1
  a=o2h : o2h=1
  s=sp+mess+src+ep
  sco=o2_compile(s) 'PARENTAL STATE BUT RESTRICTED SCOPE
  o2h=a
  '
  if vew=0 then
    '
    'prefix length of const dataspace used: (mov eax,[dati])
    'this will be deducted when the code is uncompiled
    '
    cod=chr$(&hb8)+mkl(dati)+HexLink(sco)
  else
    cod=sco
  end if
  vew=0
  dep=0
  '
  'TRANSFER CONST DATA TO UNINITIALISED DATA SECTION
  '
  p=strptr(dats)
  asm
  mov edi,[dp] '.bssdata address (in ebx)
  mov edx,[p]  'data string
  add edi,[aoffs] 'boundary if data dest
  mov ecx,[dati]
  add edx,ecx 'boundary of data src
  '
  'byte copy backwards
  '
  cmp ecx,0
  jle xcmpdt
  rcmpdt:
    dec edi
    dec edx
    mov al,[edx]
    mov [edi],al
    dec ecx
    jg rcmpdt
  xcmpdt:
  end asm
  function = cast (long, AllocString(strptr(cod), len(cod) ) )
end function




'----------------------------------------
sub uncompile(byval cod as BSTR)
'========================================
  asm
    mov edx,[cod]
    mov al,[edx]
    cmp al,&hb8
    jnz nuncmp
    mov eax,[edx+1]
    sub [aoffs],eax
    nuncmp:
    push edx
    call SysFreeString
  end asm
end sub


'------------------
sub sysfuns_build()
'==================

'This procedure is called from DLLmain when Oxygen is loaded.
'It builds an address table and storage area for the runtime library.
'This table is copied into bssdata area for each compiled binary as part
'of the compiled binary's setup when it is called.

'In independent mode the entire build process must be handled by the Executable
'which contains all the run-time functions required.



  'REGISTER PARAM MACROS FOR MS64
  '------------------------------

  rgp(0)="mov rax,"
  rgp(1)="mov rcx,"
  rgp(2)="mov rdx,"
  rgp(3)="mov r8,"
  rgp(4)="mov r9,"
  rgp(8)="movups xmm0,"
  rgp(9)="movups xmm1,"
  rgp(10)="movups xmm2,"
  rgp(11)="movups xmm3,"




psysfuns=@sysfuns(0)


#ifdef freebasic

'===============================================
'O2
'===============================================
   'sysfuns(00)=NextAvailable          '000
    sysfuns(02)=@getmem                '008 'NEWS
    sysfuns(04)=@freemem               '016 'FREES
    sysfuns(06)=@LoadLibrary           '024 'LOADLIBRARY
    sysfuns(08)=@FreeLibrary           '032 'FREELIBRARY
    sysfuns(10)=@GetProcAddress        '040 'GETPROCADDRESS
    sysfuns(12)=@procaddrs             '048 'BIND (indirectly)
    sysfuns(14)=@copy0                 '056 'COPY0
    sysfuns(16)=@copy00                '064 'COPY00
    sysfuns(18)=@copyn                 '072 'COPY COPYN
    sysfuns(20)=@getvarptr             '080 'O2 GET HOST VAR ADDRESS
   'sysfuns(22)=@strd                  '088 'obsolete
   'sysfuns(24)=@vald                  '096 'obsolete
'===============================================

'UNUSED 104 112 120


'===============================================
'O2H
'===============================================
    sysfuns(32)=@errors                '128
    sysfuns(40)=@SysAllocStringByteLen '160  **
    sysfuns(42)=@SysFreestring         '168  **
    sysfuns(48)=@ascii_to_float        '192 replace @vals
    sysfuns(50)=@float_to_ascii        '200 replace @strs
    sysfuns(52)=@hexs                  '208
    sysfuns(80)=@instrsh               '320
    sysfuns(82)=@replaces              '328
    sysfuns(84)=@getfile               '336
    sysfuns(86)=@putfile               '344
    sysfuns(88)=@guidval               '352
    sysfuns(90)=@guidtxt               '360
    sysfuns(92)=@compile               '368
    sysfuns(94)=@uncompile             '376
'===============================================

'UNUSED 136 144 152 
'UNUSED 176 184
'UNUSED 216 232 240 248 256 264 272 280 288 296 304 312
'UNUSED 384 392

'NOTE:
'** these must be preloaded for the import table in in dependent mode

'first 400 bytes will be copied to bss


#endif 'freebasic




'the following locations are used in independent mode

'===============================================
'RESERVED LOCATIONS FOR OS CALLS
'===============================================
   'sysfuns(110)=GetModuleHandle       '440  **
   'sysfuns(112)=GetCommandLine        '448  **
   'sysfuns(114)=GetExitCodeProcess    '456  **
   'sysfuns(116)=ExitProcess           '464  **
   'sysfuns(118)=MessageBoxA           '472  **
   'sysfuns(120)=CreateFileA           '480  **
   'sysfuns(122)=ReadFile              '488  **
   'sysfuns(124)=CloseHandle           '496  **
'===============================================
'NOTE:
'** these must be preloaded for the import table in in dependent mode


'the following locations are available in all modes
'but primarily used in oxygen dependent mode.
'They are initialised in the Basic prolog.

'===============================================
'RESERVED LOCATIONS FOR HANDLES
'===============================================
   '             bootstrap lib base    '600  **
   '             process handle        '608  ** 0
   '             oxygen lib handle     '616  ** 0
   '             OxygenLibBaseEBX      '624  **
   '             StaticMemBaseESI      '632  **
'===============================================


'the following locations are used in all modes

'===============================================
'RESERVED LOCATIONS FOR BUFFER POINTERS etc
'===============================================
   'STRING CAT LIST                    '640
   'STRING TEMPS                       '648
   'STRING LOCALS                      '656
   'STRING GLOBALS                     '664
   '---------------------------------------
   'DLL BINDING DATA POINTER           '672
   'DLL HANDLE LIST                    '680
   'STRING POOL                        '688
'===============================================




'STRING POOL RECORD / HELD IN BSTRING
'===============================================
   'STRING LBOUND                      '0O
   'STRING NEXT AVAIL                  '04
   'STRING ALLOCATION UNIT SIZE        '08
   'STRING STACK POINTER               '12
   '
'===============================================





'------------------------
 ' add naked procs &h400+
'========================
    asm
      mov ecx,2048 ' 512.. 
      add ecx,[psysfuns]
      call mapruntimes
      mov eax,[psysfuns]
      sub ecx,eax
      mov [eax],ecx ' next available place in table
    end asm
'=================================

'when combirs=1:
'2048-4095 bytes will be copied to bss+2048 to bss+4095

end sub



'for FB 0.20 and above



'---------------------
sub ctor() constructor
'=====================
    '
    'SETTINGS ON ENTRY
    '-----------------
    '
    'STRING AND CHARACTER MODE
    '
    #ifdef OS_MS
      omo=8 'BSTR 8bit character (+2=16 BIT character)  
    #else
      omo=0
    #endif
    '
    'BUILD RUNTIME TABLE (functions for runtime use)
    '
    sysfuns_build()
    '
    'NUMBER FORMAT CONTROL
    '
    num.dp =16 ' DECIMAL PLACES
    num.trz= 1 ' STRIP TRAILING ZEROS
    num.sn = 0 ' SCIENTIFIC NOTATION BY DEFAULT
    num.sdp= 0 ' INHIBIT ZERO BEFORE DECIMAL POINT
    '
end sub


''--------------------
'sub dtor() destructor
''====================
'    'print "process detach"
'end sub



#if 0

'------------------------------------------------------------------------
function DllMain alias "DllMain" ( _
BYVAL hInstance as sys,BYVAL Reason    as sys,BYVAL Reserved  as sys _
) as sys export
'========================================================================
  'gNumOfTimes+=1
  '
  'DEFAULT STRING PTR TYPE
  '
  '
  select case Reason
  '
  case DLL_PROCESS_ATTACH
    '
    'messagebox 0,"process attach","",0
    'DisableThreadLibraryCalls(hInstance)
    '
    'SETTINGS ON ENTRY
    '-----------------
    '
    'STRING AND CHARACTER MODE
    '
    #ifdef OS_MS
      omo=8 'BSTR 8bit character (+2=16 BIT character)  
    #else
      omo=0
    #endif
    '
    'BUILD RUNTIME TABLE (functions for runtime use)
    '
    sysfuns_build()
    '
    'NUMBER FORMAT CONTROL
    '
    num.dp =16 ' DECIMAL PLACES
    num.trz= 1 ' STRIP TRAILING ZEROS
    num.sn = 0 ' SCIENTIFIC NOTATION BY DEFAULT
    num.sdp= 0 ' INHIBIT ZERO BEFORE DECIMAL POINT
    '
    function = 1 : exit function
    '
  case DLL_PROCESS_DETACH
    'messagebox 0,"process detach","",1
    function=1 : exit function
  case DLL_THREAD_ATTACH
    'messagebox 0,"thread attach","",1
    exit function
  case DLL_THREAD_DETACH
    'messagebox 0,"thread detach","",1
    exit function
    '
  end select
  '
  Messagebox 0, "Windows Error in DllMain()","O2",0
  '
  end function

#endif 'original dllmain


End Extern
